/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The checking result of server name availibility.
 *
 */
class CheckServerNameAvailabilityResult {
  /**
   * Create a CheckServerNameAvailabilityResult.
   * @member {boolean} [nameAvailable] Indicator of available of the server
   * name.
   * @member {string} [reason] The reason of unavailability.
   * @member {string} [message] The detailed message of the request
   * unavailability.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CheckServerNameAvailabilityResult
   *
   * @returns {object} metadata of CheckServerNameAvailabilityResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CheckServerNameAvailabilityResult',
      type: {
        name: 'Composite',
        className: 'CheckServerNameAvailabilityResult',
        modelProperties: {
          nameAvailable: {
            required: false,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CheckServerNameAvailabilityResult;
