/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters supplied to the UpdateHostname operation.
 *
 */
class ApiManagementServiceUpdateHostnameParameters {
  /**
   * Create a ApiManagementServiceUpdateHostnameParameters.
   * @member {array} [update] Hostnames to create or update.
   * @member {array} [deleteProperty] Hostnames types to delete.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiManagementServiceUpdateHostnameParameters
   *
   * @returns {object} metadata of ApiManagementServiceUpdateHostnameParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiManagementServiceUpdateHostnameParameters',
      type: {
        name: 'Composite',
        className: 'ApiManagementServiceUpdateHostnameParameters',
        modelProperties: {
          update: {
            required: false,
            serializedName: 'update',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HostnameConfigurationOldElementType',
                  type: {
                    name: 'Composite',
                    className: 'HostnameConfigurationOld'
                  }
              }
            }
          },
          deleteProperty: {
            required: false,
            serializedName: 'delete',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HostnameTypeElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Proxy', 'Portal', 'Management', 'Scm' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApiManagementServiceUpdateHostnameParameters;
