/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Issue Contract details.
 *
 * @extends models['Resource']
 */
class IssueContract extends models['Resource'] {
  /**
   * Create a IssueContract.
   * @property {date} [createdDate] Date and time when the issue was created.
   * @property {string} [state] Status of the issue. Possible values include:
   * 'proposed', 'open', 'removed', 'resolved', 'closed'
   * @property {string} [apiId] A resource identifier for the API the issue was
   * created for.
   * @property {string} title The issue title.
   * @property {string} description Text describing the issue.
   * @property {string} userId A resource identifier for the user created the
   * issue.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IssueContract
   *
   * @returns {object} metadata of IssueContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IssueContract',
      type: {
        name: 'Composite',
        className: 'IssueContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          createdDate: {
            required: false,
            serializedName: 'properties.createdDate',
            type: {
              name: 'DateTime'
            }
          },
          state: {
            required: false,
            serializedName: 'properties.state',
            type: {
              name: 'String'
            }
          },
          apiId: {
            required: false,
            serializedName: 'properties.apiId',
            type: {
              name: 'String'
            }
          },
          title: {
            required: true,
            serializedName: 'properties.title',
            type: {
              name: 'String'
            }
          },
          description: {
            required: true,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          userId: {
            required: true,
            serializedName: 'properties.userId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IssueContract;
