/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * API OAuth2 Authentication settings details.
 *
 */
class OpenIdAuthenticationSettingsContract {
  /**
   * Create a OpenIdAuthenticationSettingsContract.
   * @property {string} [openidProviderId] OAuth authorization server
   * identifier.
   * @property {array} [bearerTokenSendingMethods] How to send token to the
   * server.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OpenIdAuthenticationSettingsContract
   *
   * @returns {object} metadata of OpenIdAuthenticationSettingsContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OpenIdAuthenticationSettingsContract',
      type: {
        name: 'Composite',
        className: 'OpenIdAuthenticationSettingsContract',
        modelProperties: {
          openidProviderId: {
            required: false,
            serializedName: 'openidProviderId',
            type: {
              name: 'String'
            }
          },
          bearerTokenSendingMethods: {
            required: false,
            serializedName: 'bearerTokenSendingMethods',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BearerTokenSendingMethodsElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OpenIdAuthenticationSettingsContract;
