/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Exception details
 *
 */
class EventsExceptionDetail {
  /**
   * Create a EventsExceptionDetail.
   * @member {string} [severityLevel] The severity level of the exception
   * detail
   * @member {string} [outerId] The outer ID of the exception detail
   * @member {string} [message] The message of the exception detail
   * @member {string} [type] The type of the exception detail
   * @member {string} [id] The ID of the exception detail
   * @member {array} [parsedStack] The parsed stack
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsExceptionDetail
   *
   * @returns {object} metadata of EventsExceptionDetail
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsExceptionDetail',
      type: {
        name: 'Composite',
        className: 'EventsExceptionDetail',
        modelProperties: {
          severityLevel: {
            required: false,
            serializedName: 'severityLevel',
            type: {
              name: 'String'
            }
          },
          outerId: {
            required: false,
            serializedName: 'outerId',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          parsedStack: {
            required: false,
            serializedName: 'parsedStack',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EventsExceptionDetailsParsedStackElementType',
                  type: {
                    name: 'Composite',
                    className: 'EventsExceptionDetailsParsedStack'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EventsExceptionDetail;
