/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A performance counter result
 *
 * @extends models['EventsResultData']
 */
class EventsPerformanceCounterResult extends models['EventsResultData'] {
  /**
   * Create a EventsPerformanceCounterResult.
   * @member {object} [performanceCounter]
   * @member {number} [performanceCounter.value] The value of the performance
   * counter
   * @member {string} [performanceCounter.name] The name of the performance
   * counter
   * @member {string} [performanceCounter.category] The category of the
   * performance counter
   * @member {string} [performanceCounter.counter] The counter of the
   * performance counter
   * @member {string} [performanceCounter.instanceName] The instance name of
   * the performance counter
   * @member {string} [performanceCounter.instance] The instance of the
   * performance counter
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventsPerformanceCounterResult
   *
   * @returns {object} metadata of EventsPerformanceCounterResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'performanceCounter',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'EventsResultData',
        className: 'EventsPerformanceCounterResult',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          count: {
            required: false,
            serializedName: 'count',
            type: {
              name: 'Number'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          customDimensions: {
            required: false,
            serializedName: 'customDimensions',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomDimensions'
            }
          },
          customMeasurements: {
            required: false,
            serializedName: 'customMeasurements',
            type: {
              name: 'Composite',
              className: 'EventsResultDataCustomMeasurements'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'Composite',
              className: 'EventsOperationInfo'
            }
          },
          session: {
            required: false,
            serializedName: 'session',
            type: {
              name: 'Composite',
              className: 'EventsSessionInfo'
            }
          },
          user: {
            required: false,
            serializedName: 'user',
            type: {
              name: 'Composite',
              className: 'EventsUserInfo'
            }
          },
          cloud: {
            required: false,
            serializedName: 'cloud',
            type: {
              name: 'Composite',
              className: 'EventsCloudInfo'
            }
          },
          ai: {
            required: false,
            serializedName: 'ai',
            type: {
              name: 'Composite',
              className: 'EventsAiInfo'
            }
          },
          application: {
            required: false,
            serializedName: 'application',
            type: {
              name: 'Composite',
              className: 'EventsApplicationInfo'
            }
          },
          client: {
            required: false,
            serializedName: 'client',
            type: {
              name: 'Composite',
              className: 'EventsClientInfo'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          performanceCounter: {
            required: false,
            serializedName: 'performanceCounter',
            type: {
              name: 'Composite',
              className: 'EventsPerformanceCounterInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsPerformanceCounterResult;
