/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The request info
 *
 */
class EventsRequestInfo {
  /**
   * Create a EventsRequestInfo.
   * @member {string} [name] The name of the request
   * @member {string} [url] The URL of the request
   * @member {string} [success] Indicates if the request was successful
   * @member {number} [duration] The duration of the request
   * @member {string} [performanceBucket] The performance bucket of the request
   * @member {string} [resultCode] The result code of the request
   * @member {string} [source] The source of the request
   * @member {string} [id] The ID of the request
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsRequestInfo
   *
   * @returns {object} metadata of EventsRequestInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsRequestInfo',
      type: {
        name: 'Composite',
        className: 'EventsRequestInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          success: {
            required: false,
            serializedName: 'success',
            type: {
              name: 'String'
            }
          },
          duration: {
            required: false,
            serializedName: 'duration',
            type: {
              name: 'Number'
            }
          },
          performanceBucket: {
            required: false,
            serializedName: 'performanceBucket',
            type: {
              name: 'String'
            }
          },
          resultCode: {
            required: false,
            serializedName: 'resultCode',
            type: {
              name: 'String'
            }
          },
          source: {
            required: false,
            serializedName: 'source',
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsRequestInfo;
