/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An Application Insights component API Key createion request definition.
 *
 */
class APIKeyRequest {
  /**
   * Create a APIKeyRequest.
   * @member {string} [name] The name of the API Key.
   * @member {array} [linkedReadProperties] The read access rights of this API
   * Key.
   * @member {array} [linkedWriteProperties] The write access rights of this
   * API Key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of APIKeyRequest
   *
   * @returns {object} metadata of APIKeyRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'APIKeyRequest',
      type: {
        name: 'Composite',
        className: 'APIKeyRequest',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          linkedReadProperties: {
            required: false,
            serializedName: 'linkedReadProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          linkedWriteProperties: {
            required: false,
            serializedName: 'linkedWriteProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = APIKeyRequest;
