/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An Application Insights component billing features
 *
 */
class ApplicationInsightsComponentBillingFeatures {
  /**
   * Create a ApplicationInsightsComponentBillingFeatures.
   * @member {object} [dataVolumeCap] An Application Insights component daily
   * data volumne cap
   * @member {number} [dataVolumeCap.cap] Daily data volume cap in GB.
   * @member {number} [dataVolumeCap.resetTime] Daily data volume cap UTC reset
   * hour.
   * @member {number} [dataVolumeCap.warningThreshold] Reserved, not used for
   * now.
   * @member {boolean} [dataVolumeCap.stopSendNotificationWhenHitThreshold]
   * Reserved, not used for now.
   * @member {boolean} [dataVolumeCap.stopSendNotificationWhenHitCap] Do not
   * send a notification email when the daily data volume cap is met.
   * @member {number} [dataVolumeCap.maxHistoryCap] Maximum daily data volume
   * cap that the user can set for this component.
   * @member {array} [currentBillingFeatures] Current enabled pricing plan.
   * When the component is in the Enterprise plan, this will list both 'Basic'
   * and 'Application Insights Enterprise'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationInsightsComponentBillingFeatures
   *
   * @returns {object} metadata of ApplicationInsightsComponentBillingFeatures
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationInsightsComponentBillingFeatures',
      type: {
        name: 'Composite',
        className: 'ApplicationInsightsComponentBillingFeatures',
        modelProperties: {
          dataVolumeCap: {
            required: false,
            serializedName: 'DataVolumeCap',
            type: {
              name: 'Composite',
              className: 'ApplicationInsightsComponentDataVolumeCap'
            }
          },
          currentBillingFeatures: {
            required: false,
            serializedName: 'CurrentBillingFeatures',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationInsightsComponentBillingFeatures;
