/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Deny assignment principal.
 *
 */
class Principal {
  /**
   * Create a Principal.
   * @property {string} [id] Object ID of the Azure AD principal (user, group,
   * or service principal) to which the deny assignment applies. An empty guid
   * '00000000-0000-0000-0000-000000000000' as principal id and principal type
   * as 'Everyone' represents all users, groups and service principals.
   * @property {string} [type] Type of object represented by principal id
   * (user, group, or service principal). An empty guid
   * '00000000-0000-0000-0000-000000000000' as principal id and principal type
   * as 'Everyone' represents all users, groups and service principals.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Principal
   *
   * @returns {object} metadata of Principal
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Principal',
      type: {
        name: 'Composite',
        className: 'Principal',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Principal;
