/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a SourceControlSecurityTokenProperties.
 */
class SourceControlSecurityTokenProperties {
  /**
   * Create a SourceControlSecurityTokenProperties.
   * @member {string} [accessToken] The access token.
   * @member {string} [refreshToken] The refresh token.
   * @member {string} [tokenType] The token type. Must be either
   * PersonalAccessToken or Oauth. Possible values include:
   * 'PersonalAccessToken', 'Oauth'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceControlSecurityTokenProperties
   *
   * @returns {object} metadata of SourceControlSecurityTokenProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceControlSecurityTokenProperties',
      type: {
        name: 'Composite',
        className: 'SourceControlSecurityTokenProperties',
        modelProperties: {
          accessToken: {
            required: false,
            serializedName: 'accessToken',
            constraints: {
              MaxLength: 1024
            },
            type: {
              name: 'String'
            }
          },
          refreshToken: {
            required: false,
            serializedName: 'refreshToken',
            constraints: {
              MaxLength: 1024
            },
            type: {
              name: 'String'
            }
          },
          tokenType: {
            required: false,
            serializedName: 'tokenType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceControlSecurityTokenProperties;
