/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters supplied to the create source control sync job operation.
 *
 */
class SourceControlSyncJobCreateParameters {
  /**
   * Create a SourceControlSyncJobCreateParameters.
   * @member {string} commitId The commit id of the source control sync job. If
   * not syncing to a commitId, enter an empty string.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceControlSyncJobCreateParameters
   *
   * @returns {object} metadata of SourceControlSyncJobCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceControlSyncJobCreateParameters',
      type: {
        name: 'Composite',
        className: 'SourceControlSyncJobCreateParameters',
        modelProperties: {
          commitId: {
            required: true,
            serializedName: 'properties.commitId',
            constraints: {
              MinLength: 0
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceControlSyncJobCreateParameters;
