/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the source control sync job stream.
 *
 */
class SourceControlSyncJobStream {
  /**
   * Create a SourceControlSyncJobStream.
   * @member {string} [id] Resource id.
   * @member {string} [sourceControlSyncJobStreamId] The sync job stream id.
   * @member {string} [summary] The summary of the sync job stream.
   * @member {date} [time] The time of the sync job stream.
   * @member {string} [streamType] The type of the sync job stream. Possible
   * values include: 'Error', 'Output'
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceControlSyncJobStream
   *
   * @returns {object} metadata of SourceControlSyncJobStream
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceControlSyncJobStream',
      type: {
        name: 'Composite',
        className: 'SourceControlSyncJobStream',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          sourceControlSyncJobStreamId: {
            required: false,
            serializedName: 'properties.sourceControlSyncJobStreamId',
            type: {
              name: 'String'
            }
          },
          summary: {
            required: false,
            serializedName: 'properties.summary',
            type: {
              name: 'String'
            }
          },
          time: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'properties.time',
            type: {
              name: 'DateTime'
            }
          },
          streamType: {
            required: false,
            serializedName: 'properties.streamType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceControlSyncJobStream;
