/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Definition of the source control sync job stream by id.
 *
 */
class SourceControlSyncJobStreamById {
  /**
   * Create a SourceControlSyncJobStreamById.
   * @member {string} [id] Resource id.
   * @member {string} [sourceControlSyncJobStreamId] The sync job stream id.
   * @member {string} [summary] The summary of the sync job stream.
   * @member {date} [time] The time of the sync job stream.
   * @member {string} [streamType] The type of the sync job stream. Possible
   * values include: 'Error', 'Output'
   * @member {string} [streamText] The text of the sync job stream.
   * @member {object} [value] The values of the job stream.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceControlSyncJobStreamById
   *
   * @returns {object} metadata of SourceControlSyncJobStreamById
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceControlSyncJobStreamById',
      type: {
        name: 'Composite',
        className: 'SourceControlSyncJobStreamById',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          sourceControlSyncJobStreamId: {
            required: false,
            serializedName: 'properties.sourceControlSyncJobStreamId',
            type: {
              name: 'String'
            }
          },
          summary: {
            required: false,
            serializedName: 'properties.summary',
            type: {
              name: 'String'
            }
          },
          time: {
            required: false,
            nullable: true,
            readOnly: true,
            serializedName: 'properties.time',
            type: {
              name: 'DateTime'
            }
          },
          streamType: {
            required: false,
            serializedName: 'properties.streamType',
            type: {
              name: 'String'
            }
          },
          streamText: {
            required: false,
            serializedName: 'properties.streamText',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'properties.value',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SourceControlSyncJobStreamById;
