/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Information about a file or directory on a Compute Node.
  *
 */
class NodeFile {
  /**
   * Create a NodeFile.
   * @property {string} [name] The file path.
   * @property {string} [url] The URL of the file.
   * @property {boolean} [isDirectory] Whether the object represents a
   * directory.
   * @property {object} [properties] The file properties.
   * @property {date} [properties.creationTime] The creation time is not
   * returned for files on Linux Compute Nodes.
   * @property {date} [properties.lastModified]
   * @property {number} [properties.contentLength]
   * @property {string} [properties.contentType]
   * @property {string} [properties.fileMode] The file mode is returned only
   * for files on Linux Compute Nodes.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeFile
   *
   * @returns {object} metadata of NodeFile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeFile',
      type: {
        name: 'Composite',
        className: 'NodeFile',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          isDirectory: {
            required: false,
            serializedName: 'isDirectory',
            type: {
              name: 'Boolean'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'FileProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeFile;
