/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Options for reimaging a Compute Node.
  *
 */
class NodeReimageParameter {
  /**
   * Create a NodeReimageParameter.
   * @property {string} [nodeReimageOption] When to reimage the Compute Node
   * and what to do with currently running Tasks. The default value is requeue.
   * Possible values include: 'requeue', 'terminate', 'taskCompletion',
   * 'retainedData'
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeReimageParameter
   *
   * @returns {object} metadata of NodeReimageParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeReimageParameter',
      type: {
        name: 'Composite',
        className: 'NodeReimageParameter',
        modelProperties: {
          nodeReimageOption: {
            required: false,
            serializedName: 'nodeReimageOption',
            type: {
              name: 'Enum',
              allowedValues: [ 'requeue', 'terminate', 'taskCompletion', 'retainedData' ]
            }
          }
        }
      }
    };
  }
}

module.exports = NodeReimageParameter;
