/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Cluster update parameters.
 *
 */
class ClusterUpdateParameters {
  /**
   * Create a ClusterUpdateParameters.
   * @member {object} [scaleSettings] Scale settings. Desired scale settings
   * for the cluster. Batch AI service supports manual and auto scale clusters.
   * @member {object} [scaleSettings.manual] Manual scale settings for the
   * cluster.
   * @member {number} [scaleSettings.manual.targetNodeCount] The desired number
   * of compute nodes in the Cluster. Default is 0.
   * @member {string} [scaleSettings.manual.nodeDeallocationOption] An action
   * to be performed when the cluster size is decreasing. The default value is
   * requeue. Possible values include: 'requeue', 'terminate',
   * 'waitforjobcompletion'
   * @member {object} [scaleSettings.autoScale] Auto-scale settings for the
   * cluster.
   * @member {number} [scaleSettings.autoScale.minimumNodeCount] The minimum
   * number of compute nodes the Batch AI service will try to allocate for the
   * cluster. Note, the actual number of nodes can be less than the specified
   * value if the subscription has not enough quota to fulfill the request.
   * @member {number} [scaleSettings.autoScale.maximumNodeCount] The maximum
   * number of compute nodes the cluster can have.
   * @member {number} [scaleSettings.autoScale.initialNodeCount] The number of
   * compute nodes to allocate on cluster creation. Note that this value is
   * used only during cluster creation. Default: 0.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterUpdateParameters
   *
   * @returns {object} metadata of ClusterUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterUpdateParameters',
      type: {
        name: 'Composite',
        className: 'ClusterUpdateParameters',
        modelProperties: {
          scaleSettings: {
            required: false,
            serializedName: 'properties.scaleSettings',
            type: {
              name: 'Composite',
              className: 'ScaleSettings'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterUpdateParameters;
