/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Login details to SSH to a compute node in cluster.
 *
 */
class RemoteLoginInformation {
  /**
   * Create a RemoteLoginInformation.
   * @member {string} [nodeId] Node ID. ID of the compute node.
   * @member {string} [ipAddress] IP address. Public IP address of the compute
   * node.
   * @member {number} [port] Port. SSH port number of the node.
   */
  constructor() {
  }

  /**
   * Defines the metadata of RemoteLoginInformation
   *
   * @returns {object} metadata of RemoteLoginInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RemoteLoginInformation',
      type: {
        name: 'Composite',
        className: 'RemoteLoginInformation',
        modelProperties: {
          nodeId: {
            required: false,
            readOnly: true,
            serializedName: 'nodeId',
            type: {
              name: 'String'
            }
          },
          ipAddress: {
            required: false,
            readOnly: true,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          port: {
            required: false,
            readOnly: true,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = RemoteLoginInformation;
