/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema items of the body.
 *
 */
class CreateVideoReviewsBodyItem {
  /**
   * Create a CreateVideoReviewsBodyItem.
   * @property {array} [videoFrames] Optional metadata details.
   * @property {array} [metadata] Optional metadata details.
   * @property {string} content Video content url to review.
   * @property {string} contentId Content Identifier.
   * @property {string} status Status of the
   * video(Complete,Unpublished,Pending). Possible values include: 'Complete',
   * 'Unpublished', 'Pending'
   * @property {number} [timescale] Timescale of the video.
   * @property {string} [callbackEndpoint] Optional CallbackEndpoint.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateVideoReviewsBodyItem
   *
   * @returns {object} metadata of CreateVideoReviewsBodyItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateVideoReviewsBodyItem',
      type: {
        name: 'Composite',
        className: 'CreateVideoReviewsBodyItem',
        modelProperties: {
          videoFrames: {
            required: false,
            serializedName: 'VideoFrames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CreateVideoReviewsBodyItemVideoFramesItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CreateVideoReviewsBodyItemVideoFramesItem'
                  }
              }
            }
          },
          metadata: {
            required: false,
            serializedName: 'Metadata',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'CreateVideoReviewsBodyItemMetadataItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'CreateVideoReviewsBodyItemMetadataItem'
                  }
              }
            }
          },
          type: {
            required: true,
            isConstant: true,
            serializedName: 'Type',
            defaultValue: 'Video',
            type: {
              name: 'String'
            }
          },
          content: {
            required: true,
            serializedName: 'Content',
            type: {
              name: 'String'
            }
          },
          contentId: {
            required: true,
            serializedName: 'ContentId',
            type: {
              name: 'String'
            }
          },
          status: {
            required: true,
            serializedName: 'Status',
            type: {
              name: 'String'
            }
          },
          timescale: {
            required: false,
            serializedName: 'Timescale',
            type: {
              name: 'Number'
            }
          },
          callbackEndpoint: {
            required: false,
            serializedName: 'CallbackEndpoint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateVideoReviewsBodyItem;
