/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Video frame property details.
 *
 */
class Frame {
  /**
   * Create a Frame.
   * @property {string} [timestamp] Timestamp of the frame.
   * @property {string} [frameImage] Frame image.
   * @property {array} [metadata] Array of KeyValue.
   * @property {array} [reviewerResultTags] Reviewer result tags.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Frame
   *
   * @returns {object} metadata of Frame
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Frame',
      type: {
        name: 'Composite',
        className: 'Frame',
        modelProperties: {
          timestamp: {
            required: false,
            serializedName: 'Timestamp',
            type: {
              name: 'String'
            }
          },
          frameImage: {
            required: false,
            serializedName: 'FrameImage',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'Metadata',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'KeyValuePairElementType',
                  type: {
                    name: 'Composite',
                    className: 'KeyValuePair'
                  }
              }
            }
          },
          reviewerResultTags: {
            required: false,
            serializedName: 'ReviewerResultTags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TagElementType',
                  type: {
                    name: 'Composite',
                    className: 'Tag'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Frame;
