/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Image List Properties.
 *
 */
class ImageList {
  /**
   * Create a ImageList.
   * @property {number} [id] Image List Id.
   * @property {string} [name] Image List Name.
   * @property {string} [description] Description for image list.
   * @property {object} [metadata] Image List Metadata.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageList
   *
   * @returns {object} metadata of ImageList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageList',
      type: {
        name: 'Composite',
        className: 'ImageList',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'Id',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'Description',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'Metadata',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageList;
