/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties describing present makeups on a given face.
 *
 */
class Makeup {
  /**
   * Create a Makeup.
   * @property {boolean} [eyeMakeup] A boolean value describing whether eye
   * makeup is present on a face.
   * @property {boolean} [lipMakeup] A boolean value describing whether lip
   * makeup is present on a face.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Makeup
   *
   * @returns {object} metadata of Makeup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Makeup',
      type: {
        name: 'Composite',
        className: 'Makeup',
        modelProperties: {
          eyeMakeup: {
            required: false,
            nullable: false,
            serializedName: 'eyeMakeup',
            type: {
              name: 'Boolean'
            }
          },
          lipMakeup: {
            required: false,
            nullable: false,
            serializedName: 'lipMakeup',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Makeup;
