/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response body for find similar face operation.
 *
 */
class SimilarFace {
  /**
   * Create a SimilarFace.
   * @property {uuid} [faceId] FaceId of candidate face when find by faceIds.
   * faceId is created by Face - Detect and will expire 24 hours after the
   * detection call
   * @property {uuid} [persistedFaceId] PersistedFaceId of candidate face when
   * find by faceListId. persistedFaceId in face list is persisted and will not
   * expire. As showed in below response
   * @property {number} confidence Similarity confidence of the candidate face.
   * The higher confidence, the more similar. Range between [0,1].
   */
  constructor() {
  }

  /**
   * Defines the metadata of SimilarFace
   *
   * @returns {object} metadata of SimilarFace
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SimilarFace',
      type: {
        name: 'Composite',
        className: 'SimilarFace',
        modelProperties: {
          faceId: {
            required: false,
            serializedName: 'faceId',
            type: {
              name: 'String'
            }
          },
          persistedFaceId: {
            required: false,
            serializedName: 'persistedFaceId',
            type: {
              name: 'String'
            }
          },
          confidence: {
            required: true,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SimilarFace;
