/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of the verify operation.
 *
 */
class VerifyResult {
  /**
   * Create a VerifyResult.
   * @property {boolean} isIdentical True if the two faces belong to the same
   * person or the face belongs to the person, otherwise false.
   * @property {number} confidence A number indicates the similarity confidence
   * of whether two faces belong to the same person, or whether the face
   * belongs to the person. By default, isIdentical is set to True if
   * similarity confidence is greater than or equal to 0.5. This is useful for
   * advanced users to override "isIdentical" and fine-tune the result on their
   * own data.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VerifyResult
   *
   * @returns {object} metadata of VerifyResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VerifyResult',
      type: {
        name: 'Composite',
        className: 'VerifyResult',
        modelProperties: {
          isIdentical: {
            required: true,
            serializedName: 'isIdentical',
            type: {
              name: 'Boolean'
            }
          },
          confidence: {
            required: true,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = VerifyResult;
