/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a GeoCoordinates.
 */
class GeoCoordinates {
  /**
   * Create a GeoCoordinates.
   * @property {number} latitude
   * @property {number} longitude
   * @property {number} [elevation]
   * @property {string} _type Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of GeoCoordinates
   *
   * @returns {object} metadata of GeoCoordinates
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'GeoCoordinates',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'GeoCoordinates',
        className: 'GeoCoordinates',
        modelProperties: {
          latitude: {
            required: true,
            serializedName: 'latitude',
            type: {
              name: 'Number'
            }
          },
          longitude: {
            required: true,
            serializedName: 'longitude',
            type: {
              name: 'Number'
            }
          },
          elevation: {
            required: false,
            readOnly: true,
            serializedName: 'elevation',
            type: {
              name: 'Number'
            }
          },
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = GeoCoordinates;
