/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * DTO to hold details of uploaded files.
 *
 */
class FileDTO {
  /**
   * Create a FileDTO.
   * @property {string} fileName File name. Supported file types are ".tsv",
   * ".pdf", ".txt", ".docx", ".xlsx".
   * @property {string} fileUri Public URI of the file.
   */
  constructor() {
  }

  /**
   * Defines the metadata of FileDTO
   *
   * @returns {object} metadata of FileDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FileDTO',
      type: {
        name: 'Composite',
        className: 'FileDTO',
        modelProperties: {
          fileName: {
            required: true,
            serializedName: 'fileName',
            constraints: {
              MaxLength: 200,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          fileUri: {
            required: true,
            serializedName: 'fileUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FileDTO;
