/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Name - value pair of metadata.
 *
 */
class MetadataDTO {
  /**
   * Create a MetadataDTO.
   * @property {string} name Metadata name.
   * @property {string} value Metadata value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetadataDTO
   *
   * @returns {object} metadata of MetadataDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetadataDTO',
      type: {
        name: 'Composite',
        className: 'MetadataDTO',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            constraints: {
              MaxLength: 500,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetadataDTO;
