/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines a date and time for a geographical location.
 *
 */
class TimeZoneTimeZoneInformation {
  /**
   * Create a TimeZoneTimeZoneInformation.
   * @property {string} location The name of the geographical location.For
   * example, County; City; City, State; City, State, Country; or Time Zone.
   * @property {string} time The data and time specified in the form,
   * YYYY-MM-DDThh;mm:ss.ssssssZ.
   * @property {string} utcOffset The offset from UTC. For example, UTC-7.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TimeZoneTimeZoneInformation
   *
   * @returns {object} metadata of TimeZoneTimeZoneInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TimeZone/TimeZoneInformation',
      type: {
        name: 'Composite',
        className: 'TimeZoneTimeZoneInformation',
        modelProperties: {
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          time: {
            required: true,
            serializedName: 'time',
            type: {
              name: 'String'
            }
          },
          utcOffset: {
            required: true,
            serializedName: 'utcOffset',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TimeZoneTimeZoneInformation;
