/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing whether the image contains adult-oriented content
 * and/or is racy.
 *
 */
class AdultInfo {
  /**
   * Create a AdultInfo.
   * @property {boolean} [isAdultContent] A value indicating if the image
   * contains adult-oriented content.
   * @property {boolean} [isRacyContent] A value indicating if the image is
   * racy.
   * @property {number} [adultScore] Score from 0 to 1 that indicates how much
   * the content is considered adult-oriented within the image.
   * @property {number} [racyScore] Score from 0 to 1 that indicates how
   * suggestive is the image.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AdultInfo
   *
   * @returns {object} metadata of AdultInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AdultInfo',
      type: {
        name: 'Composite',
        className: 'AdultInfo',
        modelProperties: {
          isAdultContent: {
            required: false,
            nullable: false,
            serializedName: 'isAdultContent',
            type: {
              name: 'Boolean'
            }
          },
          isRacyContent: {
            required: false,
            nullable: false,
            serializedName: 'isRacyContent',
            type: {
              name: 'Boolean'
            }
          },
          adultScore: {
            required: false,
            nullable: false,
            serializedName: 'adultScore',
            type: {
              name: 'Number'
            }
          },
          racyScore: {
            required: false,
            nullable: false,
            serializedName: 'racyScore',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AdultInfo;
