/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A bounding box for an area inside an image.
 *
 */
class BoundingRect {
  /**
   * Create a BoundingRect.
   * @property {number} [x] X-coordinate of the top left point of the area, in
   * pixels.
   * @property {number} [y] Y-coordinate of the top left point of the area, in
   * pixels.
   * @property {number} [w] Width measured from the top-left point of the area,
   * in pixels.
   * @property {number} [h] Height measured from the top-left point of the
   * area, in pixels.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BoundingRect
   *
   * @returns {object} metadata of BoundingRect
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BoundingRect',
      type: {
        name: 'Composite',
        className: 'BoundingRect',
        modelProperties: {
          x: {
            required: false,
            nullable: false,
            serializedName: 'x',
            type: {
              name: 'Number'
            }
          },
          y: {
            required: false,
            nullable: false,
            serializedName: 'y',
            type: {
              name: 'Number'
            }
          },
          w: {
            required: false,
            nullable: false,
            serializedName: 'w',
            type: {
              name: 'Number'
            }
          },
          h: {
            required: false,
            nullable: false,
            serializedName: 'h',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = BoundingRect;
