/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A collection of content tags, along with a list of captions sorted by
 * confidence level, and image metadata.
 *
 */
class ImageDescription {
  /**
   * Create a ImageDescription.
   * @property {array} [tags] A collection of image tags.
   * @property {array} [captions] A list of captions, sorted by confidence
   * level.
   * @property {string} [requestId] Id of the REST API request.
   * @property {object} [metadata]
   * @property {number} [metadata.width] Image width, in pixels.
   * @property {number} [metadata.height] Image height, in pixels.
   * @property {string} [metadata.format] Image format.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageDescription
   *
   * @returns {object} metadata of ImageDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageDescription',
      type: {
        name: 'Composite',
        className: 'ImageDescription',
        modelProperties: {
          tags: {
            required: false,
            nullable: true,
            serializedName: 'description.tags',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          captions: {
            required: false,
            nullable: true,
            serializedName: 'description.captions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageCaptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageCaption'
                  }
              }
            }
          },
          requestId: {
            required: false,
            nullable: true,
            serializedName: 'requestId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: false,
            serializedName: 'metadata',
            type: {
              name: 'Composite',
              className: 'ImageMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageDescription;
