/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An entity observation in the image, along with the confidence score.
 *
 */
class ImageTag {
  /**
   * Create a ImageTag.
   * @property {string} [name] Name of the entity.
   * @property {number} [confidence] The level of confidence that the entity
   * was observed.
   * @property {string} [hint] Optional hint/details for this tag.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageTag
   *
   * @returns {object} metadata of ImageTag
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageTag',
      type: {
        name: 'Composite',
        className: 'ImageTag',
        modelProperties: {
          name: {
            required: false,
            nullable: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          confidence: {
            required: false,
            nullable: false,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          },
          hint: {
            required: false,
            nullable: true,
            serializedName: 'hint',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageTag;
