/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Json object representing a recognized text line.
 *
 */
class Line {
  /**
   * Create a Line.
   * @property {array} [boundingBox] Bounding box of a recognized line.
   * @property {string} [text] The text content of the line.
   * @property {array} [words] List of words in the text line.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Line
   *
   * @returns {object} metadata of Line
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Line',
      type: {
        name: 'Composite',
        className: 'Line',
        modelProperties: {
          boundingBox: {
            required: false,
            serializedName: 'boundingBox',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          text: {
            required: false,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          words: {
            required: false,
            serializedName: 'words',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'WordElementType',
                  type: {
                    name: 'Composite',
                    className: 'Word'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Line;
