/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing a single recognized line of text.
 *
 */
class OcrLine {
  /**
   * Create a OcrLine.
   * @property {string} [boundingBox] Bounding box of a recognized line. The
   * four integers represent the x-coordinate of the left edge, the
   * y-coordinate of the top edge, width, and height of the bounding box, in
   * the coordinate system of the input image, after it has been rotated around
   * its center according to the detected text angle (see textAngle property),
   * with the origin at the top-left corner, and the y-axis pointing down.
   * @property {array} [words] An array of objects, where each object
   * represents a recognized word.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OcrLine
   *
   * @returns {object} metadata of OcrLine
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OcrLine',
      type: {
        name: 'Composite',
        className: 'OcrLine',
        modelProperties: {
          boundingBox: {
            required: false,
            nullable: true,
            serializedName: 'boundingBox',
            type: {
              name: 'String'
            }
          },
          words: {
            required: false,
            nullable: true,
            serializedName: 'words',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OcrWordElementType',
                  type: {
                    name: 'Composite',
                    className: 'OcrWord'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OcrLine;
