/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information on a recognized word.
 *
 */
class OcrWord {
  /**
   * Create a OcrWord.
   * @property {string} [boundingBox] Bounding box of a recognized word. The
   * four integers represent the x-coordinate of the left edge, the
   * y-coordinate of the top edge, width, and height of the bounding box, in
   * the coordinate system of the input image, after it has been rotated around
   * its center according to the detected text angle (see textAngle property),
   * with the origin at the top-left corner, and the y-axis pointing down.
   * @property {string} [text] String value of a recognized word.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OcrWord
   *
   * @returns {object} metadata of OcrWord
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OcrWord',
      type: {
        name: 'Composite',
        className: 'OcrWord',
        modelProperties: {
          boundingBox: {
            required: false,
            nullable: true,
            serializedName: 'boundingBox',
            type: {
              name: 'String'
            }
          },
          text: {
            required: false,
            nullable: true,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OcrWord;
