/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a build argument.
 *
 */
class BuildArgument {
  /**
   * Create a BuildArgument.
   * @member {string} name The name of the argument.
   * @member {string} value The value of the argument.
   * @member {boolean} [isSecret] Flag to indicate whether the argument
   * represents a secret and want to be removed from build logs. Default value:
   * false .
   */
  constructor() {
  }

  /**
   * Defines the metadata of BuildArgument
   *
   * @returns {object} metadata of BuildArgument
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildArgument',
      type: {
        name: 'Composite',
        className: 'BuildArgument',
        modelProperties: {
          type: {
            required: true,
            isConstant: true,
            serializedName: 'type',
            defaultValue: 'DockerBuildArgument',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          isSecret: {
            required: false,
            serializedName: 'isSecret',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = BuildArgument;
