/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The queue build parameters based on a build task.
 *
 * @extends models['QueueBuildRequest']
 */
class BuildTaskBuildRequest extends models['QueueBuildRequest'] {
  /**
   * Create a BuildTaskBuildRequest.
   * @member {string} buildTaskName The name of build task against which build
   * has to be queued.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BuildTaskBuildRequest
   *
   * @returns {object} metadata of BuildTaskBuildRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildTask',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'QueueBuildRequest',
        className: 'BuildTaskBuildRequest',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          buildTaskName: {
            required: true,
            serializedName: 'buildTaskName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BuildTaskBuildRequest;
