/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ImportSourceCredentials = require('./importSourceCredentials');
exports.ImportSource = require('./importSource');
exports.ImportImageParameters = require('./importImageParameters');
exports.RegistryNameCheckRequest = require('./registryNameCheckRequest');
exports.RegistryNameStatus = require('./registryNameStatus');
exports.OperationDisplayDefinition = require('./operationDisplayDefinition');
exports.OperationMetricSpecificationDefinition = require('./operationMetricSpecificationDefinition');
exports.OperationServiceSpecificationDefinition = require('./operationServiceSpecificationDefinition');
exports.OperationDefinition = require('./operationDefinition');
exports.Sku = require('./sku');
exports.Status = require('./status');
exports.StorageAccountProperties = require('./storageAccountProperties');
exports.VirtualNetworkRule = require('./virtualNetworkRule');
exports.IPRule = require('./iPRule');
exports.NetworkRuleSet = require('./networkRuleSet');
exports.Resource = require('./resource');
exports.Registry = require('./registry');
exports.RegistryUpdateParameters = require('./registryUpdateParameters');
exports.RegistryPassword = require('./registryPassword');
exports.RegistryListCredentialsResult = require('./registryListCredentialsResult');
exports.RegenerateCredentialParameters = require('./regenerateCredentialParameters');
exports.RegistryUsage = require('./registryUsage');
exports.RegistryUsageListResult = require('./registryUsageListResult');
exports.QuarantinePolicy = require('./quarantinePolicy');
exports.TrustPolicy = require('./trustPolicy');
exports.RegistryPolicies = require('./registryPolicies');
exports.Replication = require('./replication');
exports.ReplicationUpdateParameters = require('./replicationUpdateParameters');
exports.Webhook = require('./webhook');
exports.WebhookCreateParameters = require('./webhookCreateParameters');
exports.WebhookUpdateParameters = require('./webhookUpdateParameters');
exports.EventInfo = require('./eventInfo');
exports.CallbackConfig = require('./callbackConfig');
exports.Target = require('./target');
exports.Request = require('./request');
exports.Actor = require('./actor');
exports.Source = require('./source');
exports.EventContent = require('./eventContent');
exports.EventRequestMessage = require('./eventRequestMessage');
exports.EventResponseMessage = require('./eventResponseMessage');
exports.Event = require('./event');
exports.RunRequest = require('./runRequest');
exports.ImageDescriptor = require('./imageDescriptor');
exports.ImageUpdateTrigger = require('./imageUpdateTrigger');
exports.SourceTriggerDescriptor = require('./sourceTriggerDescriptor');
exports.PlatformProperties = require('./platformProperties');
exports.AgentProperties = require('./agentProperties');
exports.ProxyResource = require('./proxyResource');
exports.Run = require('./run');
exports.SourceUploadDefinition = require('./sourceUploadDefinition');
exports.RunFilter = require('./runFilter');
exports.RunUpdateParameters = require('./runUpdateParameters');
exports.RunGetLogResult = require('./runGetLogResult');
exports.UserIdentityProperties = require('./userIdentityProperties');
exports.IdentityProperties = require('./identityProperties');
exports.BaseImageDependency = require('./baseImageDependency');
exports.TaskStepProperties = require('./taskStepProperties');
exports.TimerTrigger = require('./timerTrigger');
exports.AuthInfo = require('./authInfo');
exports.SourceProperties = require('./sourceProperties');
exports.SourceTrigger = require('./sourceTrigger');
exports.BaseImageTrigger = require('./baseImageTrigger');
exports.TriggerProperties = require('./triggerProperties');
exports.SourceRegistryCredentials = require('./sourceRegistryCredentials');
exports.SecretObject = require('./secretObject');
exports.CustomRegistryCredentials = require('./customRegistryCredentials');
exports.Credentials = require('./credentials');
exports.Task = require('./task');
exports.PlatformUpdateParameters = require('./platformUpdateParameters');
exports.TaskStepUpdateParameters = require('./taskStepUpdateParameters');
exports.TimerTriggerUpdateParameters = require('./timerTriggerUpdateParameters');
exports.AuthInfoUpdateParameters = require('./authInfoUpdateParameters');
exports.SourceUpdateParameters = require('./sourceUpdateParameters');
exports.SourceTriggerUpdateParameters = require('./sourceTriggerUpdateParameters');
exports.BaseImageTriggerUpdateParameters = require('./baseImageTriggerUpdateParameters');
exports.TriggerUpdateParameters = require('./triggerUpdateParameters');
exports.TaskUpdateParameters = require('./taskUpdateParameters');
exports.Argument = require('./argument');
exports.DockerBuildRequest = require('./dockerBuildRequest');
exports.SetValue = require('./setValue');
exports.FileTaskRunRequest = require('./fileTaskRunRequest');
exports.TaskRunRequest = require('./taskRunRequest');
exports.EncodedTaskRunRequest = require('./encodedTaskRunRequest');
exports.DockerBuildStep = require('./dockerBuildStep');
exports.FileTaskStep = require('./fileTaskStep');
exports.EncodedTaskStep = require('./encodedTaskStep');
exports.DockerBuildStepUpdateParameters = require('./dockerBuildStepUpdateParameters');
exports.FileTaskStepUpdateParameters = require('./fileTaskStepUpdateParameters');
exports.EncodedTaskStepUpdateParameters = require('./encodedTaskStepUpdateParameters');
exports.RegistryListResult = require('./registryListResult');
exports.OperationListResult = require('./operationListResult');
exports.ReplicationListResult = require('./replicationListResult');
exports.WebhookListResult = require('./webhookListResult');
exports.EventListResult = require('./eventListResult');
exports.RunListResult = require('./runListResult');
exports.TaskListResult = require('./taskListResult');
exports.discriminators = {
  'RunRequest' : exports.RunRequest,
  'TaskStepProperties' : exports.TaskStepProperties,
  'TaskStepUpdateParameters' : exports.TaskStepUpdateParameters,
  'RunRequest.DockerBuildRequest' : exports.DockerBuildRequest,
  'RunRequest.FileTaskRunRequest' : exports.FileTaskRunRequest,
  'RunRequest.TaskRunRequest' : exports.TaskRunRequest,
  'RunRequest.EncodedTaskRunRequest' : exports.EncodedTaskRunRequest,
  'TaskStepProperties.Docker' : exports.DockerBuildStep,
  'TaskStepProperties.FileTask' : exports.FileTaskStep,
  'TaskStepProperties.EncodedTask' : exports.EncodedTaskStep,
  'TaskStepUpdateParameters.Docker' : exports.DockerBuildStepUpdateParameters,
  'TaskStepUpdateParameters.FileTask' : exports.FileTaskStepUpdateParameters,
  'TaskStepUpdateParameters.EncodedTask' : exports.EncodedTaskStepUpdateParameters
};
