/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The definition of Azure Monitoring metric.
 *
 */
class OperationMetricSpecificationDefinition {
  /**
   * Create a OperationMetricSpecificationDefinition.
   * @property {string} [name] Metric name.
   * @property {string} [displayName] Metric display name.
   * @property {string} [displayDescription] Metric description.
   * @property {string} [unit] Metric unit.
   * @property {string} [aggregationType] Metric aggregation type.
   * @property {string} [internalMetricName] Internal metric name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OperationMetricSpecificationDefinition
   *
   * @returns {object} metadata of OperationMetricSpecificationDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OperationMetricSpecificationDefinition',
      type: {
        name: 'Composite',
        className: 'OperationMetricSpecificationDefinition',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          displayDescription: {
            required: false,
            serializedName: 'displayDescription',
            type: {
              name: 'String'
            }
          },
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          aggregationType: {
            required: false,
            serializedName: 'aggregationType',
            type: {
              name: 'String'
            }
          },
          internalMetricName: {
            required: false,
            serializedName: 'internalMetricName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OperationMetricSpecificationDefinition;
