/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The platform properties against which the run has to happen.
 *
 */
class PlatformProperties {
  /**
   * Create a PlatformProperties.
   * @property {string} os The operating system type required for the run.
   * Possible values include: 'Windows', 'Linux'
   * @property {string} [architecture] The OS architecture. Possible values
   * include: 'amd64', 'x86', 'arm'
   * @property {string} [variant] Variant of the CPU. Possible values include:
   * 'v6', 'v7', 'v8'
   */
  constructor() {
  }

  /**
   * Defines the metadata of PlatformProperties
   *
   * @returns {object} metadata of PlatformProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PlatformProperties',
      type: {
        name: 'Composite',
        className: 'PlatformProperties',
        modelProperties: {
          os: {
            required: true,
            serializedName: 'os',
            type: {
              name: 'String'
            }
          },
          architecture: {
            required: false,
            serializedName: 'architecture',
            type: {
              name: 'String'
            }
          },
          variant: {
            required: false,
            serializedName: 'variant',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PlatformProperties;
