/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a overridable value that can be passed to a task template.
 *
 */
class SetValue {
  /**
   * Create a SetValue.
   * @property {string} name The name of the overridable value.
   * @property {string} value The overridable value.
   * @property {boolean} [isSecret] Flag to indicate whether the value
   * represents a secret or not. Default value: false .
   */
  constructor() {
  }

  /**
   * Defines the metadata of SetValue
   *
   * @returns {object} metadata of SetValue
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SetValue',
      type: {
        name: 'Composite',
        className: 'SetValue',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          },
          isSecret: {
            required: false,
            serializedName: 'isSecret',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SetValue;
