/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters for a task run request.
 *
 * @extends models['RunRequest']
 */
class TaskRunRequest extends models['RunRequest'] {
  /**
   * Create a TaskRunRequest.
   * @property {string} taskName The name of task against which run has to be
   * queued.
   * @property {array} [values] The collection of overridable values that can
   * be passed when running a task.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TaskRunRequest
   *
   * @returns {object} metadata of TaskRunRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskRunRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'RunRequest',
        className: 'TaskRunRequest',
        modelProperties: {
          isArchiveEnabled: {
            required: false,
            serializedName: 'isArchiveEnabled',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          taskName: {
            required: true,
            serializedName: 'taskName',
            type: {
              name: 'String'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SetValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'SetValue'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = TaskRunRequest;
