/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identity for the container group.
 *
 */
class ContainerGroupIdentity {
  /**
   * Create a ContainerGroupIdentity.
   * @member {string} [principalId] The principal id of the container group
   * identity. This property will only be provided for a system assigned
   * identity.
   * @member {string} [tenantId] The tenant id associated with the container
   * group. This property will only be provided for a system assigned identity.
   * @member {string} [type] The type of identity used for the container group.
   * The type 'SystemAssigned, UserAssigned' includes both an implicitly
   * created identity and a set of user assigned identities. The type 'None'
   * will remove any identities from the container group. Possible values
   * include: 'SystemAssigned', 'UserAssigned', 'SystemAssigned, UserAssigned',
   * 'None'
   * @member {object} [userAssignedIdentities] The list of user identities
   * associated with the container group. The user identity dictionary key
   * references will be ARM resource ids in the form:
   * '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerGroupIdentity
   *
   * @returns {object} metadata of ContainerGroupIdentity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerGroupIdentity',
      type: {
        name: 'Composite',
        className: 'ContainerGroupIdentity',
        modelProperties: {
          principalId: {
            required: false,
            readOnly: true,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            readOnly: true,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'SystemAssigned', 'UserAssigned', 'SystemAssigned, UserAssigned', 'None' ]
            }
          },
          userAssignedIdentities: {
            required: false,
            serializedName: 'userAssignedIdentities',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ContainerGroupIdentityUserAssignedIdentitiesValueElementType',
                  type: {
                    name: 'Composite',
                    className: 'ContainerGroupIdentityUserAssignedIdentitiesValue'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerGroupIdentity;
