/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An operation for Azure Container Instance service.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} name The name of the operation.
   * @member {object} display The display information of the operation.
   * @member {string} [display.provider] The name of the provider of the
   * operation.
   * @member {string} [display.resource] The name of the resource type of the
   * operation.
   * @member {string} [display.operation] The friendly name of the operation.
   * @member {string} [display.description] The description of the operation.
   * @member {string} [origin] The intended executor of the operation. Possible
   * values include: 'User', 'System'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: true,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
