/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The resource requests.
 *
 */
class ResourceRequests {
  /**
   * Create a ResourceRequests.
   * @member {number} memoryInGB The memory request in GB of this container
   * instance.
   * @member {number} cpu The CPU request of this container instance.
   * @member {object} [gpu] The GPU request of this container instance.
   * @member {number} [gpu.count] The count of the GPU resource.
   * @member {string} [gpu.sku] The SKU of the GPU resource. Possible values
   * include: 'K80', 'P100', 'V100'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceRequests
   *
   * @returns {object} metadata of ResourceRequests
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceRequests',
      type: {
        name: 'Composite',
        className: 'ResourceRequests',
        modelProperties: {
          memoryInGB: {
            required: true,
            serializedName: 'memoryInGB',
            type: {
              name: 'Number'
            }
          },
          cpu: {
            required: true,
            serializedName: 'cpu',
            type: {
              name: 'Number'
            }
          },
          gpu: {
            required: false,
            serializedName: 'gpu',
            type: {
              name: 'Composite',
              className: 'GpuResource'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceRequests;
