/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The resource requirements.
 *
 */
class ResourceRequirements {
  /**
   * Create a ResourceRequirements.
   * @member {object} requests The resource requests of this container
   * instance.
   * @member {number} [requests.memoryInGB] The memory request in GB of this
   * container instance.
   * @member {number} [requests.cpu] The CPU request of this container
   * instance.
   * @member {object} [requests.gpu] The GPU request of this container
   * instance.
   * @member {number} [requests.gpu.count] The count of the GPU resource.
   * @member {string} [requests.gpu.sku] The SKU of the GPU resource. Possible
   * values include: 'K80', 'P100', 'V100'
   * @member {object} [limits] The resource limits of this container instance.
   * @member {number} [limits.memoryInGB] The memory limit in GB of this
   * container instance.
   * @member {number} [limits.cpu] The CPU limit of this container instance.
   * @member {object} [limits.gpu] The GPU limit of this container instance.
   * @member {number} [limits.gpu.count] The count of the GPU resource.
   * @member {string} [limits.gpu.sku] The SKU of the GPU resource. Possible
   * values include: 'K80', 'P100', 'V100'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceRequirements
   *
   * @returns {object} metadata of ResourceRequirements
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceRequirements',
      type: {
        name: 'Composite',
        className: 'ResourceRequirements',
        modelProperties: {
          requests: {
            required: true,
            serializedName: 'requests',
            type: {
              name: 'Composite',
              className: 'ResourceRequests'
            }
          },
          limits: {
            required: false,
            serializedName: 'limits',
            type: {
              name: 'Composite',
              className: 'ResourceLimits'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceRequirements;
