/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a service principal identity for the cluster to use for
 * manipulating Azure APIs. Either secret or keyVaultSecretRef must be
 * specified.
 *
 */
class ContainerServiceServicePrincipalProfile {
  /**
   * Create a ContainerServiceServicePrincipalProfile.
   * @property {string} clientId The ID for the service principal.
   * @property {string} [secret] The secret password associated with the
   * service principal in plain text.
   * @property {object} [keyVaultSecretRef] Reference to a secret stored in
   * Azure Key Vault.
   * @property {string} [keyVaultSecretRef.vaultID] Key vault identifier.
   * @property {string} [keyVaultSecretRef.secretName] The secret name.
   * @property {string} [keyVaultSecretRef.version] The secret version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerServiceServicePrincipalProfile
   *
   * @returns {object} metadata of ContainerServiceServicePrincipalProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerServiceServicePrincipalProfile',
      type: {
        name: 'Composite',
        className: 'ContainerServiceServicePrincipalProfile',
        modelProperties: {
          clientId: {
            required: true,
            serializedName: 'clientId',
            type: {
              name: 'String'
            }
          },
          secret: {
            required: false,
            serializedName: 'secret',
            type: {
              name: 'String'
            }
          },
          keyVaultSecretRef: {
            required: false,
            serializedName: 'keyVaultSecretRef',
            type: {
              name: 'Composite',
              className: 'KeyVaultSecretRef'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerServiceServicePrincipalProfile;
