/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a service principal identity for the cluster to use for
 * manipulating Azure APIs.
 *
 */
class ManagedClusterServicePrincipalProfile {
  /**
   * Create a ManagedClusterServicePrincipalProfile.
   * @property {string} clientId The ID for the service principal.
   * @property {string} [secret] The secret password associated with the
   * service principal in plain text.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedClusterServicePrincipalProfile
   *
   * @returns {object} metadata of ManagedClusterServicePrincipalProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedClusterServicePrincipalProfile',
      type: {
        name: 'Composite',
        className: 'ManagedClusterServicePrincipalProfile',
        modelProperties: {
          clientId: {
            required: true,
            serializedName: 'clientId',
            type: {
              name: 'String'
            }
          },
          secret: {
            required: false,
            serializedName: 'secret',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedClusterServicePrincipalProfile;
