/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines all possible authentication profiles for the OpenShift cluster.
 *
 */
class OpenShiftManagedClusterAuthProfile {
  /**
   * Create a OpenShiftManagedClusterAuthProfile.
   * @property {array} [identityProviders] Type of authentication profile to
   * use.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OpenShiftManagedClusterAuthProfile
   *
   * @returns {object} metadata of OpenShiftManagedClusterAuthProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OpenShiftManagedClusterAuthProfile',
      type: {
        name: 'Composite',
        className: 'OpenShiftManagedClusterAuthProfile',
        modelProperties: {
          identityProviders: {
            required: false,
            serializedName: 'identityProviders',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OpenShiftManagedClusterIdentityProviderElementType',
                  type: {
                    name: 'Composite',
                    className: 'OpenShiftManagedClusterIdentityProvider'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OpenShiftManagedClusterAuthProfile;
