/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents an OpenShift router
 *
 */
class OpenShiftRouterProfile {
  /**
   * Create a OpenShiftRouterProfile.
   * @property {string} [name] Name of the router profile.
   * @property {string} [publicSubdomain] DNS subdomain for OpenShift router.
   * @property {string} [fqdn] Auto-allocated FQDN for the OpenShift router.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OpenShiftRouterProfile
   *
   * @returns {object} metadata of OpenShiftRouterProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OpenShiftRouterProfile',
      type: {
        name: 'Composite',
        className: 'OpenShiftRouterProfile',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          publicSubdomain: {
            required: false,
            readOnly: true,
            serializedName: 'publicSubdomain',
            type: {
              name: 'String'
            }
          },
          fqdn: {
            required: false,
            readOnly: true,
            serializedName: 'fqdn',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OpenShiftRouterProfile;
