/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ImageCreateSummary.
 */
class ImageCreateSummary {
  /**
   * Create a ImageCreateSummary.
   * @property {boolean} [isBatchSuccessful] True if all of the images in the
   * batch were created successfully, otherwise false.
   * @property {array} [images] List of the image creation results.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageCreateSummary
   *
   * @returns {object} metadata of ImageCreateSummary
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageCreateSummary',
      type: {
        name: 'Composite',
        className: 'ImageCreateSummary',
        modelProperties: {
          isBatchSuccessful: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'isBatchSuccessful',
            type: {
              name: 'Boolean'
            }
          },
          images: {
            required: false,
            readOnly: true,
            serializedName: 'images',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ImageCreateResultElementType',
                  type: {
                    name: 'Composite',
                    className: 'ImageCreateResult'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageCreateSummary;
