/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Job details for update.
 *
 */
class UpdateJobDetails {
  /**
   * Create a UpdateJobDetails.
   * @member {object} [contactDetails] Contact details for notification and
   * shipping.
   * @member {string} [contactDetails.contactName] Contact name of the person.
   * @member {string} [contactDetails.phone] Phone number of the contact
   * person.
   * @member {string} [contactDetails.phoneExtension] Phone extension number of
   * the contact person.
   * @member {string} [contactDetails.mobile] Mobile number of the contact
   * person.
   * @member {array} [contactDetails.emailList] List of Email-ids to be
   * notified about job progress.
   * @member {array} [contactDetails.notificationPreference] Notification
   * preference for a job stage.
   * @member {object} [shippingAddress] Shipping address of the customer.
   * @member {string} [shippingAddress.streetAddress1] Street Address line 1.
   * @member {string} [shippingAddress.streetAddress2] Street Address line 2.
   * @member {string} [shippingAddress.streetAddress3] Street Address line 3.
   * @member {string} [shippingAddress.city] Name of the City.
   * @member {string} [shippingAddress.stateOrProvince] Name of the State or
   * Province.
   * @member {string} [shippingAddress.country] Name of the Country.
   * @member {string} [shippingAddress.postalCode] Postal code.
   * @member {string} [shippingAddress.zipExtendedCode] Extended Zip Code.
   * @member {string} [shippingAddress.companyName] Name of the company.
   * @member {string} [shippingAddress.addressType] Type of address. Possible
   * values include: 'None', 'Residential', 'Commercial'
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateJobDetails
   *
   * @returns {object} metadata of UpdateJobDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateJobDetails',
      type: {
        name: 'Composite',
        className: 'UpdateJobDetails',
        modelProperties: {
          contactDetails: {
            required: false,
            serializedName: 'contactDetails',
            type: {
              name: 'Composite',
              className: 'ContactDetails'
            }
          },
          shippingAddress: {
            required: false,
            serializedName: 'shippingAddress',
            type: {
              name: 'Composite',
              className: 'ShippingAddress'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateJobDetails;
