/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Credential details of the account.
 *
 */
class AccountCredentialDetails {
  /**
   * Create a AccountCredentialDetails.
   * @member {string} [accountName] Name of the account.
   * @member {string} [accountConnectionString] Connection string of the
   * account endpoint to use the account as a storage endpoint on the device.
   * @member {array} [shareCredentialDetails] Per share level unencrypted
   * access credentials.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AccountCredentialDetails
   *
   * @returns {object} metadata of AccountCredentialDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccountCredentialDetails',
      type: {
        name: 'Composite',
        className: 'AccountCredentialDetails',
        modelProperties: {
          accountName: {
            required: false,
            readOnly: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          accountConnectionString: {
            required: false,
            readOnly: true,
            serializedName: 'accountConnectionString',
            type: {
              name: 'String'
            }
          },
          shareCredentialDetails: {
            required: false,
            readOnly: true,
            serializedName: 'shareCredentialDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ShareCredentialDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'ShareCredentialDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AccountCredentialDetails;
