/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Output of the address validation api.
 *
 */
class AddressValidationOutput {
  /**
   * Create a AddressValidationOutput.
   * @member {string} [validationStatus] The address validation status.
   * Possible values include: 'Valid', 'Invalid', 'Ambiguous'
   * @member {array} [alternateAddresses] List of alternate addresses.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AddressValidationOutput
   *
   * @returns {object} metadata of AddressValidationOutput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AddressValidationOutput',
      type: {
        name: 'Composite',
        className: 'AddressValidationOutput',
        modelProperties: {
          validationStatus: {
            required: false,
            readOnly: true,
            serializedName: 'properties.validationStatus',
            type: {
              name: 'Enum',
              allowedValues: [ 'Valid', 'Invalid', 'Ambiguous' ]
            }
          },
          alternateAddresses: {
            required: false,
            readOnly: true,
            serializedName: 'properties.alternateAddresses',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ShippingAddressElementType',
                  type: {
                    name: 'Composite',
                    className: 'ShippingAddress'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AddressValidationOutput;
