/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Error details.
  *
 */
class ErrorDetail {
  /**
   * Create a ErrorDetail.
   * @member {string} code The error's code.
   * @member {string} message A human readable error message.
   * @member {string} [target] Indicates which property in the request is
   * responsible for the error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorDetail
   *
   * @returns {object} metadata of ErrorDetail
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorDetail',
      type: {
        name: 'Composite',
        className: 'ErrorDetail',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorDetail;
