/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Custom linked service.
 *
 * @extends models['LinkedService']
 */
class CustomDataSourceLinkedService extends models['LinkedService'] {
  /**
   * Create a CustomDataSourceLinkedService.
   * @member {object} typeProperties Custom linked service properties.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CustomDataSourceLinkedService
   *
   * @returns {object} metadata of CustomDataSourceLinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomDataSource',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'LinkedService',
        className: 'CustomDataSourceLinkedService',
        modelProperties: {
          connectVia: {
            required: false,
            serializedName: 'connectVia',
            type: {
              name: 'Composite',
              className: 'IntegrationRuntimeReference'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ParameterSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterSpecification'
                  }
              }
            }
          },
          annotations: {
            required: false,
            serializedName: 'annotations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          typeProperties: {
            required: true,
            serializedName: 'typeProperties',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = CustomDataSourceLinkedService;
