/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Filter and return results from input array based on the conditions.
 *
 * @extends models['ControlActivity']
 */
class FilterActivity extends models['ControlActivity'] {
  /**
   * Create a FilterActivity.
   * @member {object} items Input array on which filter should be applied.
   * @member {string} [items.value] Expression value.
   * @member {object} condition Condition to be used for filtering the input.
   * @member {string} [condition.value] Expression value.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FilterActivity
   *
   * @returns {object} metadata of FilterActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Filter',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'Activity',
        className: 'FilterActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    additionalProperties: {
                      type: {
                        name: 'Dictionary',
                        value: {
                            required: false,
                            serializedName: 'ObjectElementType',
                            type: {
                              name: 'Object'
                            }
                        }
                      }
                    },
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          userProperties: {
            required: false,
            serializedName: 'userProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UserPropertyElementType',
                  type: {
                    name: 'Composite',
                    className: 'UserProperty'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          items: {
            required: true,
            serializedName: 'typeProperties.items',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'Expression'
            }
          },
          condition: {
            required: true,
            serializedName: 'typeProperties.condition',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'Expression'
            }
          }
        }
      }
    };
  }
}

module.exports = FilterActivity;
