/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A Rest service dataset.
 *
 * @extends models['Dataset']
 */
class RestServiceDataset extends models['Dataset'] {
  /**
   * Create a RestServiceDataset.
   * @member {object} [relativeUrl] The relative URL to the resource that the
   * RESTful API provides. Type: string (or Expression with resultType string).
   * @member {object} [requestMethod] The HTTP method used to call the RESTful
   * API. The default is GET. Type: string (or Expression with resultType
   * string).
   * @member {object} [requestBody] The HTTP request body to the RESTful API if
   * requestMethod is POST. Type: string (or Expression with resultType
   * string).
   * @member {object} [additionalHeaders] The additional HTTP headers in the
   * request to the RESTful API. Type: string (or Expression with resultType
   * string).
   * @member {object} [paginationRules] The pagination rules to compose next
   * page requests.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RestServiceDataset
   *
   * @returns {object} metadata of RestServiceDataset
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestResource',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'Dataset',
        className: 'RestServiceDataset',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          structure: {
            required: false,
            serializedName: 'structure',
            type: {
              name: 'Object'
            }
          },
          linkedServiceName: {
            required: true,
            serializedName: 'linkedServiceName',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          parameters: {
            required: false,
            serializedName: 'parameters',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ParameterSpecificationElementType',
                  type: {
                    name: 'Composite',
                    className: 'ParameterSpecification'
                  }
              }
            }
          },
          annotations: {
            required: false,
            serializedName: 'annotations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          },
          folder: {
            required: false,
            serializedName: 'folder',
            type: {
              name: 'Composite',
              className: 'DatasetFolder'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          relativeUrl: {
            required: false,
            serializedName: 'typeProperties.relativeUrl',
            type: {
              name: 'Object'
            }
          },
          requestMethod: {
            required: false,
            serializedName: 'typeProperties.requestMethod',
            type: {
              name: 'Object'
            }
          },
          requestBody: {
            required: false,
            serializedName: 'typeProperties.requestBody',
            type: {
              name: 'Object'
            }
          },
          additionalHeaders: {
            required: false,
            serializedName: 'typeProperties.additionalHeaders',
            type: {
              name: 'Object'
            }
          },
          paginationRules: {
            required: false,
            serializedName: 'typeProperties.paginationRules',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = RestServiceDataset;
