/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Self-hosted integration runtime.
 *
 * @extends models['IntegrationRuntime']
 */
class SelfHostedIntegrationRuntime extends models['IntegrationRuntime'] {
  /**
   * Create a SelfHostedIntegrationRuntime.
   * @member {object} [linkedInfo]
   * @member {string} [linkedInfo.authorizationType] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SelfHostedIntegrationRuntime
   *
   * @returns {object} metadata of SelfHostedIntegrationRuntime
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SelfHosted',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'IntegrationRuntime',
        className: 'SelfHostedIntegrationRuntime',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          linkedInfo: {
            required: false,
            serializedName: 'typeProperties.linkedInfo',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'authorizationType',
                clientName: 'authorizationType'
              },
              uberParent: 'LinkedIntegrationRuntimeType',
              className: 'LinkedIntegrationRuntimeType'
            }
          }
        }
      }
    };
  }
}

module.exports = SelfHostedIntegrationRuntime;
