/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A copy activity tabular translator.
 *
 * @extends models['CopyTranslator']
 */
class TabularTranslator extends models['CopyTranslator'] {
  /**
   * Create a TabularTranslator.
   * @member {object} [columnMappings] Column mappings. Example: "UserId:
   * MyUserId, Group: MyGroup, Name: MyName" Type: string (or Expression with
   * resultType string).
   * @member {object} [schemaMapping] The schema mapping to map between tabular
   * data and hierarchical data. Example: {"Column1": "$.Column1", "Column2":
   * "$.Column2.Property1", "Column3": "$.Column2.Property2"}. Type: object (or
   * Expression with resultType object).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TabularTranslator
   *
   * @returns {object} metadata of TabularTranslator
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TabularTranslator',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'CopyTranslator',
        className: 'TabularTranslator',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          columnMappings: {
            required: false,
            serializedName: 'columnMappings',
            type: {
              name: 'Object'
            }
          },
          schemaMapping: {
            required: false,
            serializedName: 'schemaMapping',
            type: {
              name: 'Object'
            }
          }
        }
      }
    };
  }
}

module.exports = TabularTranslator;
