/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Trigger referenced dependency.
 *
 * @extends models['DependencyReference']
 */
class TriggerDependencyReference extends models['DependencyReference'] {
  /**
   * Create a TriggerDependencyReference.
   * @member {object} referenceTrigger Referenced trigger.
   * @member {string} [referenceTrigger.referenceName] Reference trigger name.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TriggerDependencyReference
   *
   * @returns {object} metadata of TriggerDependencyReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TriggerDependencyReference',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'DependencyReference',
        className: 'TriggerDependencyReference',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          referenceTrigger: {
            required: true,
            serializedName: 'referenceTrigger',
            defaultValue: {},
            type: {
              name: 'Composite',
              className: 'TriggerReference'
            }
          }
        }
      }
    };
  }
}

module.exports = TriggerDependencyReference;
