/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters used to create a new firewall rule.
 *
 */
class CreateOrUpdateFirewallRuleParameters {
  /**
   * Create a CreateOrUpdateFirewallRuleParameters.
   * @property {string} startIpAddress The start IP address for the firewall
   * rule. This can be either ipv4 or ipv6. Start and End should be in the same
   * protocol.
   * @property {string} endIpAddress The end IP address for the firewall rule.
   * This can be either ipv4 or ipv6. Start and End should be in the same
   * protocol.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateOrUpdateFirewallRuleParameters
   *
   * @returns {object} metadata of CreateOrUpdateFirewallRuleParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateOrUpdateFirewallRuleParameters',
      type: {
        name: 'Composite',
        className: 'CreateOrUpdateFirewallRuleParameters',
        modelProperties: {
          startIpAddress: {
            required: true,
            serializedName: 'properties.startIpAddress',
            type: {
              name: 'String'
            }
          },
          endIpAddress: {
            required: true,
            serializedName: 'properties.endIpAddress',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateOrUpdateFirewallRuleParameters;
