/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An available operation for Data Lake Store.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @property {string} [name] The name of the operation.
   * @property {object} [display] The display information for the operation.
   * @property {string} [display.provider] The resource provider of the
   * operation.
   * @property {string} [display.resource] The resource type of the operation.
   * @property {string} [display.operation] A friendly name of the operation.
   * @property {string} [display.description] A friendly description of the
   * operation.
   * @property {string} [origin] The intended executor of the operation.
   * Possible values include: 'user', 'system', 'user,system'
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            readOnly: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
