/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of a service.
 *
 */
class ServiceProperties {
  /**
   * Create a ServiceProperties.
   * @member {string} targetLocation The Azure location to which the resources
   * in the service belong to or should be deployed to.
   * @member {string} targetSubscriptionId The subscription to which the
   * resources in the service belong to or should be deployed to.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceProperties
   *
   * @returns {object} metadata of ServiceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceProperties',
      type: {
        name: 'Composite',
        className: 'ServiceProperties',
        modelProperties: {
          targetLocation: {
            required: true,
            serializedName: 'targetLocation',
            type: {
              name: 'String'
            }
          },
          targetSubscriptionId: {
            required: true,
            serializedName: 'targetSubscriptionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceProperties;
