/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The resource representation of a rollout step.
 *
 * @extends models['TrackedResource']
 */
class StepResource extends models['TrackedResource'] {
  /**
   * Create a StepResource.
   * @member {object} properties The properties that define the step.
   * @member {string} [properties.stepType] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StepResource
   *
   * @returns {object} metadata of StepResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StepResource',
      type: {
        name: 'Composite',
        className: 'StepResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'stepType',
                clientName: 'stepType'
              },
              uberParent: 'StepProperties',
              className: 'StepProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = StepResource;
