/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a lab's announcement banner
 *
 */
class LabAnnouncementProperties {
  /**
   * Create a LabAnnouncementProperties.
   * @property {string} [title] The plain text title for the lab announcement
   * @property {string} [markdown] The markdown text (if any) that this lab
   * displays in the UI. If left empty/null, nothing will be shown.
   * @property {string} [enabled] Is the lab announcement active/enabled at
   * this time?. Possible values include: 'Enabled', 'Disabled'
   * @property {date} [expirationDate] The time at which the announcement
   * expires (null for never)
   * @property {boolean} [expired] Has this announcement expired?
   * @property {string} [provisioningState] The provisioning status of the
   * resource.
   * @property {string} [uniqueIdentifier] The unique immutable identifier of a
   * resource (Guid).
   */
  constructor() {
  }

  /**
   * Defines the metadata of LabAnnouncementProperties
   *
   * @returns {object} metadata of LabAnnouncementProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LabAnnouncementProperties',
      type: {
        name: 'Composite',
        className: 'LabAnnouncementProperties',
        modelProperties: {
          title: {
            required: false,
            serializedName: 'title',
            type: {
              name: 'String'
            }
          },
          markdown: {
            required: false,
            serializedName: 'markdown',
            type: {
              name: 'String'
            }
          },
          enabled: {
            required: false,
            serializedName: 'enabled',
            type: {
              name: 'String'
            }
          },
          expirationDate: {
            required: false,
            serializedName: 'expirationDate',
            type: {
              name: 'DateTime'
            }
          },
          expired: {
            required: false,
            serializedName: 'expired',
            type: {
              name: 'Boolean'
            }
          },
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'provisioningState',
            type: {
              name: 'String'
            }
          },
          uniqueIdentifier: {
            required: false,
            readOnly: true,
            serializedName: 'uniqueIdentifier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LabAnnouncementProperties;
