/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A notification.
 *
 * @extends models['UpdateResource']
 */
class NotificationChannelFragment extends models['UpdateResource'] {
  /**
   * Create a NotificationChannelFragment.
   * @property {string} [webHookUrl] The webhook URL to send notifications to.
   * @property {string} [emailRecipient] The email recipient to send
   * notifications to (can be a list of semi-colon separated email addresses).
   * @property {string} [notificationLocale] The locale to use when sending a
   * notification (fallback for unsupported languages is EN).
   * @property {string} [description] Description of notification.
   * @property {array} [events] The list of event for which this notification
   * is enabled.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NotificationChannelFragment
   *
   * @returns {object} metadata of NotificationChannelFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NotificationChannelFragment',
      type: {
        name: 'Composite',
        className: 'NotificationChannelFragment',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          webHookUrl: {
            required: false,
            serializedName: 'properties.webHookUrl',
            type: {
              name: 'String'
            }
          },
          emailRecipient: {
            required: false,
            serializedName: 'properties.emailRecipient',
            type: {
              name: 'String'
            }
          },
          notificationLocale: {
            required: false,
            serializedName: 'properties.notificationLocale',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          events: {
            required: false,
            serializedName: 'properties.events',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EventFragmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'EventFragment'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationChannelFragment;
