/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A secret.
 *
 * @extends models['UpdateResource']
 */
class SecretFragment extends models['UpdateResource'] {
  /**
   * Create a SecretFragment.
   * @property {string} [value] The value of the secret for secret creation.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SecretFragment
   *
   * @returns {object} metadata of SecretFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretFragment',
      type: {
        name: 'Composite',
        className: 'SecretFragment',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          value: {
            required: false,
            serializedName: 'properties.value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretFragment;
