/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a ControllerConnectionDetails.
 */
class ControllerConnectionDetails {
  /**
   * Create a ControllerConnectionDetails.
   * @member {string} [authKey] Authentication key for communicating with
   * services.
   * @member {string} [workspaceStorageAccountName] Workspace storage account
   * name.
   * @member {string} [workspaceStorageSasToken] Workspace storage account SAS
   * token.
   * @member {object} [orchestratorSpecificConnectionDetails]
   * @member {string} [orchestratorSpecificConnectionDetails.instanceType]
   * Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ControllerConnectionDetails
   *
   * @returns {object} metadata of ControllerConnectionDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ControllerConnectionDetails',
      type: {
        name: 'Composite',
        className: 'ControllerConnectionDetails',
        modelProperties: {
          authKey: {
            required: false,
            readOnly: true,
            serializedName: 'authKey',
            type: {
              name: 'String'
            }
          },
          workspaceStorageAccountName: {
            required: false,
            readOnly: true,
            serializedName: 'workspaceStorageAccountName',
            type: {
              name: 'String'
            }
          },
          workspaceStorageSasToken: {
            required: false,
            readOnly: true,
            serializedName: 'workspaceStorageSasToken',
            type: {
              name: 'String'
            }
          },
          orchestratorSpecificConnectionDetails: {
            required: false,
            serializedName: 'orchestratorSpecificConnectionDetails',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'instanceType',
                clientName: 'instanceType'
              },
              uberParent: 'OrchestratorSpecificConnectionDetails',
              className: 'OrchestratorSpecificConnectionDetails'
            }
          }
        }
      }
    };
  }
}

module.exports = ControllerConnectionDetails;
