/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Health Alert Description
 *
 */
class HealthAlert {
  /**
   * Create a HealthAlert.
   * @member {string} [id] Health Alert Id
   * @member {string} [name] Health Alert Name
   * @member {string} [issue] Health Alert Issue
   * @member {string} [severity] Health Alert Severity
   * @member {date} [raised] Health Alert Raised DateTime
   * @member {date} [lastDetected] Health Alert Last Detected DateTime
   * @member {string} [resolutionUri] Health Alert TSG Link
   */
  constructor() {
  }

  /**
   * Defines the metadata of HealthAlert
   *
   * @returns {object} metadata of HealthAlert
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HealthAlert',
      type: {
        name: 'Composite',
        className: 'HealthAlert',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          issue: {
            required: false,
            readOnly: true,
            serializedName: 'issue',
            type: {
              name: 'String'
            }
          },
          severity: {
            required: false,
            readOnly: true,
            serializedName: 'severity',
            type: {
              name: 'String'
            }
          },
          raised: {
            required: false,
            readOnly: true,
            serializedName: 'raised',
            type: {
              name: 'DateTime'
            }
          },
          lastDetected: {
            required: false,
            readOnly: true,
            serializedName: 'lastDetected',
            type: {
              name: 'DateTime'
            }
          },
          resolutionUri: {
            required: false,
            readOnly: true,
            serializedName: 'resolutionUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = HealthAlert;
