/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema of the Data property of an EventGridEvent for an
 * Microsoft.AppConfiguration.KeyValueDeleted event.
 *
 */
class AppConfigurationKeyValueDeletedEventData {
  /**
   * Create a AppConfigurationKeyValueDeletedEventData.
   * @member {string} [key] The key used to identify the key-value that was
   * deleted.
   * @member {string} [label] The label, if any, used to identify the key-value
   * that was deleted.
   * @member {string} [etag] The etag representing the key-value that was
   * deleted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppConfigurationKeyValueDeletedEventData
   *
   * @returns {object} metadata of AppConfigurationKeyValueDeletedEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppConfigurationKeyValueDeletedEventData',
      type: {
        name: 'Composite',
        className: 'AppConfigurationKeyValueDeletedEventData',
        modelProperties: {
          key: {
            required: false,
            serializedName: 'key',
            type: {
              name: 'String'
            }
          },
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppConfigurationKeyValueDeletedEventData;
