/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Event data for Microsoft.Devices.DeviceDeleted event.
 *
 * @extends models['DeviceLifeCycleEventProperties']
 */
class IotHubDeviceDeletedEventData extends models['DeviceLifeCycleEventProperties'] {
  /**
   * Create a IotHubDeviceDeletedEventData.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IotHubDeviceDeletedEventData
   *
   * @returns {object} metadata of IotHubDeviceDeletedEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IotHubDeviceDeletedEventData',
      type: {
        name: 'Composite',
        className: 'IotHubDeviceDeletedEventData',
        modelProperties: {
          deviceId: {
            required: false,
            serializedName: 'deviceId',
            type: {
              name: 'String'
            }
          },
          hubName: {
            required: false,
            serializedName: 'hubName',
            type: {
              name: 'String'
            }
          },
          twin: {
            required: false,
            serializedName: 'twin',
            type: {
              name: 'Composite',
              className: 'DeviceTwinInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = IotHubDeviceDeletedEventData;
