/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Schema of the Data property of an EventGridEvent for a
 * Microsoft.EventGrid.SubscriptionValidationEvent.
 *
 */
class SubscriptionValidationEventData {
  /**
   * Create a SubscriptionValidationEventData.
   * @member {string} [validationCode] The validation code sent by Azure Event
   * Grid to validate an event subscription. To complete the validation
   * handshake, the subscriber must either respond with this validation code as
   * part of the validation response, or perform a GET request on the
   * validationUrl (available starting version 2018-05-01-preview).
   * @member {string} [validationUrl] The validation URL sent by Azure Event
   * Grid (available starting version 2018-05-01-preview). To complete the
   * validation handshake, the subscriber must either respond with the
   * validationCode as part of the validation response, or perform a GET
   * request on the validationUrl (available starting version
   * 2018-05-01-preview).
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubscriptionValidationEventData
   *
   * @returns {object} metadata of SubscriptionValidationEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubscriptionValidationEventData',
      type: {
        name: 'Composite',
        className: 'SubscriptionValidationEventData',
        modelProperties: {
          validationCode: {
            required: false,
            readOnly: true,
            serializedName: 'validationCode',
            type: {
              name: 'String'
            }
          },
          validationUrl: {
            required: false,
            readOnly: true,
            serializedName: 'validationUrl',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SubscriptionValidationEventData;
