/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the service bus destination for an event subscription
 *
 * @extends models['EventSubscriptionDestination']
 */
class ServiceBusQueueEventSubscriptionDestination extends models['EventSubscriptionDestination'] {
  /**
   * Create a ServiceBusQueueEventSubscriptionDestination.
   * @property {string} [resourceId] The Azure Resource Id that represents the
   * endpoint of the Service Bus destination of an event subscription.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceBusQueueEventSubscriptionDestination
   *
   * @returns {object} metadata of ServiceBusQueueEventSubscriptionDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceBusQueue',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'endpointType',
          clientName: 'endpointType'
        },
        uberParent: 'EventSubscriptionDestination',
        className: 'ServiceBusQueueEventSubscriptionDestination',
        modelProperties: {
          endpointType: {
            required: true,
            serializedName: 'endpointType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'properties.resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceBusQueueEventSubscriptionDestination;
