/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A collection of backends that can be routed to.
 *
 */
class BackendPoolUpdateParameters {
  /**
   * Create a BackendPoolUpdateParameters.
   * @member {array} [backends] The set of backends for this pool
   * @member {object} [loadBalancingSettings] Load balancing settings for a
   * backend pool
   * @member {string} [loadBalancingSettings.id] Resource ID.
   * @member {object} [healthProbeSettings] L7 health probe settings for a
   * backend pool
   * @member {string} [healthProbeSettings.id] Resource ID.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackendPoolUpdateParameters
   *
   * @returns {object} metadata of BackendPoolUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackendPoolUpdateParameters',
      type: {
        name: 'Composite',
        className: 'BackendPoolUpdateParameters',
        modelProperties: {
          backends: {
            required: false,
            serializedName: 'backends',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BackendElementType',
                  type: {
                    name: 'Composite',
                    className: 'Backend'
                  }
              }
            }
          },
          loadBalancingSettings: {
            required: false,
            serializedName: 'loadBalancingSettings',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          },
          healthProbeSettings: {
            required: false,
            serializedName: 'healthProbeSettings',
            type: {
              name: 'Composite',
              className: 'SubResource'
            }
          }
        }
      }
    };
  }
}

module.exports = BackendPoolUpdateParameters;
