/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the characteristics of content found in an image.
 *
 */
class ImageTagsModule {
  /**
   * Create a ImageTagsModule.
   * @property {array} value A list of tags that describe the characteristics
   * of the content found in the image. For example, if the image is of a
   * musical artist, the list might include Female, Dress, and Music to
   * indicate the person is female music artist that's wearing a dress.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageTagsModule
   *
   * @returns {object} metadata of ImageTagsModule
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageTagsModule',
      type: {
        name: 'Composite',
        className: 'ImageTagsModule',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'InsightsTagElementType',
                  type: {
                    name: 'Composite',
                    className: 'InsightsTag'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageTagsModule;
