/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties indicating whether a given IoT Central application name or
 * subdomain is available.
 *
 */
class AppAvailabilityInfo {
  /**
   * Create a AppAvailabilityInfo.
   * @member {boolean} [nameAvailable] The value which indicates whether the
   * provided name is available.
   * @member {string} [reason] The reason for unavailability.
   * @member {string} [message] The detailed reason message.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AppAvailabilityInfo
   *
   * @returns {object} metadata of AppAvailabilityInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AppAvailabilityInfo',
      type: {
        name: 'Composite',
        className: 'AppAvailabilityInfo',
        modelProperties: {
          nameAvailable: {
            required: false,
            readOnly: true,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            readOnly: true,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AppAvailabilityInfo;
