/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Input values.
 *
 */
class SubdomainAvailabilityInputs {
  /**
   * Create a SubdomainAvailabilityInputs.
   * @member {string} subdomain The subdomain of the IoT Central application
   * instance to check.
   * @member {string} [type] The type of the IoT Central resource to query.
   * Default value: 'IoTApps' .
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubdomainAvailabilityInputs
   *
   * @returns {object} metadata of SubdomainAvailabilityInputs
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubdomainAvailabilityInputs',
      type: {
        name: 'Composite',
        className: 'SubdomainAvailabilityInputs',
        modelProperties: {
          subdomain: {
            required: true,
            serializedName: 'subdomain',
            constraints: {
              Pattern: '^[a-z0-9-]{1,63}$'
            },
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            defaultValue: 'IoTApps',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SubdomainAvailabilityInputs;
