/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure SKU definition.
 *
 */
class AzureSku {
  /**
   * Create a AzureSku.
   * @property {string} name SKU name. Possible values include: 'D13_v2',
   * 'D14_v2', 'L8', 'L16', 'D11_v2', 'D12_v2', 'L4'
   * @property {number} [capacity] SKU capacity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureSku
   *
   * @returns {object} metadata of AzureSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureSku',
      type: {
        name: 'Composite',
        className: 'AzureSku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          },
          tier: {
            required: true,
            isConstant: true,
            serializedName: 'tier',
            defaultValue: 'Standard',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureSku;
