/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.AddUsersPayload = require('./addUsersPayload');
exports.ReferenceVmCreationParameters = require('./referenceVmCreationParameters');
exports.ResourceSettingCreationParameters = require('./resourceSettingCreationParameters');
exports.EnvironmentSettingCreationParameters = require('./environmentSettingCreationParameters');
exports.LabCreationParameters = require('./labCreationParameters');
exports.CreateLabProperties = require('./createLabProperties');
exports.ResourceSet = require('./resourceSet');
exports.NetworkInterface = require('./networkInterface');
exports.LatestOperationResult = require('./latestOperationResult');
exports.Resource = require('./resource');
exports.Environment = require('./environment');
exports.VirtualMachineDetails = require('./virtualMachineDetails');
exports.EnvironmentDetails = require('./environmentDetails');
exports.ResourceSetFragment = require('./resourceSetFragment');
exports.EnvironmentFragment = require('./environmentFragment');
exports.EnvironmentOperationsPayload = require('./environmentOperationsPayload');
exports.VmStateDetails = require('./vmStateDetails');
exports.ReferenceVm = require('./referenceVm');
exports.ResourceSettings = require('./resourceSettings');
exports.EnvironmentSetting = require('./environmentSetting');
exports.ReferenceVmFragment = require('./referenceVmFragment');
exports.ResourceSettingsFragment = require('./resourceSettingsFragment');
exports.EnvironmentSettingFragment = require('./environmentSettingFragment');
exports.SizeInfo = require('./sizeInfo');
exports.EnvironmentSize = require('./environmentSize');
exports.SizeInfoFragment = require('./sizeInfoFragment');
exports.EnvironmentSizeFragment = require('./environmentSizeFragment');
exports.GalleryImageReference = require('./galleryImageReference');
exports.GalleryImage = require('./galleryImage');
exports.GalleryImageFragment = require('./galleryImageFragment');
exports.GalleryImageReferenceFragment = require('./galleryImageReferenceFragment');
exports.GetEnvironmentResponse = require('./getEnvironmentResponse');
exports.GetPersonalPreferencesResponse = require('./getPersonalPreferencesResponse');
exports.SizeAvailability = require('./sizeAvailability');
exports.RegionalAvailability = require('./regionalAvailability');
exports.GetRegionalAvailabilityResponse = require('./getRegionalAvailabilityResponse');
exports.Lab = require('./lab');
exports.SizeConfigurationProperties = require('./sizeConfigurationProperties');
exports.LabAccount = require('./labAccount');
exports.LabAccountFragment = require('./labAccountFragment');
exports.LabDetails = require('./labDetails');
exports.LabFragment = require('./labFragment');
exports.ListEnvironmentsPayload = require('./listEnvironmentsPayload');
exports.ListEnvironmentsResponse = require('./listEnvironmentsResponse');
exports.ListLabsResponse = require('./listLabsResponse');
exports.OperationBatchStatusPayload = require('./operationBatchStatusPayload');
exports.OperationBatchStatusResponseItem = require('./operationBatchStatusResponseItem');
exports.OperationBatchStatusResponse = require('./operationBatchStatusResponse');
exports.OperationError = require('./operationError');
exports.OperationMetadataDisplay = require('./operationMetadataDisplay');
exports.OperationMetadata = require('./operationMetadata');
exports.OperationResult = require('./operationResult');
exports.OperationStatusPayload = require('./operationStatusPayload');
exports.OperationStatusResponse = require('./operationStatusResponse');
exports.PersonalPreferencesOperationsPayload = require('./personalPreferencesOperationsPayload');
exports.PublishPayload = require('./publishPayload');
exports.RegisterPayload = require('./registerPayload');
exports.ResetPasswordPayload = require('./resetPasswordPayload');
exports.SizeConfigurationPropertiesFragment = require('./sizeConfigurationPropertiesFragment');
exports.User = require('./user');
exports.UserFragment = require('./userFragment');
exports.ProviderOperationResult = require('./providerOperationResult');
exports.ResponseWithContinuationLabAccount = require('./responseWithContinuationLabAccount');
exports.ResponseWithContinuationGalleryImage = require('./responseWithContinuationGalleryImage');
exports.ResponseWithContinuationLab = require('./responseWithContinuationLab');
exports.ResponseWithContinuationEnvironmentSetting = require('./responseWithContinuationEnvironmentSetting');
exports.ResponseWithContinuationEnvironment = require('./responseWithContinuationEnvironment');
exports.ResponseWithContinuationUser = require('./responseWithContinuationUser');
