/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents a lab.
 *
 * @extends models['Resource']
 */
class LabFragment extends models['Resource'] {
  /**
   * Create a LabFragment.
   * @property {number} [maxUsersInLab] Maximum number of users allowed in the
   * lab.
   * @property {moment.duration} [usageQuota] Maximum duration a user can use
   * an environment for in the lab.
   * @property {string} [userAccessMode] Lab user access mode (open to all vs.
   * restricted to those listed on the lab). Possible values include:
   * 'Restricted', 'Open'
   * @property {string} [provisioningState] The provisioning status of the
   * resource.
   * @property {string} [uniqueIdentifier] The unique immutable identifier of a
   * resource (Guid).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LabFragment
   *
   * @returns {object} metadata of LabFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LabFragment',
      type: {
        name: 'Composite',
        className: 'LabFragment',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          maxUsersInLab: {
            required: false,
            serializedName: 'properties.maxUsersInLab',
            type: {
              name: 'Number'
            }
          },
          usageQuota: {
            required: false,
            serializedName: 'properties.usageQuota',
            type: {
              name: 'TimeSpan'
            }
          },
          userAccessMode: {
            required: false,
            serializedName: 'properties.userAccessMode',
            type: {
              name: 'String'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          uniqueIdentifier: {
            required: false,
            serializedName: 'properties.uniqueIdentifier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LabFragment;
