/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents resource specific settings
 *
 */
class ResourceSettingCreationParameters {
  /**
   * Create a ResourceSettingCreationParameters.
   * @property {string} [location] The location where the virtual machine will
   * live
   * @property {string} [name] The name of the resource setting
   * @property {string} galleryImageResourceId The resource id of the gallery
   * image used for creating the virtual machine
   * @property {string} [size] The size of the virtual machine. Possible values
   * include: 'Basic', 'Standard', 'Performance'
   * @property {object} referenceVmCreationParameters Creation parameters for
   * Reference Vm
   * @property {string} [referenceVmCreationParameters.userName] The username
   * of the virtual machine
   * @property {string} [referenceVmCreationParameters.password] The password
   * of the virtual machine.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSettingCreationParameters
   *
   * @returns {object} metadata of ResourceSettingCreationParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSettingCreationParameters',
      type: {
        name: 'Composite',
        className: 'ResourceSettingCreationParameters',
        modelProperties: {
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          galleryImageResourceId: {
            required: true,
            serializedName: 'galleryImageResourceId',
            type: {
              name: 'String'
            }
          },
          size: {
            required: false,
            serializedName: 'size',
            type: {
              name: 'String'
            }
          },
          referenceVmCreationParameters: {
            required: true,
            serializedName: 'referenceVmCreationParameters',
            type: {
              name: 'Composite',
              className: 'ReferenceVmCreationParameters'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSettingCreationParameters;
