/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents resource specific settings
 *
 */
class ResourceSettings {
  /**
   * Create a ResourceSettings.
   * @property {string} [id] The unique id of the resource setting
   * @property {string} [galleryImageResourceId] The resource id of the gallery
   * image used for creating the virtual machine
   * @property {string} [imageName] The name of the image used to created the
   * environment setting
   * @property {string} [size] The size of the virtual machine. Possible values
   * include: 'Basic', 'Standard', 'Performance'
   * @property {number} [cores] The translated compute cores of the virtual
   * machine
   * @property {object} referenceVm Details specific to Reference Vm
   * @property {string} [referenceVm.userName] The username of the virtual
   * machine
   * @property {string} [referenceVm.password] The password of the virtual
   * machine. This will be set to null in GET resource API
   * @property {object} [referenceVm.vmStateDetails] The state details for the
   * reference virtual machine.
   * @property {string} [referenceVm.vmStateDetails.rdpAuthority] The
   * RdpAuthority property is a server DNS host name or IP address followed by
   * the service port number for RDP (Remote Desktop Protocol).
   * @property {string} [referenceVm.vmStateDetails.sshAuthority] The
   * SshAuthority property is a server DNS host name or IP address followed by
   * the service port number for SSH.
   * @property {string} [referenceVm.vmStateDetails.powerState] The power state
   * of the reference virtual machine.
   * @property {string} [referenceVm.vmStateDetails.lastKnownPowerState] Last
   * known compute power state captured in DTL
   * @property {string} [referenceVm.vmResourceId] VM resource Id for the
   * environment
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSettings
   *
   * @returns {object} metadata of ResourceSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSettings',
      type: {
        name: 'Composite',
        className: 'ResourceSettings',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          galleryImageResourceId: {
            required: false,
            serializedName: 'galleryImageResourceId',
            type: {
              name: 'String'
            }
          },
          imageName: {
            required: false,
            readOnly: true,
            serializedName: 'imageName',
            type: {
              name: 'String'
            }
          },
          size: {
            required: false,
            serializedName: 'size',
            type: {
              name: 'String'
            }
          },
          cores: {
            required: false,
            readOnly: true,
            serializedName: 'cores',
            type: {
              name: 'Number'
            }
          },
          referenceVm: {
            required: true,
            serializedName: 'referenceVm',
            type: {
              name: 'Composite',
              className: 'ReferenceVm'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSettings;
