/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ErrorDetailsItem.
 */
class ErrorDetailsItem {
  /**
   * Create a ErrorDetailsItem.
   * @member {string} [code] Error code.
   * @member {string} [message] If available, a human readable description of
   * the error.
   * @member {string} [target] If available, the component generating the
   * error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorDetailsItem
   *
   * @returns {object} metadata of ErrorDetailsItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Error_detailsItem',
      type: {
        name: 'Composite',
        className: 'ErrorDetailsItem',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            readOnly: true,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorDetailsItem;
