/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * This object is returned when an error occurs in the Location Based Service
 * API
 *
 */
class ErrorModel {
  /**
   * Create a ErrorModel.
   * @member {string} [code] Error code.
   * @member {string} [message] If available, a human readable description of
   * the error.
   * @member {string} [target] If available, the component generating the
   * error.
   * @member {array} [details] If available, a list of additional details about
   * the error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorModel
   *
   * @returns {object} metadata of ErrorModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Error',
      type: {
        name: 'Composite',
        className: 'ErrorModel',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            readOnly: true,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            readOnly: true,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorDetailsItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorDetailsItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorModel;
