/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Edifact agreement framing settings.
 *
 */
class EdifactFramingSettings {
  /**
   * Create a EdifactFramingSettings.
   * @property {string} [serviceCodeListDirectoryVersion] The service code list
   * directory version.
   * @property {string} [characterEncoding] The character encoding.
   * @property {number} protocolVersion The protocol version.
   * @property {number} dataElementSeparator The data element separator.
   * @property {number} componentSeparator The component separator.
   * @property {number} segmentTerminator The segment terminator.
   * @property {number} releaseIndicator The release indicator.
   * @property {number} repetitionSeparator The repetition separator.
   * @property {string} characterSet The EDIFACT frame setting characterSet.
   * Possible values include: 'NotSpecified', 'UNOB', 'UNOA', 'UNOC', 'UNOD',
   * 'UNOE', 'UNOF', 'UNOG', 'UNOH', 'UNOI', 'UNOJ', 'UNOK', 'UNOX', 'UNOY',
   * 'KECA'
   * @property {string} decimalPointIndicator The EDIFACT frame setting decimal
   * indicator. Possible values include: 'NotSpecified', 'Comma', 'Decimal'
   * @property {string} segmentTerminatorSuffix The EDIFACT frame setting
   * segment terminator suffix. Possible values include: 'NotSpecified',
   * 'None', 'CR', 'LF', 'CRLF'
   */
  constructor() {
  }

  /**
   * Defines the metadata of EdifactFramingSettings
   *
   * @returns {object} metadata of EdifactFramingSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EdifactFramingSettings',
      type: {
        name: 'Composite',
        className: 'EdifactFramingSettings',
        modelProperties: {
          serviceCodeListDirectoryVersion: {
            required: false,
            serializedName: 'serviceCodeListDirectoryVersion',
            type: {
              name: 'String'
            }
          },
          characterEncoding: {
            required: false,
            serializedName: 'characterEncoding',
            type: {
              name: 'String'
            }
          },
          protocolVersion: {
            required: true,
            serializedName: 'protocolVersion',
            type: {
              name: 'Number'
            }
          },
          dataElementSeparator: {
            required: true,
            serializedName: 'dataElementSeparator',
            type: {
              name: 'Number'
            }
          },
          componentSeparator: {
            required: true,
            serializedName: 'componentSeparator',
            type: {
              name: 'Number'
            }
          },
          segmentTerminator: {
            required: true,
            serializedName: 'segmentTerminator',
            type: {
              name: 'Number'
            }
          },
          releaseIndicator: {
            required: true,
            serializedName: 'releaseIndicator',
            type: {
              name: 'Number'
            }
          },
          repetitionSeparator: {
            required: true,
            serializedName: 'repetitionSeparator',
            type: {
              name: 'Number'
            }
          },
          characterSet: {
            required: true,
            serializedName: 'characterSet',
            type: {
              name: 'String'
            }
          },
          decimalPointIndicator: {
            required: true,
            serializedName: 'decimalPointIndicator',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'Comma', 'Decimal' ]
            }
          },
          segmentTerminatorSuffix: {
            required: true,
            serializedName: 'segmentTerminatorSuffix',
            type: {
              name: 'Enum',
              allowedValues: [ 'NotSpecified', 'None', 'CR', 'LF', 'CRLF' ]
            }
          }
        }
      }
    };
  }
}

module.exports = EdifactFramingSettings;
