/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a ExpressionRoot.
 * @extends models['Expression']
 */
class ExpressionRoot extends models['Expression'] {
  /**
   * Create a ExpressionRoot.
   * @property {string} [path] The path.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ExpressionRoot
   *
   * @returns {object} metadata of ExpressionRoot
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExpressionRoot',
      type: {
        name: 'Composite',
        className: 'ExpressionRoot',
        modelProperties: {
          text: {
            required: false,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Object'
            }
          },
          subexpressions: {
            required: false,
            serializedName: 'subexpressions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ExpressionElementType',
                  type: {
                    name: 'Composite',
                    className: 'Expression'
                  }
              }
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'AzureResourceErrorInfo'
            }
          },
          path: {
            required: false,
            serializedName: 'path',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExpressionRoot;
