/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.SubResource = require('./subResource');
exports.ResourceReference = require('./resourceReference');
exports.Sku = require('./sku');
exports.WorkflowParameter = require('./workflowParameter');
exports.Workflow = require('./workflow');
exports.WorkflowFilter = require('./workflowFilter');
exports.WorkflowVersion = require('./workflowVersion');
exports.RecurrenceScheduleOccurrence = require('./recurrenceScheduleOccurrence');
exports.RecurrenceSchedule = require('./recurrenceSchedule');
exports.WorkflowTriggerRecurrence = require('./workflowTriggerRecurrence');
exports.WorkflowTrigger = require('./workflowTrigger');
exports.WorkflowTriggerFilter = require('./workflowTriggerFilter');
exports.WorkflowTriggerListCallbackUrlQueries = require('./workflowTriggerListCallbackUrlQueries');
exports.WorkflowTriggerCallbackUrl = require('./workflowTriggerCallbackUrl');
exports.Correlation = require('./correlation');
exports.ContentHash = require('./contentHash');
exports.ContentLink = require('./contentLink');
exports.WorkflowTriggerHistory = require('./workflowTriggerHistory');
exports.WorkflowTriggerHistoryFilter = require('./workflowTriggerHistoryFilter');
exports.WorkflowRunTrigger = require('./workflowRunTrigger');
exports.WorkflowOutputParameter = require('./workflowOutputParameter');
exports.WorkflowRun = require('./workflowRun');
exports.WorkflowRunFilter = require('./workflowRunFilter');
exports.ErrorProperties = require('./errorProperties');
exports.ErrorResponse = require('./errorResponse');
exports.RetryHistory = require('./retryHistory');
exports.WorkflowRunAction = require('./workflowRunAction');
exports.WorkflowRunActionFilter = require('./workflowRunActionFilter');
exports.RegenerateActionParameter = require('./regenerateActionParameter');
exports.GenerateUpgradedDefinitionParameters = require('./generateUpgradedDefinitionParameters');
exports.IntegrationAccountSku = require('./integrationAccountSku');
exports.IntegrationAccount = require('./integrationAccount');
exports.GetCallbackUrlParameters = require('./getCallbackUrlParameters');
exports.CallbackUrl = require('./callbackUrl');
exports.IntegrationAccountSchema = require('./integrationAccountSchema');
exports.IntegrationAccountSchemaFilter = require('./integrationAccountSchemaFilter');
exports.IntegrationAccountMapPropertiesParametersSchema = require('./integrationAccountMapPropertiesParametersSchema');
exports.IntegrationAccountMap = require('./integrationAccountMap');
exports.IntegrationAccountMapFilter = require('./integrationAccountMapFilter');
exports.BusinessIdentity = require('./businessIdentity');
exports.B2BPartnerContent = require('./b2BPartnerContent');
exports.PartnerContent = require('./partnerContent');
exports.IntegrationAccountPartner = require('./integrationAccountPartner');
exports.IntegrationAccountPartnerFilter = require('./integrationAccountPartnerFilter');
exports.AS2MessageConnectionSettings = require('./aS2MessageConnectionSettings');
exports.AS2AcknowledgementConnectionSettings = require('./aS2AcknowledgementConnectionSettings');
exports.AS2MdnSettings = require('./aS2MdnSettings');
exports.AS2SecuritySettings = require('./aS2SecuritySettings');
exports.AS2ValidationSettings = require('./aS2ValidationSettings');
exports.AS2EnvelopeSettings = require('./aS2EnvelopeSettings');
exports.AS2ErrorSettings = require('./aS2ErrorSettings');
exports.AS2ProtocolSettings = require('./aS2ProtocolSettings');
exports.AS2OneWayAgreement = require('./aS2OneWayAgreement');
exports.AS2AgreementContent = require('./aS2AgreementContent');
exports.X12ValidationSettings = require('./x12ValidationSettings');
exports.X12FramingSettings = require('./x12FramingSettings');
exports.X12EnvelopeSettings = require('./x12EnvelopeSettings');
exports.X12AcknowledgementSettings = require('./x12AcknowledgementSettings');
exports.X12MessageFilter = require('./x12MessageFilter');
exports.X12SecuritySettings = require('./x12SecuritySettings');
exports.X12ProcessingSettings = require('./x12ProcessingSettings');
exports.X12EnvelopeOverride = require('./x12EnvelopeOverride');
exports.X12ValidationOverride = require('./x12ValidationOverride');
exports.X12MessageIdentifier = require('./x12MessageIdentifier');
exports.X12SchemaReference = require('./x12SchemaReference');
exports.X12DelimiterOverrides = require('./x12DelimiterOverrides');
exports.X12ProtocolSettings = require('./x12ProtocolSettings');
exports.X12OneWayAgreement = require('./x12OneWayAgreement');
exports.X12AgreementContent = require('./x12AgreementContent');
exports.EdifactValidationSettings = require('./edifactValidationSettings');
exports.EdifactFramingSettings = require('./edifactFramingSettings');
exports.EdifactEnvelopeSettings = require('./edifactEnvelopeSettings');
exports.EdifactAcknowledgementSettings = require('./edifactAcknowledgementSettings');
exports.EdifactMessageFilter = require('./edifactMessageFilter');
exports.EdifactProcessingSettings = require('./edifactProcessingSettings');
exports.EdifactEnvelopeOverride = require('./edifactEnvelopeOverride');
exports.EdifactMessageIdentifier = require('./edifactMessageIdentifier');
exports.EdifactSchemaReference = require('./edifactSchemaReference');
exports.EdifactValidationOverride = require('./edifactValidationOverride');
exports.EdifactDelimiterOverride = require('./edifactDelimiterOverride');
exports.EdifactProtocolSettings = require('./edifactProtocolSettings');
exports.EdifactOneWayAgreement = require('./edifactOneWayAgreement');
exports.EdifactAgreementContent = require('./edifactAgreementContent');
exports.AgreementContent = require('./agreementContent');
exports.IntegrationAccountAgreement = require('./integrationAccountAgreement');
exports.IntegrationAccountAgreementFilter = require('./integrationAccountAgreementFilter');
exports.KeyVaultKeyReferenceKeyVault = require('./keyVaultKeyReferenceKeyVault');
exports.KeyVaultKeyReference = require('./keyVaultKeyReference');
exports.IntegrationAccountCertificate = require('./integrationAccountCertificate');
exports.IntegrationAccountSessionFilter = require('./integrationAccountSessionFilter');
exports.IntegrationAccountSession = require('./integrationAccountSession');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.KeyVaultReference = require('./keyVaultReference');
exports.ListKeyVaultKeysDefinition = require('./listKeyVaultKeysDefinition');
exports.KeyVaultKeyAttributes = require('./keyVaultKeyAttributes');
exports.KeyVaultKey = require('./keyVaultKey');
exports.TrackingEventErrorInfo = require('./trackingEventErrorInfo');
exports.TrackingEvent = require('./trackingEvent');
exports.TrackingEventsDefinition = require('./trackingEventsDefinition');
exports.SetTriggerStateActionDefinition = require('./setTriggerStateActionDefinition');
exports.Expression = require('./expression');
exports.ExpressionRoot = require('./expressionRoot');
exports.ErrorInfo = require('./errorInfo');
exports.AzureResourceErrorInfo = require('./azureResourceErrorInfo');
exports.RepetitionIndex = require('./repetitionIndex');
exports.WorkflowRunActionRepetitionDefinition = require('./workflowRunActionRepetitionDefinition');
exports.OperationResultProperties = require('./operationResultProperties');
exports.OperationResult = require('./operationResult');
exports.RunCorrelation = require('./runCorrelation');
exports.RunActionCorrelation = require('./runActionCorrelation');
exports.JsonSchema = require('./jsonSchema');
exports.ArtifactProperties = require('./artifactProperties');
exports.ArtifactContentPropertiesDefinition = require('./artifactContentPropertiesDefinition');
exports.AssemblyProperties = require('./assemblyProperties');
exports.AssemblyDefinition = require('./assemblyDefinition');
exports.BatchReleaseCriteria = require('./batchReleaseCriteria');
exports.BatchConfigurationProperties = require('./batchConfigurationProperties');
exports.BatchConfiguration = require('./batchConfiguration');
exports.Request = require('./request');
exports.Response = require('./response');
exports.RequestHistoryProperties = require('./requestHistoryProperties');
exports.RequestHistory = require('./requestHistory');
exports.WorkflowListResult = require('./workflowListResult');
exports.WorkflowVersionListResult = require('./workflowVersionListResult');
exports.WorkflowTriggerListResult = require('./workflowTriggerListResult');
exports.WorkflowTriggerHistoryListResult = require('./workflowTriggerHistoryListResult');
exports.WorkflowRunListResult = require('./workflowRunListResult');
exports.WorkflowRunActionListResult = require('./workflowRunActionListResult');
exports.ExpressionTraces = require('./expressionTraces');
exports.WorkflowRunActionRepetitionDefinitionCollection = require('./workflowRunActionRepetitionDefinitionCollection');
exports.RequestHistoryListResult = require('./requestHistoryListResult');
exports.IntegrationAccountListResult = require('./integrationAccountListResult');
exports.KeyVaultKeyCollection = require('./keyVaultKeyCollection');
exports.AssemblyCollection = require('./assemblyCollection');
exports.BatchConfigurationCollection = require('./batchConfigurationCollection');
exports.IntegrationAccountSchemaListResult = require('./integrationAccountSchemaListResult');
exports.IntegrationAccountMapListResult = require('./integrationAccountMapListResult');
exports.IntegrationAccountPartnerListResult = require('./integrationAccountPartnerListResult');
exports.IntegrationAccountAgreementListResult = require('./integrationAccountAgreementListResult');
exports.IntegrationAccountCertificateListResult = require('./integrationAccountCertificateListResult');
exports.IntegrationAccountSessionListResult = require('./integrationAccountSessionListResult');
exports.OperationListResult = require('./operationListResult');
