/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A response.
 *
 */
class Response {
  /**
   * Create a Response.
   * @property {object} [headers] A list of all the headers attached to the
   * response.
   * @property {number} [statusCode] The status code of the response.
   * @property {object} [bodyLink] Details on the location of the body content.
   * @property {string} [bodyLink.uri] The content link URI.
   * @property {string} [bodyLink.contentVersion] The content version.
   * @property {number} [bodyLink.contentSize] The content size.
   * @property {object} [bodyLink.contentHash] The content hash.
   * @property {string} [bodyLink.contentHash.algorithm] The algorithm of the
   * content hash.
   * @property {string} [bodyLink.contentHash.value] The value of the content
   * hash.
   * @property {object} [bodyLink.metadata] The metadata.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Response
   *
   * @returns {object} metadata of Response
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Response',
      type: {
        name: 'Composite',
        className: 'Response',
        modelProperties: {
          headers: {
            required: false,
            serializedName: 'headers',
            type: {
              name: 'Object'
            }
          },
          statusCode: {
            required: false,
            serializedName: 'statusCode',
            type: {
              name: 'Number'
            }
          },
          bodyLink: {
            required: false,
            serializedName: 'bodyLink',
            type: {
              name: 'Composite',
              className: 'ContentLink'
            }
          }
        }
      }
    };
  }
}

module.exports = Response;
