/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The workflow run action correlation properties.
 *
 * @extends models['RunCorrelation']
 */
class RunActionCorrelation extends models['RunCorrelation'] {
  /**
   * Create a RunActionCorrelation.
   * @property {string} [actionTrackingId] The action tracking identifier.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RunActionCorrelation
   *
   * @returns {object} metadata of RunActionCorrelation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RunActionCorrelation',
      type: {
        name: 'Composite',
        className: 'RunActionCorrelation',
        modelProperties: {
          clientTrackingId: {
            required: false,
            serializedName: 'clientTrackingId',
            type: {
              name: 'String'
            }
          },
          clientKeywords: {
            required: false,
            serializedName: 'clientKeywords',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          actionTrackingId: {
            required: false,
            serializedName: 'actionTrackingId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RunActionCorrelation;
