/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties for creating a new LUIS Application
 *
 */
class ApplicationCreateObject {
  /**
   * Create a ApplicationCreateObject.
   * @property {string} culture The culture for the new application. It is the
   * language that your app understands and speaks. E.g.: "en-us". Note: the
   * culture cannot be changed after the app is created.
   * @property {string} [domain] The domain for the new application. Optional.
   * E.g.: Comics.
   * @property {string} [description] Description of the new application.
   * Optional.
   * @property {string} [initialVersionId] The initial version ID. Optional.
   * Default value is: "0.1"
   * @property {string} [usageScenario] Defines the scenario for the new
   * application. Optional. E.g.: IoT.
   * @property {string} name The name for the new application.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationCreateObject
   *
   * @returns {object} metadata of ApplicationCreateObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationCreateObject',
      type: {
        name: 'Composite',
        className: 'ApplicationCreateObject',
        modelProperties: {
          culture: {
            required: true,
            serializedName: 'culture',
            type: {
              name: 'String'
            }
          },
          domain: {
            required: false,
            serializedName: 'domain',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          initialVersionId: {
            required: false,
            serializedName: 'initialVersionId',
            type: {
              name: 'String'
            }
          },
          usageScenario: {
            required: false,
            serializedName: 'usageScenario',
            type: {
              name: 'String'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationCreateObject;
