/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response when adding a batch of labeled examples.
 *
 */
class BatchLabelExample {
  /**
   * Create a BatchLabelExample.
   * @property {object} [value]
   * @property {string} [value.utteranceText] The sample's utterance.
   * @property {number} [value.exampleId] The newly created sample ID.
   * @property {boolean} [hasError]
   * @property {object} [error]
   * @property {string} [error.code] Status Code. Possible values include:
   * 'Failed', 'FAILED', 'Success'
   * @property {string} [error.message] Status details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of BatchLabelExample
   *
   * @returns {object} metadata of BatchLabelExample
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BatchLabelExample',
      type: {
        name: 'Composite',
        className: 'BatchLabelExample',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Composite',
              className: 'LabelExampleResponse'
            }
          },
          hasError: {
            required: false,
            serializedName: 'hasError',
            type: {
              name: 'Boolean'
            }
          },
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'OperationStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = BatchLabelExample;
