/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Exported Model - A Closed List.
 *
 */
class ClosedList {
  /**
   * Create a ClosedList.
   * @property {string} [name] Name of the closed list feature.
   * @property {array} [subLists] Sublists for the feature.
   * @property {array} [roles]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClosedList
   *
   * @returns {object} metadata of ClosedList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClosedList',
      type: {
        name: 'Composite',
        className: 'ClosedList',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          subLists: {
            required: false,
            serializedName: 'subLists',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SubClosedListElementType',
                  type: {
                    name: 'Composite',
                    className: 'SubClosedList'
                  }
              }
            }
          },
          roles: {
            required: false,
            serializedName: 'roles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ClosedList;
