/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Pattern feature.
 *
 * @extends models['FeatureInfoObject']
 */
class PatternFeatureInfo extends models['FeatureInfoObject'] {
  /**
   * Create a PatternFeatureInfo.
   * @property {string} [pattern] The Regular Expression to match.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PatternFeatureInfo
   *
   * @returns {object} metadata of PatternFeatureInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PatternFeatureInfo',
      type: {
        name: 'Composite',
        className: 'PatternFeatureInfo',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isActive: {
            required: false,
            serializedName: 'isActive',
            type: {
              name: 'Boolean'
            }
          },
          pattern: {
            required: false,
            serializedName: 'pattern',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PatternFeatureInfo;
