/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details of a commitment plan SKU.
 *
 */
class CatalogSku {
  /**
   * Create a CatalogSku.
   * @property {string} [resourceType] Resource type name
   * @property {string} [name] SKU name
   * @property {string} [tier] SKU tier
   * @property {array} [locations] Regions where the SKU is available.
   * @property {object} [capacity] SKU scaling information
   * @property {number} [capacity.minimum] The minimum capacity.
   * @property {number} [capacity.maximum] The maximum capacity that can be
   * set.
   * @property {number} [capacity.default] The default capacity.
   * @property {string} [capacity.scaleType] The scale type applicable to the
   * sku. Possible values include: 'Automatic', 'Manual', 'None'
   * @property {array} [capabilities] The capability information for the
   * specified SKU.
   * @property {array} [costs] The cost information for the specified SKU.
   * @property {array} [restrictions] Restrictions which would prevent a SKU
   * from being used. This is empty if there are no restrictions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CatalogSku
   *
   * @returns {object} metadata of CatalogSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CatalogSku',
      type: {
        name: 'Composite',
        className: 'CatalogSku',
        modelProperties: {
          resourceType: {
            required: false,
            readOnly: true,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            readOnly: true,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          locations: {
            required: false,
            readOnly: true,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          capacity: {
            required: false,
            readOnly: true,
            serializedName: 'capacity',
            type: {
              name: 'Composite',
              className: 'SkuCapacity'
            }
          },
          capabilities: {
            required: false,
            readOnly: true,
            serializedName: 'capabilities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SkuCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'SkuCapability'
                  }
              }
            }
          },
          costs: {
            required: false,
            readOnly: true,
            serializedName: 'costs',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SkuCostElementType',
                  type: {
                    name: 'Composite',
                    className: 'SkuCost'
                  }
              }
            }
          },
          restrictions: {
            required: false,
            readOnly: true,
            serializedName: 'restrictions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SkuRestrictionsElementType',
                  type: {
                    name: 'Composite',
                    className: 'SkuRestrictions'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CatalogSku;
