/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Secrets related to a Machine Learning compute. Might differ for every type
 * of compute.
 *
 */
class ComputeSecrets {
  /**
   * Create a ComputeSecrets.
   * @member {string} computeType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ComputeSecrets
   *
   * @returns {object} metadata of ComputeSecrets
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ComputeSecrets',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'computeType',
          clientName: 'computeType'
        },
        uberParent: 'ComputeSecrets',
        className: 'ComputeSecrets',
        modelProperties: {
          computeType: {
            required: true,
            serializedName: 'computeType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ComputeSecrets;
