/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a HDInsightProperties.
 */
class HDInsightProperties {
  /**
   * Create a HDInsightProperties.
   * @member {number} [sshPort] Port open for ssh connections on the master
   * node of the cluster.
   * @member {string} [address] Public IP address of the master node of the
   * cluster.
   * @member {object} [administratorAccount] Admin credentials for master node
   * of the cluster
   * @member {string} [administratorAccount.username] Username of admin account
   * @member {string} [administratorAccount.password] Password of admin account
   * @member {string} [administratorAccount.publicKeyData] Public key data
   * @member {string} [administratorAccount.privateKeyData] Private key data
   */
  constructor() {
  }

  /**
   * Defines the metadata of HDInsightProperties
   *
   * @returns {object} metadata of HDInsightProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HDInsight_properties',
      type: {
        name: 'Composite',
        className: 'HDInsightProperties',
        modelProperties: {
          sshPort: {
            required: false,
            serializedName: 'sshPort',
            type: {
              name: 'Number'
            }
          },
          address: {
            required: false,
            serializedName: 'address',
            type: {
              name: 'String'
            }
          },
          administratorAccount: {
            required: false,
            serializedName: 'administratorAccount',
            type: {
              name: 'Composite',
              className: 'VirtualMachineSshCredentials'
            }
          }
        }
      }
    };
  }
}

module.exports = HDInsightProperties;
