/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * scale settings for BatchAI Compute
 *
 */
class ScaleSettings {
  /**
   * Create a ScaleSettings.
   * @member {number} [maxNodeCount] Max number of nodes to use
   * @member {number} [minNodeCount] Min number of nodes to use
   * @member {boolean} [autoScaleEnabled] Enable or disable auto scale
   */
  constructor() {
  }

  /**
   * Defines the metadata of ScaleSettings
   *
   * @returns {object} metadata of ScaleSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ScaleSettings',
      type: {
        name: 'Composite',
        className: 'ScaleSettings',
        modelProperties: {
          maxNodeCount: {
            required: false,
            serializedName: 'maxNodeCount',
            type: {
              name: 'Number'
            }
          },
          minNodeCount: {
            required: false,
            serializedName: 'minNodeCount',
            type: {
              name: 'Number'
            }
          },
          autoScaleEnabled: {
            required: false,
            serializedName: 'autoScaleEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ScaleSettings;
