/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The ssl configugation for scoring
 *
 */
class SslConfiguration {
  /**
   * Create a SslConfiguration.
   * @member {string} [status] Enable or disable ssl for scoring. Possible
   * values include: 'Disabled', 'Enabled'
   * @member {string} [cert] Cert data
   * @member {string} [key] Key data
   * @member {string} [cname] CNAME of the cert
   */
  constructor() {
  }

  /**
   * Defines the metadata of SslConfiguration
   *
   * @returns {object} metadata of SslConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SslConfiguration',
      type: {
        name: 'Composite',
        className: 'SslConfiguration',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          cert: {
            required: false,
            serializedName: 'cert',
            type: {
              name: 'String'
            }
          },
          key: {
            required: false,
            serializedName: 'key',
            type: {
              name: 'String'
            }
          },
          cname: {
            required: false,
            serializedName: 'cname',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SslConfiguration;
