/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a policy option.
 *
 */
class ContentKeyPolicyOption {
  /**
   * Create a ContentKeyPolicyOption.
   * @property {uuid} [policyOptionId] The legacy Policy Option ID.
   * @property {string} [name] The Policy Option description.
   * @property {object} configuration The key delivery configuration.
   * @property {string} [configuration.odatatype] Polymorphic Discriminator
   * @property {object} restriction The requirements that must be met to
   * deliver keys with this configuration
   * @property {string} [restriction.odatatype] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContentKeyPolicyOption
   *
   * @returns {object} metadata of ContentKeyPolicyOption
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentKeyPolicyOption',
      type: {
        name: 'Composite',
        className: 'ContentKeyPolicyOption',
        modelProperties: {
          policyOptionId: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'policyOptionId',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          configuration: {
            required: true,
            serializedName: 'configuration',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '@odata.type',
                clientName: 'odatatype'
              },
              uberParent: 'ContentKeyPolicyConfiguration',
              className: 'ContentKeyPolicyConfiguration'
            }
          },
          restriction: {
            required: true,
            serializedName: 'restriction',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '@odata.type',
                clientName: 'odatatype'
              },
              uberParent: 'ContentKeyPolicyRestriction',
              className: 'ContentKeyPolicyRestriction'
            }
          }
        }
      }
    };
  }
}

module.exports = ContentKeyPolicyOption;
