/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the Content Key Policy.
 *
 */
class ContentKeyPolicyProperties {
  /**
   * Create a ContentKeyPolicyProperties.
   * @property {uuid} [policyId] The legacy Policy ID.
   * @property {date} [created] The creation date of the Policy
   * @property {date} [lastModified] The last modified date of the Policy
   * @property {string} [description] A description for the Policy.
   * @property {array} options The Key Policy options.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContentKeyPolicyProperties
   *
   * @returns {object} metadata of ContentKeyPolicyProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentKeyPolicyProperties',
      type: {
        name: 'Composite',
        className: 'ContentKeyPolicyProperties',
        modelProperties: {
          policyId: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'policyId',
            type: {
              name: 'String'
            }
          },
          created: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'created',
            type: {
              name: 'DateTime'
            }
          },
          lastModified: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'lastModified',
            type: {
              name: 'DateTime'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          options: {
            required: true,
            serializedName: 'options',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ContentKeyPolicyOptionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ContentKeyPolicyOption'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ContentKeyPolicyProperties;
