/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class to specify which protocols are enabled
 *
 */
class EnabledProtocols {
  /**
   * Create a EnabledProtocols.
   * @property {boolean} download Enable Download protocol or not
   * @property {boolean} dash Enable DASH protocol or not
   * @property {boolean} hls Enable HLS protocol or not
   * @property {boolean} smoothStreaming Enable SmoothStreaming protocol or not
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnabledProtocols
   *
   * @returns {object} metadata of EnabledProtocols
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnabledProtocols',
      type: {
        name: 'Composite',
        className: 'EnabledProtocols',
        modelProperties: {
          download: {
            required: true,
            serializedName: 'download',
            type: {
              name: 'Boolean'
            }
          },
          dash: {
            required: true,
            serializedName: 'dash',
            type: {
              name: 'Boolean'
            }
          },
          hls: {
            required: true,
            serializedName: 'hls',
            type: {
              name: 'Boolean'
            }
          },
          smoothStreaming: {
            required: true,
            serializedName: 'smoothStreaming',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = EnabledProtocols;
