/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the properties for producing a series of JPEG images from the
 * input video.
 *
 * @extends models['Image']
 */
class JpgImage extends models['Image'] {
  /**
   * Create a JpgImage.
   * @property {array} [layers] A collection of output JPEG image layers to be
   * produced by the encoder.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of JpgImage
   *
   * @returns {object} metadata of JpgImage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.JpgImage',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'Codec',
        className: 'JpgImage',
        modelProperties: {
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          keyFrameInterval: {
            required: false,
            serializedName: 'keyFrameInterval',
            type: {
              name: 'TimeSpan'
            }
          },
          stretchMode: {
            required: false,
            serializedName: 'stretchMode',
            type: {
              name: 'String'
            }
          },
          start: {
            required: true,
            serializedName: 'start',
            type: {
              name: 'String'
            }
          },
          step: {
            required: false,
            serializedName: 'step',
            type: {
              name: 'String'
            }
          },
          range: {
            required: false,
            serializedName: 'range',
            type: {
              name: 'String'
            }
          },
          layers: {
            required: false,
            serializedName: 'layers',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JpgLayerElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: '@odata.type',
                      clientName: 'odatatype'
                    },
                    uberParent: 'Layer',
                    className: 'JpgLayer'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JpgImage;
