/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Live Event encoding.
 *
 */
class LiveEventEncoding {
  /**
   * Create a LiveEventEncoding.
   * @property {string} [encodingType] The encoding type for Live Event.  This
   * value is specified at creation time and cannot be updated. Possible values
   * include: 'None', 'Basic', 'Standard'
   * @property {string} [presetName] The encoding preset name.  This value is
   * specified at creation time and cannot be updated.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LiveEventEncoding
   *
   * @returns {object} metadata of LiveEventEncoding
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LiveEventEncoding',
      type: {
        name: 'Composite',
        className: 'LiveEventEncoding',
        modelProperties: {
          encodingType: {
            required: false,
            serializedName: 'encodingType',
            type: {
              name: 'Enum',
              allowedValues: [ 'None', 'Basic', 'Standard' ]
            }
          },
          presetName: {
            required: false,
            serializedName: 'presetName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LiveEventEncoding;
