/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about an error.
 *
 */
class ODataError {
  /**
   * Create a ODataError.
   * @property {string} [code] A language-independent error name.
   * @property {string} [message] The error message.
   * @property {string} [target] The target of the error (for example, the name
   * of the property in error).
   * @property {array} [details] The error details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ODataError
   *
   * @returns {object} metadata of ODataError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ODataError',
      type: {
        name: 'Composite',
        className: 'ODataError',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ODataErrorElementType',
                  type: {
                    name: 'Composite',
                    className: 'ODataError'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ODataError;
