/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An operation.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @property {string} name The operation name.
   * @property {object} [display] The operation display name.
   * @property {string} [display.provider] The service provider.
   * @property {string} [display.resource] Resource on which the operation is
   * performed.
   * @property {string} [display.operation] The operation type.
   * @property {string} [display.description] The operation description.
   * @property {string} [origin] Origin of the operation.
   * @property {object} [properties] Operation properties format.
   * @property {object} [properties.serviceSpecification] The service
   * specifications.
   * @property {array} [properties.serviceSpecification.metricSpecifications]
   * List of metric specifications.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'MetricProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
