/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class to specify properties of content key
 *
 */
class StreamingPolicyContentKey {
  /**
   * Create a StreamingPolicyContentKey.
   * @property {string} [label] Label can be used to specify Content Key when
   * creating a Streaming Locator
   * @property {string} [policyName] Policy used by Content Key
   * @property {array} [tracks] Tracks which use this content key
   */
  constructor() {
  }

  /**
   * Defines the metadata of StreamingPolicyContentKey
   *
   * @returns {object} metadata of StreamingPolicyContentKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StreamingPolicyContentKey',
      type: {
        name: 'Composite',
        className: 'StreamingPolicyContentKey',
        modelProperties: {
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          policyName: {
            required: false,
            serializedName: 'policyName',
            type: {
              name: 'String'
            }
          },
          tracks: {
            required: false,
            serializedName: 'tracks',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TrackSelectionElementType',
                  type: {
                    name: 'Composite',
                    className: 'TrackSelection'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = StreamingPolicyContentKey;
