/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An azure function receiver.
 *
 */
class AzureFunctionReceiver {
  /**
   * Create a AzureFunctionReceiver.
   * @property {string} name The name of the azure function receiver. Names
   * must be unique across all receivers within an action group.
   * @property {string} functionAppResourceId The azure resource id of the
   * function app.
   * @property {string} functionName The function name in the function app.
   * @property {string} httpTriggerUrl The http trigger url where http request
   * sent to.
   * @property {boolean} useCommonAlertSchema Indicates whether to use common
   * alert schema.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureFunctionReceiver
   *
   * @returns {object} metadata of AzureFunctionReceiver
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureFunctionReceiver',
      type: {
        name: 'Composite',
        className: 'AzureFunctionReceiver',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          functionAppResourceId: {
            required: true,
            serializedName: 'functionAppResourceId',
            type: {
              name: 'String'
            }
          },
          functionName: {
            required: true,
            serializedName: 'functionName',
            type: {
              name: 'String'
            }
          },
          httpTriggerUrl: {
            required: true,
            serializedName: 'httpTriggerUrl',
            type: {
              name: 'String'
            }
          },
          useCommonAlertSchema: {
            required: true,
            serializedName: 'useCommonAlertSchema',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureFunctionReceiver;
