/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The baseline values for a single sensitivity value.
 *
 */
class Baseline {
  /**
   * Create a Baseline.
   * @property {string} sensitivity the sensitivity of the baseline. Possible
   * values include: 'Low', 'Medium', 'High'
   * @property {array} lowThresholds The low thresholds of the baseline.
   * @property {array} highThresholds The high thresholds of the baseline.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Baseline
   *
   * @returns {object} metadata of Baseline
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Baseline',
      type: {
        name: 'Composite',
        className: 'Baseline',
        modelProperties: {
          sensitivity: {
            required: true,
            serializedName: 'sensitivity',
            type: {
              name: 'Enum',
              allowedValues: [ 'Low', 'Medium', 'High' ]
            }
          },
          lowThresholds: {
            required: true,
            serializedName: 'lowThresholds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          },
          highThresholds: {
            required: true,
            serializedName: 'highThresholds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Baseline;
