/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the criteria for converting log to metric.
 *
 */
class Dimension {
  /**
   * Create a Dimension.
   * @property {string} name Name of the dimension
   * @property {array} values List of dimension values
   */
  constructor() {
  }

  /**
   * Defines the metadata of Dimension
   *
   * @returns {object} metadata of Dimension
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Dimension',
      type: {
        name: 'Composite',
        className: 'Dimension',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          operator: {
            required: true,
            isConstant: true,
            serializedName: 'operator',
            defaultValue: 'Include',
            type: {
              name: 'String'
            }
          },
          values: {
            required: true,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Dimension;
