/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Service level objectives for performance tier.
 *
 */
class PerformanceTierServiceLevelObjectives {
  /**
   * Create a PerformanceTierServiceLevelObjectives.
   * @member {string} [id] ID for the service level objective.
   * @member {string} [edition] Edition of the performance tier.
   * @member {number} [vCore] vCore associated with the service level objective
   * @member {string} [hardwareGeneration] Hardware generation associated with
   * the service level objective
   * @member {number} [maxBackupRetentionDays] Maximum Backup retention in days
   * for the performance tier edition
   * @member {number} [minBackupRetentionDays] Minimum Backup retention in days
   * for the performance tier edition
   * @member {number} [maxStorageMB] Max storage allowed for a server.
   * @member {number} [minStorageMB] Max storage allowed for a server.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PerformanceTierServiceLevelObjectives
   *
   * @returns {object} metadata of PerformanceTierServiceLevelObjectives
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PerformanceTierServiceLevelObjectives',
      type: {
        name: 'Composite',
        className: 'PerformanceTierServiceLevelObjectives',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          edition: {
            required: false,
            serializedName: 'edition',
            type: {
              name: 'String'
            }
          },
          vCore: {
            required: false,
            serializedName: 'vCore',
            type: {
              name: 'Number'
            }
          },
          hardwareGeneration: {
            required: false,
            serializedName: 'hardwareGeneration',
            type: {
              name: 'String'
            }
          },
          maxBackupRetentionDays: {
            required: false,
            serializedName: 'maxBackupRetentionDays',
            type: {
              name: 'Number'
            }
          },
          minBackupRetentionDays: {
            required: false,
            serializedName: 'minBackupRetentionDays',
            type: {
              name: 'Number'
            }
          },
          maxStorageMB: {
            required: false,
            serializedName: 'maxStorageMB',
            type: {
              name: 'Number'
            }
          },
          minStorageMB: {
            required: false,
            serializedName: 'minStorageMB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PerformanceTierServiceLevelObjectives;
