/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The top level Linked service resource container.
 *
 * @extends models['BaseResource']
 */
class LinkedService extends models['BaseResource'] {
  /**
   * Create a LinkedService.
   * @member {string} resourceId The resource id of the resource that will be
   * linked to the workspace.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LinkedService
   *
   * @returns {object} metadata of LinkedService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LinkedService',
      type: {
        name: 'Composite',
        className: 'LinkedService',
        modelProperties: {
          resourceId: {
            required: true,
            serializedName: 'properties.resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkedService;
