/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Non-compliance summary on a particular summary level.
 *
 */
class SummaryResults {
  /**
   * Create a SummaryResults.
   * @property {string} [queryResultsUri] HTTP POST URI for queryResults action
   * on Microsoft.PolicyInsights to retrieve raw results for the non-compliance
   * summary.
   * @property {number} [nonCompliantResources] Number of non-compliant
   * resources.
   * @property {number} [nonCompliantPolicies] Number of non-compliant
   * policies.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SummaryResults
   *
   * @returns {object} metadata of SummaryResults
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SummaryResults',
      type: {
        name: 'Composite',
        className: 'SummaryResults',
        modelProperties: {
          queryResultsUri: {
            required: false,
            serializedName: 'queryResultsUri',
            type: {
              name: 'String'
            }
          },
          nonCompliantResources: {
            required: false,
            serializedName: 'nonCompliantResources',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          nonCompliantPolicies: {
            required: false,
            serializedName: 'nonCompliantPolicies',
            constraints: {
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SummaryResults;
