/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Storage Account workload-specific container.
 *
 * @extends models['ProtectionContainer']
 */
class AzureStorageContainer extends models['ProtectionContainer'] {
  /**
   * Create a AzureStorageContainer.
   * @member {string} [sourceResourceId] Fully qualified ARM url.
   * @member {string} [storageAccountVersion] Storage account version.
   * @member {string} [resourceGroup] Resource group name of Recovery Services
   * Vault.
   * @member {number} [protectedItemCount] Number of items backed up in this
   * container.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureStorageContainer
   *
   * @returns {object} metadata of AzureStorageContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageContainer',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'containerType',
          clientName: 'containerType'
        },
        uberParent: 'ProtectionContainer',
        className: 'AzureStorageContainer',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          registrationStatus: {
            required: false,
            serializedName: 'registrationStatus',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          containerType: {
            required: true,
            serializedName: 'containerType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          storageAccountVersion: {
            required: false,
            serializedName: 'storageAccountVersion',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: false,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          },
          protectedItemCount: {
            required: false,
            serializedName: 'protectedItemCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureStorageContainer;
