/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The query filters that can be used with the refresh container API.
 *
 */
class BMSRefreshContainersQueryObject {
  /**
   * Create a BMSRefreshContainersQueryObject.
   * @member {string} [backupManagementType] Backup management type for this
   * container. Possible values include: 'Invalid', 'AzureIaasVM', 'MAB',
   * 'DPM', 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
   * 'DefaultBackup'
   */
  constructor() {
  }

  /**
   * Defines the metadata of BMSRefreshContainersQueryObject
   *
   * @returns {object} metadata of BMSRefreshContainersQueryObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BMSRefreshContainersQueryObject',
      type: {
        name: 'Composite',
        className: 'BMSRefreshContainersQueryObject',
        modelProperties: {
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BMSRefreshContainersQueryObject;
