/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details about inquired protectable items under a given container.
 *
 */
class InquiryInfo {
  /**
   * Create a InquiryInfo.
   * @member {string} [status] Inquiry Status for this container such as
   * InProgress | Failed | Succeeded
   * @member {object} [errorDetail] Error Details if the Status is non-success.
   * @member {string} [errorDetail.code] Error code.
   * @member {string} [errorDetail.message] Error Message related to the Code.
   * @member {array} [errorDetail.recommendations] List of recommendation
   * strings.
   * @member {array} [inquiryDetails] Inquiry Details which will have workload
   * specific details.
   * For e.g. - For SQL and oracle this will contain different details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InquiryInfo
   *
   * @returns {object} metadata of InquiryInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InquiryInfo',
      type: {
        name: 'Composite',
        className: 'InquiryInfo',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          errorDetail: {
            required: false,
            serializedName: 'errorDetail',
            type: {
              name: 'Composite',
              className: 'ErrorDetail'
            }
          },
          inquiryDetails: {
            required: false,
            serializedName: 'inquiryDetails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'WorkloadInquiryDetailsElementType',
                  type: {
                    name: 'Composite',
                    className: 'WorkloadInquiryDetails'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = InquiryInfo;
