/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Validation for inquired protectable items under a given container.
 *
 */
class InquiryValidation {
  /**
   * Create a InquiryValidation.
   * @member {string} [status] Status for the Inquiry Validation.
   * @member {object} [errorDetail] Error Detail in case the status is
   * non-success.
   * @member {string} [errorDetail.code] Error code.
   * @member {string} [errorDetail.message] Error Message related to the Code.
   * @member {array} [errorDetail.recommendations] List of recommendation
   * strings.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InquiryValidation
   *
   * @returns {object} metadata of InquiryValidation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InquiryValidation',
      type: {
        name: 'Composite',
        className: 'InquiryValidation',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          errorDetail: {
            required: false,
            serializedName: 'errorDetail',
            type: {
              name: 'Composite',
              className: 'ErrorDetail'
            }
          }
        }
      }
    };
  }
}

module.exports = InquiryValidation;
