/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Base class for backup ProtectionIntent.
 *
 * @extends models['Resource']
 */
class ProtectionIntentResource extends models['Resource'] {
  /**
   * Create a ProtectionIntentResource.
   * @member {object} [properties] ProtectionIntentResource properties
   * @member {string} [properties.backupManagementType] Type of backup
   * managemenent for the backed up item. Possible values include: 'Invalid',
   * 'AzureIaasVM', 'MAB', 'DPM', 'AzureBackupServer', 'AzureSql',
   * 'AzureStorage', 'AzureWorkload', 'DefaultBackup'
   * @member {string} [properties.sourceResourceId] ARM ID of the resource to
   * be backed up.
   * @member {string} [properties.itemId] ID of the item which is getting
   * protected, In case of Azure Vm , it is ProtectedItemId
   * @member {string} [properties.policyId] ID of the backup policy with which
   * this item is backed up.
   * @member {string} [properties.protectionState] Backup state of this backup
   * item. Possible values include: 'Invalid', 'NotProtected', 'Protecting',
   * 'Protected', 'ProtectionFailed'
   * @member {string} [properties.protectionIntentItemType] Polymorphic
   * Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ProtectionIntentResource
   *
   * @returns {object} metadata of ProtectionIntentResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectionIntentResource',
      type: {
        name: 'Composite',
        className: 'ProtectionIntentResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          eTag: {
            required: false,
            serializedName: 'eTag',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'protectionIntentItemType',
                clientName: 'protectionIntentItemType'
              },
              uberParent: 'ProtectionIntent',
              className: 'ProtectionIntent'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectionIntentResource;
