/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Encapsulates information regarding data directory
 *
 */
class SQLDataDirectoryMapping {
  /**
   * Create a SQLDataDirectoryMapping.
   * @member {string} [mappingType] Type of data directory mapping. Possible
   * values include: 'Invalid', 'Data', 'Log'
   * @member {string} [sourceLogicalName] Restore source logical name path
   * @member {string} [sourcePath] Restore source path
   * @member {string} [targetPath] Target path
   */
  constructor() {
  }

  /**
   * Defines the metadata of SQLDataDirectoryMapping
   *
   * @returns {object} metadata of SQLDataDirectoryMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SQLDataDirectoryMapping',
      type: {
        name: 'Composite',
        className: 'SQLDataDirectoryMapping',
        modelProperties: {
          mappingType: {
            required: false,
            serializedName: 'mappingType',
            type: {
              name: 'String'
            }
          },
          sourceLogicalName: {
            required: false,
            serializedName: 'sourceLogicalName',
            type: {
              name: 'String'
            }
          },
          sourcePath: {
            required: false,
            serializedName: 'sourcePath',
            type: {
              name: 'String'
            }
          },
          targetPath: {
            required: false,
            serializedName: 'targetPath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SQLDataDirectoryMapping;
