/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Localized display information of an operation.
 *
 */
class ClientDiscoveryDisplay {
  /**
   * Create a ClientDiscoveryDisplay.
   * @property {string} [provider] Name of the provider for display purposes
   * @property {string} [resource] ResourceType for which this Operation can be
   * performed.
   * @property {string} [operation] Operations Name itself.
   * @property {string} [description] Description of the operation having
   * details of what operation is about.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClientDiscoveryDisplay
   *
   * @returns {object} metadata of ClientDiscoveryDisplay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClientDiscoveryDisplay',
      type: {
        name: 'Composite',
        className: 'ClientDiscoveryDisplay',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          resource: {
            required: false,
            serializedName: 'resource',
            type: {
              name: 'String'
            }
          },
          operation: {
            required: false,
            serializedName: 'operation',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClientDiscoveryDisplay;
