/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

import { ServiceClientCredentials } from 'ms-rest';
import { AzureServiceClient, AzureServiceClientOptions } from 'ms-rest-azure';
import * as models from "./models";
import * as operations from "./operations";

export default class SiteRecoveryManagementClient extends AzureServiceClient {
  /**
   * Initializes a new instance of the SiteRecoveryManagementClient class.
   * @constructor
   *
   * @class
   * @param {credentials} credentials - Credentials needed for the client to connect to Azure.
   *
   * @param {string} subscriptionId - The subscription Id.
   *
   * @param {string} resourceGroupName - The name of the resource group where the recovery services vault is present.
   *
   * @param {string} resourceName - The name of the recovery services vault.
   *
   * @param {string} [baseUri] - The base URI of the service.
   *
   * @param {object} [options] - The parameter options
   *
   * @param {Array} [options.filters] - Filters to be added to the request pipeline
   *
   * @param {object} [options.requestOptions] - Options for the underlying request object
   * {@link https://github.com/request/request#requestoptions-callback Options doc}
   *
   * @param {boolean} [options.noRetryPolicy] - If set to true, turn off default retry policy
   *
   * @param {string} [options.acceptLanguage] - The preferred language for the response.
   *
   * @param {number} [options.longRunningOperationRetryTimeout] - The retry timeout in seconds for Long Running Operations. Default value is 30.
   *
   * @param {boolean} [options.generateClientRequestId] - Whether a unique x-ms-client-request-id should be generated. When set to true a unique x-ms-client-request-id value is generated and included in each request. Default is true.
   *
   */
  constructor(credentials: ServiceClientCredentials, subscriptionId: string, resourceGroupName: string, resourceName: string, baseUri?: string, options?: AzureServiceClientOptions);

  credentials: ServiceClientCredentials;

  subscriptionId: string;

  resourceGroupName: string;

  resourceName: string;

  apiVersion: string;

  acceptLanguage: string;

  longRunningOperationRetryTimeout: number;

  generateClientRequestId: boolean;

  // Operation groups
  operations: operations.Operations;
  replicationAlertSettings: operations.ReplicationAlertSettings;
  replicationEvents: operations.ReplicationEvents;
  replicationFabrics: operations.ReplicationFabrics;
  replicationLogicalNetworks: operations.ReplicationLogicalNetworks;
  replicationNetworks: operations.ReplicationNetworks;
  replicationNetworkMappings: operations.ReplicationNetworkMappings;
  replicationProtectionContainers: operations.ReplicationProtectionContainers;
  replicationProtectableItems: operations.ReplicationProtectableItems;
  replicationProtectedItems: operations.ReplicationProtectedItems;
  recoveryPoints: operations.RecoveryPoints;
  targetComputeSizes: operations.TargetComputeSizes;
  replicationProtectionContainerMappings: operations.ReplicationProtectionContainerMappings;
  replicationRecoveryServicesProviders: operations.ReplicationRecoveryServicesProviders;
  replicationStorageClassifications: operations.ReplicationStorageClassifications;
  replicationStorageClassificationMappings: operations.ReplicationStorageClassificationMappings;
  replicationvCenters: operations.ReplicationvCenters;
  replicationJobs: operations.ReplicationJobs;
  replicationPolicies: operations.ReplicationPolicies;
  replicationRecoveryPlans: operations.ReplicationRecoveryPlans;
  replicationVaultHealth: operations.ReplicationVaultHealth;
}

export { SiteRecoveryManagementClient, models as SiteRecoveryManagementModels };
