/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a Catalog.
 */
class Catalog {
  /**
   * Create a Catalog.
   * @property {string} [resourceType] The type of resource the SKU applies to.
   * @property {string} [name] The name of SKU
   * @property {array} [terms] Available reservation terms for this resource
   * @property {array} [locations]
   * @property {array} [skuProperties]
   * @property {array} [restrictions]
   */
  constructor() {
  }

  /**
   * Defines the metadata of Catalog
   *
   * @returns {object} metadata of Catalog
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Catalog',
      type: {
        name: 'Composite',
        className: 'Catalog',
        modelProperties: {
          resourceType: {
            required: false,
            readOnly: true,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          terms: {
            required: false,
            readOnly: true,
            serializedName: 'terms',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ReservationTermElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          locations: {
            required: false,
            readOnly: true,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          skuProperties: {
            required: false,
            readOnly: true,
            serializedName: 'skuProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SkuPropertyElementType',
                  type: {
                    name: 'Composite',
                    className: 'SkuProperty'
                  }
              }
            }
          },
          restrictions: {
            required: false,
            readOnly: true,
            serializedName: 'restrictions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SkuRestrictionElementType',
                  type: {
                    name: 'Composite',
                    className: 'SkuRestriction'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Catalog;
