/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ReservationMergeProperties.
 */
class ReservationMergeProperties {
  /**
   * Create a ReservationMergeProperties.
   * @property {string} [mergeDestination] Reservation Resource Id Created due
   * to the merge. Format of the resource Id is
   * /providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}
   * @property {array} [mergeSources] Resource Ids of the Source Reservation's
   * merged to form this Reservation. Format of the resource Id is
   * /providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReservationMergeProperties
   *
   * @returns {object} metadata of ReservationMergeProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReservationMergeProperties',
      type: {
        name: 'Composite',
        className: 'ReservationMergeProperties',
        modelProperties: {
          mergeDestination: {
            required: false,
            serializedName: 'mergeDestination',
            type: {
              name: 'String'
            }
          },
          mergeSources: {
            required: false,
            serializedName: 'mergeSources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ReservationMergeProperties;
