/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ReservationSplitProperties.
 */
class ReservationSplitProperties {
  /**
   * Create a ReservationSplitProperties.
   * @property {array} [splitDestinations] List of destination Resource Id that
   * are created due to split. Format of the resource Id is
   * /providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}
   * @property {string} [splitSource] Resource Id of the Reservation from which
   * this is split. Format of the resource Id is
   * /providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}
   */
  constructor() {
  }

  /**
   * Defines the metadata of ReservationSplitProperties
   *
   * @returns {object} metadata of ReservationSplitProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ReservationSplitProperties',
      type: {
        name: 'Composite',
        className: 'ReservationSplitProperties',
        modelProperties: {
          splitDestinations: {
            required: false,
            serializedName: 'splitDestinations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          splitSource: {
            required: false,
            serializedName: 'splitSource',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ReservationSplitProperties;
