/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Appliance artifact.
 *
 */
class ApplianceArtifact {
  /**
   * Create a ApplianceArtifact.
   * @property {string} [name] The appliance artifact name.
   * @property {string} [uri] The appliance artifact blob uri.
   * @property {string} [type] The the appliance artifact type. Possible values
   * include: 'Template', 'Custom'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplianceArtifact
   *
   * @returns {object} metadata of ApplianceArtifact
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplianceArtifact',
      type: {
        name: 'Composite',
        className: 'ApplianceArtifact',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          uri: {
            required: false,
            serializedName: 'uri',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'Template', 'Custom' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ApplianceArtifact;
