/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Plan for the appliance.
 *
 */
class Plan {
  /**
   * Create a Plan.
   * @property {string} name The plan name.
   * @property {string} publisher The publisher ID.
   * @property {string} product The product code.
   * @property {string} [promotionCode] The promotion code.
   * @property {string} version The plan's version.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Plan
   *
   * @returns {object} metadata of Plan
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Plan',
      type: {
        name: 'Composite',
        className: 'Plan',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: true,
            serializedName: 'publisher',
            type: {
              name: 'String'
            }
          },
          product: {
            required: true,
            serializedName: 'product',
            type: {
              name: 'String'
            }
          },
          promotionCode: {
            required: false,
            serializedName: 'promotionCode',
            type: {
              name: 'String'
            }
          },
          version: {
            required: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Plan;
