/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The resource whose properties describes the allowed traffic between Azure
 * resources
 *
 */
class AllowedConnectionsResource {
  /**
   * Create a AllowedConnectionsResource.
   * @member {string} [id] Resource Id
   * @member {string} [name] Resource name
   * @member {string} [type] Resource type
   * @member {string} [location] Location where the resource is stored
   * @member {date} [calculatedDateTime] The UTC time on which the allowed
   * connections resource was calculated
   * @member {array} [connectableResources] List of connectable resources
   */
  constructor() {
  }

  /**
   * Defines the metadata of AllowedConnectionsResource
   *
   * @returns {object} metadata of AllowedConnectionsResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AllowedConnectionsResource',
      type: {
        name: 'Composite',
        className: 'AllowedConnectionsResource',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          calculatedDateTime: {
            required: false,
            readOnly: true,
            serializedName: 'properties.calculatedDateTime',
            type: {
              name: 'DateTime'
            }
          },
          connectableResources: {
            required: false,
            readOnly: true,
            serializedName: 'properties.connectableResources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ConnectableResourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ConnectableResource'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AllowedConnectionsResource;
