/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents an ATA security solution which sends logs to an OMS workspace
 *
 * @extends models['ExternalSecuritySolution']
 */
class AtaExternalSecuritySolution extends models['ExternalSecuritySolution'] {
  /**
   * Create a AtaExternalSecuritySolution.
   * @member {object} [properties]
   * @member {string} [properties.lastEventReceived]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AtaExternalSecuritySolution
   *
   * @returns {object} metadata of AtaExternalSecuritySolution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ATA',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ExternalSecuritySolution',
        className: 'AtaExternalSecuritySolution',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'AtaSolutionProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = AtaExternalSecuritySolution;
