/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes properties of a connected resource
 *
 */
class ConnectedResource {
  /**
   * Create a ConnectedResource.
   * @member {string} [connectedResourceId] The Azure resource id of the
   * connected resource
   * @member {string} [tcpPorts] The allowed tcp ports
   * @member {string} [udpPorts] The allowed udp ports
   */
  constructor() {
  }

  /**
   * Defines the metadata of ConnectedResource
   *
   * @returns {object} metadata of ConnectedResource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ConnectedResource',
      type: {
        name: 'Composite',
        className: 'ConnectedResource',
        modelProperties: {
          connectedResourceId: {
            required: false,
            readOnly: true,
            serializedName: 'connectedResourceId',
            type: {
              name: 'String'
            }
          },
          tcpPorts: {
            required: false,
            readOnly: true,
            serializedName: 'tcpPorts',
            type: {
              name: 'String'
            }
          },
          udpPorts: {
            required: false,
            readOnly: true,
            serializedName: 'udpPorts',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ConnectedResource;
