/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The information type keyword.
 *
 */
class InformationProtectionKeyword {
  /**
   * Create a InformationProtectionKeyword.
   * @member {string} [pattern] The keyword pattern.
   * @member {boolean} [custom] Indicates whether the keyword is custom or not.
   * @member {boolean} [canBeNumeric] Indicates whether the keyword can be
   * applied on numeric types or not.
   * @member {boolean} [excluded] Indicates whether the keyword is excluded or
   * not.
   */
  constructor() {
  }

  /**
   * Defines the metadata of InformationProtectionKeyword
   *
   * @returns {object} metadata of InformationProtectionKeyword
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'InformationProtectionKeyword',
      type: {
        name: 'Composite',
        className: 'InformationProtectionKeyword',
        modelProperties: {
          pattern: {
            required: false,
            serializedName: 'pattern',
            type: {
              name: 'String'
            }
          },
          custom: {
            required: false,
            serializedName: 'custom',
            type: {
              name: 'Boolean'
            }
          },
          canBeNumeric: {
            required: false,
            serializedName: 'canBeNumeric',
            type: {
              name: 'Boolean'
            }
          },
          excluded: {
            required: false,
            serializedName: 'excluded',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = InformationProtectionKeyword;
