/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Application Upgrade Start event.
 *
 * @extends models['ApplicationEvent']
 */
class ApplicationUpgradeStartEvent extends models['ApplicationEvent'] {
  /**
   * Create a ApplicationUpgradeStartEvent.
   * @property {string} applicationTypeName Application type name.
   * @property {string} currentApplicationTypeVersion Current Application type
   * version.
   * @property {string} applicationTypeVersion Target Application type version.
   * @property {string} upgradeType Type of upgrade.
   * @property {string} rollingUpgradeMode Mode of upgrade.
   * @property {string} failureAction Action if failed.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ApplicationUpgradeStartEvent
   *
   * @returns {object} metadata of ApplicationUpgradeStartEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationUpgradeStart',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ApplicationUpgradeStartEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          applicationId: {
            required: true,
            serializedName: 'ApplicationId',
            type: {
              name: 'String'
            }
          },
          applicationTypeName: {
            required: true,
            serializedName: 'ApplicationTypeName',
            type: {
              name: 'String'
            }
          },
          currentApplicationTypeVersion: {
            required: true,
            serializedName: 'CurrentApplicationTypeVersion',
            type: {
              name: 'String'
            }
          },
          applicationTypeVersion: {
            required: true,
            serializedName: 'ApplicationTypeVersion',
            type: {
              name: 'String'
            }
          },
          upgradeType: {
            required: true,
            serializedName: 'UpgradeType',
            type: {
              name: 'String'
            }
          },
          rollingUpgradeMode: {
            required: true,
            serializedName: 'RollingUpgradeMode',
            type: {
              name: 'String'
            }
          },
          failureAction: {
            required: true,
            serializedName: 'FailureAction',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationUpgradeStartEvent;
