/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the backup suspension details.
 *
 */
class BackupSuspensionInfo {
  /**
   * Create a BackupSuspensionInfo.
   * @property {boolean} [isSuspended] Indicates whether periodic backup is
   * suspended at this level or not.
   * @property {string} [suspensionInheritedFrom] Specifies the scope at which
   * the backup suspension was applied. Possible values include: 'Invalid',
   * 'Partition', 'Service', 'Application'
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupSuspensionInfo
   *
   * @returns {object} metadata of BackupSuspensionInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupSuspensionInfo',
      type: {
        name: 'Composite',
        className: 'BackupSuspensionInfo',
        modelProperties: {
          isSuspended: {
            required: false,
            serializedName: 'IsSuspended',
            type: {
              name: 'Boolean'
            }
          },
          suspensionInheritedFrom: {
            required: false,
            serializedName: 'SuspensionInheritedFrom',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupSuspensionInfo;
