/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

exports.FabricErrorError = require('./fabricErrorError');
exports.FabricError = require('./fabricError');
exports.ContainerLogs = require('./containerLogs');
exports.AadMetadata = require('./aadMetadata');
exports.AadMetadataObject = require('./aadMetadataObject');
exports.AnalysisEventMetadata = require('./analysisEventMetadata');
exports.FabricEvent = require('./fabricEvent');
exports.ApplicationEvent = require('./applicationEvent');
exports.EntityHealthState = require('./entityHealthState');
exports.ServiceHealthState = require('./serviceHealthState');
exports.DeployedApplicationHealthState = require('./deployedApplicationHealthState');
exports.EntityHealth = require('./entityHealth');
exports.ApplicationHealth = require('./applicationHealth');
exports.HealthEvaluation = require('./healthEvaluation');
exports.HealthEvaluationWrapper = require('./healthEvaluationWrapper');
exports.ApplicationHealthEvaluation = require('./applicationHealthEvaluation');
exports.ServiceTypeHealthPolicy = require('./serviceTypeHealthPolicy');
exports.ServiceTypeHealthPolicyMapItem = require('./serviceTypeHealthPolicyMapItem');
exports.ApplicationHealthPolicy = require('./applicationHealthPolicy');
exports.ApplicationHealthPolicyMapItem = require('./applicationHealthPolicyMapItem');
exports.ApplicationHealthPolicies = require('./applicationHealthPolicies');
exports.ApplicationHealthState = require('./applicationHealthState');
exports.EntityHealthStateChunk = require('./entityHealthStateChunk');
exports.ReplicaHealthStateChunk = require('./replicaHealthStateChunk');
exports.ReplicaHealthStateChunkList = require('./replicaHealthStateChunkList');
exports.PartitionHealthStateChunk = require('./partitionHealthStateChunk');
exports.PartitionHealthStateChunkList = require('./partitionHealthStateChunkList');
exports.ServiceHealthStateChunk = require('./serviceHealthStateChunk');
exports.ServiceHealthStateChunkList = require('./serviceHealthStateChunkList');
exports.DeployedServicePackageHealthStateChunk = require('./deployedServicePackageHealthStateChunk');
exports.DeployedServicePackageHealthStateChunkList = require('./deployedServicePackageHealthStateChunkList');
exports.DeployedApplicationHealthStateChunk = require('./deployedApplicationHealthStateChunk');
exports.DeployedApplicationHealthStateChunkList = require('./deployedApplicationHealthStateChunkList');
exports.ApplicationHealthStateChunk = require('./applicationHealthStateChunk');
exports.EntityHealthStateChunkList = require('./entityHealthStateChunkList');
exports.ApplicationHealthStateChunkList = require('./applicationHealthStateChunkList');
exports.ReplicaHealthStateFilter = require('./replicaHealthStateFilter');
exports.PartitionHealthStateFilter = require('./partitionHealthStateFilter');
exports.ServiceHealthStateFilter = require('./serviceHealthStateFilter');
exports.DeployedServicePackageHealthStateFilter = require('./deployedServicePackageHealthStateFilter');
exports.DeployedApplicationHealthStateFilter = require('./deployedApplicationHealthStateFilter');
exports.ApplicationHealthStateFilter = require('./applicationHealthStateFilter');
exports.ApplicationParameter = require('./applicationParameter');
exports.ApplicationInfo = require('./applicationInfo');
exports.ApplicationMetricDescription = require('./applicationMetricDescription');
exports.ApplicationLoadInfo = require('./applicationLoadInfo');
exports.ApplicationNameInfo = require('./applicationNameInfo');
exports.ApplicationsHealthEvaluation = require('./applicationsHealthEvaluation');
exports.ApplicationTypeApplicationsHealthEvaluation = require('./applicationTypeApplicationsHealthEvaluation');
exports.ApplicationTypeHealthPolicyMapItem = require('./applicationTypeHealthPolicyMapItem');
exports.ApplicationTypeInfo = require('./applicationTypeInfo');
exports.PagedApplicationTypeInfoList = require('./pagedApplicationTypeInfoList');
exports.ApplicationTypeManifest = require('./applicationTypeManifest');
exports.MonitoringPolicyDescription = require('./monitoringPolicyDescription');
exports.ApplicationUpgradeDescription = require('./applicationUpgradeDescription');
exports.UpgradeDomainInfo = require('./upgradeDomainInfo');
exports.SafetyCheck = require('./safetyCheck');
exports.SafetyCheckWrapper = require('./safetyCheckWrapper');
exports.NodeUpgradeProgressInfo = require('./nodeUpgradeProgressInfo');
exports.CurrentUpgradeDomainProgressInfo = require('./currentUpgradeDomainProgressInfo');
exports.FailureUpgradeDomainProgressInfo = require('./failureUpgradeDomainProgressInfo');
exports.ApplicationUpgradeProgressInfo = require('./applicationUpgradeProgressInfo');
exports.ClusterConfiguration = require('./clusterConfiguration');
exports.ClusterEvent = require('./clusterEvent');
exports.NodeId = require('./nodeId');
exports.NodeHealthState = require('./nodeHealthState');
exports.ClusterHealth = require('./clusterHealth');
exports.NodeHealthStateChunk = require('./nodeHealthStateChunk');
exports.NodeHealthStateChunkList = require('./nodeHealthStateChunkList');
exports.ClusterHealthChunk = require('./clusterHealthChunk');
exports.NodeHealthStateFilter = require('./nodeHealthStateFilter');
exports.ClusterHealthPolicy = require('./clusterHealthPolicy');
exports.ClusterHealthChunkQueryDescription = require('./clusterHealthChunkQueryDescription');
exports.ClusterHealthPolicies = require('./clusterHealthPolicies');
exports.ClusterManifest = require('./clusterManifest');
exports.ClusterVersion = require('./clusterVersion');
exports.ContainerApiRequestBody = require('./containerApiRequestBody');
exports.ContainerApiResult = require('./containerApiResult');
exports.ContainerApiResponse = require('./containerApiResponse');
exports.ContainerInstanceEvent = require('./containerInstanceEvent');
exports.DeactivationIntentDescription = require('./deactivationIntentDescription');
exports.DeltaNodesCheckHealthEvaluation = require('./deltaNodesCheckHealthEvaluation');
exports.DeployedServicePackageHealthState = require('./deployedServicePackageHealthState');
exports.DeployedApplicationHealth = require('./deployedApplicationHealth');
exports.DeployedApplicationHealthEvaluation = require('./deployedApplicationHealthEvaluation');
exports.DeployedApplicationInfo = require('./deployedApplicationInfo');
exports.DeployedApplicationsHealthEvaluation = require('./deployedApplicationsHealthEvaluation');
exports.DeployedServicePackageHealth = require('./deployedServicePackageHealth');
exports.DeployedServicePackageHealthEvaluation = require('./deployedServicePackageHealthEvaluation');
exports.DeployedServicePackagesHealthEvaluation = require('./deployedServicePackagesHealthEvaluation');
exports.DeployedServiceReplicaInfo = require('./deployedServiceReplicaInfo');
exports.ReconfigurationInformation = require('./reconfigurationInformation');
exports.DeployedStatefulServiceReplicaInfo = require('./deployedStatefulServiceReplicaInfo');
exports.DeployedStatelessServiceInstanceInfo = require('./deployedStatelessServiceInstanceInfo');
exports.HealthInformation = require('./healthInformation');
exports.HealthEvent = require('./healthEvent');
exports.HealthStateCount = require('./healthStateCount');
exports.EntityKindHealthStateCount = require('./entityKindHealthStateCount');
exports.HealthStatistics = require('./healthStatistics');
exports.Epoch = require('./epoch');
exports.EventHealthEvaluation = require('./eventHealthEvaluation');
exports.FabricCodeVersionInfo = require('./fabricCodeVersionInfo');
exports.FabricConfigVersionInfo = require('./fabricConfigVersionInfo');
exports.ClusterConfigurationUpgradeStatusInfo = require('./clusterConfigurationUpgradeStatusInfo');
exports.PartitionInformation = require('./partitionInformation');
exports.Int64RangePartitionInformation = require('./int64RangePartitionInformation');
exports.NamedPartitionInformation = require('./namedPartitionInformation');
exports.NodeDeactivationTaskId = require('./nodeDeactivationTaskId');
exports.NodeDeactivationTask = require('./nodeDeactivationTask');
exports.NodeDeactivationInfo = require('./nodeDeactivationInfo');
exports.NodeEvent = require('./nodeEvent');
exports.NodeHealth = require('./nodeHealth');
exports.NodeHealthEvaluation = require('./nodeHealthEvaluation');
exports.NodeInfo = require('./nodeInfo');
exports.NodeLoadMetricInformation = require('./nodeLoadMetricInformation');
exports.NodeLoadInfo = require('./nodeLoadInfo');
exports.NodesHealthEvaluation = require('./nodesHealthEvaluation');
exports.PagedApplicationInfoList = require('./pagedApplicationInfoList');
exports.PagedDeployedApplicationInfoList = require('./pagedDeployedApplicationInfoList');
exports.PagedNodeInfoList = require('./pagedNodeInfoList');
exports.ServicePartitionInfo = require('./servicePartitionInfo');
exports.PagedServicePartitionInfoList = require('./pagedServicePartitionInfoList');
exports.ReplicaInfo = require('./replicaInfo');
exports.PagedReplicaInfoList = require('./pagedReplicaInfoList');
exports.ServiceInfo = require('./serviceInfo');
exports.PagedServiceInfoList = require('./pagedServiceInfoList');
exports.PartitionEvent = require('./partitionEvent');
exports.PartitionAnalysisEvent = require('./partitionAnalysisEvent');
exports.ReplicaHealthState = require('./replicaHealthState');
exports.PartitionHealth = require('./partitionHealth');
exports.PartitionHealthEvaluation = require('./partitionHealthEvaluation');
exports.PartitionHealthState = require('./partitionHealthState');
exports.ProvisionFabricDescription = require('./provisionFabricDescription');
exports.ProvisionApplicationTypeDescriptionBase = require('./provisionApplicationTypeDescriptionBase');
exports.ProvisionApplicationTypeDescription = require('./provisionApplicationTypeDescription');
exports.ExternalStoreProvisionApplicationTypeDescription = require('./externalStoreProvisionApplicationTypeDescription');
exports.UnprovisionFabricDescription = require('./unprovisionFabricDescription');
exports.ResumeClusterUpgradeDescription = require('./resumeClusterUpgradeDescription');
exports.ClusterUpgradeHealthPolicyObject = require('./clusterUpgradeHealthPolicyObject');
exports.StartClusterUpgradeDescription = require('./startClusterUpgradeDescription');
exports.RollingUpgradeUpdateDescription = require('./rollingUpgradeUpdateDescription');
exports.UpdateClusterUpgradeDescription = require('./updateClusterUpgradeDescription');
exports.PartitionSafetyCheck = require('./partitionSafetyCheck');
exports.EnsureAvailabilitySafetyCheck = require('./ensureAvailabilitySafetyCheck');
exports.EnsurePartitionQurumSafetyCheck = require('./ensurePartitionQurumSafetyCheck');
exports.SeedNodeSafetyCheck = require('./seedNodeSafetyCheck');
exports.PartitionsHealthEvaluation = require('./partitionsHealthEvaluation');
exports.ReplicaEvent = require('./replicaEvent');
exports.ReplicaHealth = require('./replicaHealth');
exports.ReplicaHealthEvaluation = require('./replicaHealthEvaluation');
exports.ReplicasHealthEvaluation = require('./replicasHealthEvaluation');
exports.RestartNodeDescription = require('./restartNodeDescription');
exports.ServiceEvent = require('./serviceEvent');
exports.ServiceFromTemplateDescription = require('./serviceFromTemplateDescription');
exports.ServiceHealthEvaluation = require('./serviceHealthEvaluation');
exports.ServiceHealth = require('./serviceHealth');
exports.ServiceNameInfo = require('./serviceNameInfo');
exports.ServicePlacementPolicyDescription = require('./servicePlacementPolicyDescription');
exports.ServicePlacementInvalidDomainPolicyDescription = require('./servicePlacementInvalidDomainPolicyDescription');
exports.ServicePlacementNonPartiallyPlaceServicePolicyDescription = require('./servicePlacementNonPartiallyPlaceServicePolicyDescription');
exports.ServicePlacementPreferPrimaryDomainPolicyDescription = require('./servicePlacementPreferPrimaryDomainPolicyDescription');
exports.ServicePlacementRequiredDomainPolicyDescription = require('./servicePlacementRequiredDomainPolicyDescription');
exports.ServicePlacementRequireDomainDistributionPolicyDescription = require('./servicePlacementRequireDomainDistributionPolicyDescription');
exports.ServicesHealthEvaluation = require('./servicesHealthEvaluation');
exports.ServiceLoadMetricDescription = require('./serviceLoadMetricDescription');
exports.ServiceTypeExtensionDescription = require('./serviceTypeExtensionDescription');
exports.ServiceTypeDescription = require('./serviceTypeDescription');
exports.ServiceTypeInfo = require('./serviceTypeInfo');
exports.ServiceTypeManifest = require('./serviceTypeManifest');
exports.SingletonPartitionInformation = require('./singletonPartitionInformation');
exports.StatefulServiceInfo = require('./statefulServiceInfo');
exports.StatefulServicePartitionInfo = require('./statefulServicePartitionInfo');
exports.StatefulServiceReplicaHealth = require('./statefulServiceReplicaHealth');
exports.StatefulServiceReplicaHealthState = require('./statefulServiceReplicaHealthState');
exports.StatefulServiceTypeDescription = require('./statefulServiceTypeDescription');
exports.StatelessServiceInfo = require('./statelessServiceInfo');
exports.StatelessServiceInstanceHealth = require('./statelessServiceInstanceHealth');
exports.StatelessServiceInstanceHealthState = require('./statelessServiceInstanceHealthState');
exports.StatelessServicePartitionInfo = require('./statelessServicePartitionInfo');
exports.StatelessServiceTypeDescription = require('./statelessServiceTypeDescription');
exports.SystemApplicationHealthEvaluation = require('./systemApplicationHealthEvaluation');
exports.UpgradeDomainDeltaNodesCheckHealthEvaluation = require('./upgradeDomainDeltaNodesCheckHealthEvaluation');
exports.UpgradeDomainNodesHealthEvaluation = require('./upgradeDomainNodesHealthEvaluation');
exports.WaitForInbuildReplicaSafetyCheck = require('./waitForInbuildReplicaSafetyCheck');
exports.WaitForPrimaryPlacementSafetyCheck = require('./waitForPrimaryPlacementSafetyCheck');
exports.WaitForPrimarySwapSafetyCheck = require('./waitForPrimarySwapSafetyCheck');
exports.WaitForReconfigurationSafetyCheck = require('./waitForReconfigurationSafetyCheck');
exports.LoadMetricReport = require('./loadMetricReport');
exports.PartitionLoadInformation = require('./partitionLoadInformation');
exports.StatefulServiceReplicaInfo = require('./statefulServiceReplicaInfo');
exports.StatelessServiceInstanceInfo = require('./statelessServiceInstanceInfo');
exports.ClusterUpgradeDescriptionObject = require('./clusterUpgradeDescriptionObject');
exports.FailedUpgradeDomainProgressObject = require('./failedUpgradeDomainProgressObject');
exports.ClusterUpgradeProgressObject = require('./clusterUpgradeProgressObject');
exports.ClusterConfigurationUpgradeDescription = require('./clusterConfigurationUpgradeDescription');
exports.UpgradeOrchestrationServiceState = require('./upgradeOrchestrationServiceState');
exports.UpgradeOrchestrationServiceStateSummary = require('./upgradeOrchestrationServiceStateSummary');
exports.ApplicationTypeImageStorePath = require('./applicationTypeImageStorePath');
exports.UnprovisionApplicationTypeDescriptionInfo = require('./unprovisionApplicationTypeDescriptionInfo');
exports.CodePackageEntryPointStatistics = require('./codePackageEntryPointStatistics');
exports.CodePackageEntryPoint = require('./codePackageEntryPoint');
exports.DeployedCodePackageInfo = require('./deployedCodePackageInfo');
exports.ChaosContext = require('./chaosContext');
exports.ChaosTargetFilter = require('./chaosTargetFilter');
exports.ChaosParameters = require('./chaosParameters');
exports.Chaos = require('./chaos');
exports.ChaosParametersDictionaryItem = require('./chaosParametersDictionaryItem');
exports.ChaosEvent = require('./chaosEvent');
exports.ChaosEventWrapper = require('./chaosEventWrapper');
exports.ChaosEventsSegment = require('./chaosEventsSegment');
exports.ChaosScheduleJobActiveDaysOfWeek = require('./chaosScheduleJobActiveDaysOfWeek');
exports.TimeOfDay = require('./timeOfDay');
exports.TimeRange = require('./timeRange');
exports.ChaosScheduleJob = require('./chaosScheduleJob');
exports.ChaosSchedule = require('./chaosSchedule');
exports.ChaosScheduleDescription = require('./chaosScheduleDescription');
exports.ExecutingFaultsChaosEvent = require('./executingFaultsChaosEvent');
exports.StartedChaosEvent = require('./startedChaosEvent');
exports.StoppedChaosEvent = require('./stoppedChaosEvent');
exports.TestErrorChaosEvent = require('./testErrorChaosEvent');
exports.ValidationFailedChaosEvent = require('./validationFailedChaosEvent');
exports.WaitingChaosEvent = require('./waitingChaosEvent');
exports.ApplicationCapacityDescription = require('./applicationCapacityDescription');
exports.ApplicationDescription = require('./applicationDescription');
exports.ComposeDeploymentStatusInfo = require('./composeDeploymentStatusInfo');
exports.RegistryCredential = require('./registryCredential');
exports.ComposeDeploymentUpgradeDescription = require('./composeDeploymentUpgradeDescription');
exports.ComposeDeploymentUpgradeProgressInfo = require('./composeDeploymentUpgradeProgressInfo');
exports.PagedComposeDeploymentStatusInfoList = require('./pagedComposeDeploymentStatusInfoList');
exports.CreateComposeDeploymentDescription = require('./createComposeDeploymentDescription');
exports.DeployedServicePackageInfo = require('./deployedServicePackageInfo');
exports.ServiceCorrelationDescription = require('./serviceCorrelationDescription');
exports.PartitionSchemeDescription = require('./partitionSchemeDescription');
exports.NamedPartitionSchemeDescription = require('./namedPartitionSchemeDescription');
exports.SingletonPartitionSchemeDescription = require('./singletonPartitionSchemeDescription');
exports.UniformInt64RangePartitionSchemeDescription = require('./uniformInt64RangePartitionSchemeDescription');
exports.ScalingTriggerDescription = require('./scalingTriggerDescription');
exports.ScalingMechanismDescription = require('./scalingMechanismDescription');
exports.ScalingPolicyDescription = require('./scalingPolicyDescription');
exports.ServiceDescription = require('./serviceDescription');
exports.StatefulServiceDescription = require('./statefulServiceDescription');
exports.StatelessServiceDescription = require('./statelessServiceDescription');
exports.ReplicatorQueueStatus = require('./replicatorQueueStatus');
exports.ReplicatorStatus = require('./replicatorStatus');
exports.RemoteReplicatorAcknowledgementDetail = require('./remoteReplicatorAcknowledgementDetail');
exports.RemoteReplicatorAcknowledgementStatus = require('./remoteReplicatorAcknowledgementStatus');
exports.RemoteReplicatorStatus = require('./remoteReplicatorStatus');
exports.PrimaryReplicatorStatus = require('./primaryReplicatorStatus');
exports.SecondaryReplicatorStatus = require('./secondaryReplicatorStatus');
exports.SecondaryActiveReplicatorStatus = require('./secondaryActiveReplicatorStatus');
exports.SecondaryIdleReplicatorStatus = require('./secondaryIdleReplicatorStatus');
exports.LoadMetricReportInfo = require('./loadMetricReportInfo');
exports.DeployedServiceReplicaDetailInfo = require('./deployedServiceReplicaDetailInfo');
exports.ReplicaStatusBase = require('./replicaStatusBase');
exports.KeyValueStoreReplicaStatus = require('./keyValueStoreReplicaStatus');
exports.DeployedStatefulServiceReplicaDetailInfo = require('./deployedStatefulServiceReplicaDetailInfo');
exports.DeployedStatelessServiceInstanceDetailInfo = require('./deployedStatelessServiceInstanceDetailInfo');
exports.ServiceUpdateDescription = require('./serviceUpdateDescription');
exports.StatefulServiceUpdateDescription = require('./statefulServiceUpdateDescription');
exports.StatelessServiceUpdateDescription = require('./statelessServiceUpdateDescription');
exports.FileVersion = require('./fileVersion');
exports.FileInfo = require('./fileInfo');
exports.FolderInfo = require('./folderInfo');
exports.ImageStoreContent = require('./imageStoreContent');
exports.ImageStoreCopyDescription = require('./imageStoreCopyDescription');
exports.RestartDeployedCodePackageDescription = require('./restartDeployedCodePackageDescription');
exports.DeployedServiceTypeInfo = require('./deployedServiceTypeInfo');
exports.ResolvedServiceEndpoint = require('./resolvedServiceEndpoint');
exports.ResolvedServicePartition = require('./resolvedServicePartition');
exports.SelectedPartition = require('./selectedPartition');
exports.InvokeDataLossResult = require('./invokeDataLossResult');
exports.InvokeQuorumLossResult = require('./invokeQuorumLossResult');
exports.NodeResult = require('./nodeResult');
exports.NodeTransitionResult = require('./nodeTransitionResult');
exports.NodeTransitionProgress = require('./nodeTransitionProgress');
exports.OperationStatus = require('./operationStatus');
exports.PartitionDataLossProgress = require('./partitionDataLossProgress');
exports.PartitionQuorumLossProgress = require('./partitionQuorumLossProgress');
exports.RestartPartitionResult = require('./restartPartitionResult');
exports.PartitionRestartProgress = require('./partitionRestartProgress');
exports.PackageSharingPolicyInfo = require('./packageSharingPolicyInfo');
exports.DeployServicePackageToNodeDescription = require('./deployServicePackageToNodeDescription');
exports.ResumeApplicationUpgradeDescription = require('./resumeApplicationUpgradeDescription');
exports.ApplicationUpgradeUpdateDescription = require('./applicationUpgradeUpdateDescription');
exports.NameDescription = require('./nameDescription');
exports.PagedSubNameInfoList = require('./pagedSubNameInfoList');
exports.PropertyValue = require('./propertyValue');
exports.BinaryPropertyValue = require('./binaryPropertyValue');
exports.Int64PropertyValue = require('./int64PropertyValue');
exports.DoublePropertyValue = require('./doublePropertyValue');
exports.StringPropertyValue = require('./stringPropertyValue');
exports.GuidPropertyValue = require('./guidPropertyValue');
exports.PropertyMetadata = require('./propertyMetadata');
exports.PropertyInfo = require('./propertyInfo');
exports.PagedPropertyInfoList = require('./pagedPropertyInfoList');
exports.PropertyDescription = require('./propertyDescription');
exports.PropertyBatchOperation = require('./propertyBatchOperation');
exports.PropertyBatchDescriptionList = require('./propertyBatchDescriptionList');
exports.CheckExistsPropertyBatchOperation = require('./checkExistsPropertyBatchOperation');
exports.CheckSequencePropertyBatchOperation = require('./checkSequencePropertyBatchOperation');
exports.CheckValuePropertyBatchOperation = require('./checkValuePropertyBatchOperation');
exports.DeletePropertyBatchOperation = require('./deletePropertyBatchOperation');
exports.GetPropertyBatchOperation = require('./getPropertyBatchOperation');
exports.PutPropertyBatchOperation = require('./putPropertyBatchOperation');
exports.PropertyBatchInfo = require('./propertyBatchInfo');
exports.SuccessfulPropertyBatchInfo = require('./successfulPropertyBatchInfo');
exports.FailedPropertyBatchInfo = require('./failedPropertyBatchInfo');
exports.BackupScheduleDescription = require('./backupScheduleDescription');
exports.BackupStorageDescription = require('./backupStorageDescription');
exports.RetentionPolicyDescription = require('./retentionPolicyDescription');
exports.BackupPolicyDescription = require('./backupPolicyDescription');
exports.PagedBackupPolicyDescriptionList = require('./pagedBackupPolicyDescriptionList');
exports.BasicRetentionPolicyDescription = require('./basicRetentionPolicyDescription');
exports.DisableBackupDescription = require('./disableBackupDescription');
exports.BackupConfigurationInfo = require('./backupConfigurationInfo');
exports.ApplicationBackupConfigurationInfo = require('./applicationBackupConfigurationInfo');
exports.ServiceBackupConfigurationInfo = require('./serviceBackupConfigurationInfo');
exports.BackupSuspensionInfo = require('./backupSuspensionInfo');
exports.PagedBackupConfigurationInfoList = require('./pagedBackupConfigurationInfoList');
exports.RestorePartitionDescription = require('./restorePartitionDescription');
exports.RestoreProgressInfo = require('./restoreProgressInfo');
exports.BackupPartitionDescription = require('./backupPartitionDescription');
exports.BackupInfo = require('./backupInfo');
exports.PagedBackupInfoList = require('./pagedBackupInfoList');
exports.AzureBlobBackupStorageDescription = require('./azureBlobBackupStorageDescription');
exports.FileShareBackupStorageDescription = require('./fileShareBackupStorageDescription');
exports.FrequencyBasedBackupScheduleDescription = require('./frequencyBasedBackupScheduleDescription');
exports.TimeBasedBackupScheduleDescription = require('./timeBasedBackupScheduleDescription');
exports.BackupProgressInfo = require('./backupProgressInfo');
exports.PartitionBackupConfigurationInfo = require('./partitionBackupConfigurationInfo');
exports.BackupEntity = require('./backupEntity');
exports.ApplicationBackupEntity = require('./applicationBackupEntity');
exports.ServiceBackupEntity = require('./serviceBackupEntity');
exports.PartitionBackupEntity = require('./partitionBackupEntity');
exports.EnableBackupDescription = require('./enableBackupDescription');
exports.PagedBackupEntityList = require('./pagedBackupEntityList');
exports.GetBackupByStorageQueryDescription = require('./getBackupByStorageQueryDescription');
exports.NodeImpact = require('./nodeImpact');
exports.RepairImpactDescriptionBase = require('./repairImpactDescriptionBase');
exports.NodeRepairImpactDescription = require('./nodeRepairImpactDescription');
exports.RepairTargetDescriptionBase = require('./repairTargetDescriptionBase');
exports.NodeRepairTargetDescription = require('./nodeRepairTargetDescription');
exports.RepairTaskHistory = require('./repairTaskHistory');
exports.RepairTask = require('./repairTask');
exports.RepairTaskApproveDescription = require('./repairTaskApproveDescription');
exports.RepairTaskCancelDescription = require('./repairTaskCancelDescription');
exports.RepairTaskDeleteDescription = require('./repairTaskDeleteDescription');
exports.RepairTaskUpdateHealthPolicyDescription = require('./repairTaskUpdateHealthPolicyDescription');
exports.RepairTaskUpdateInfo = require('./repairTaskUpdateInfo');
exports.UploadChunkRange = require('./uploadChunkRange');
exports.UploadSessionInfo = require('./uploadSessionInfo');
exports.UploadSession = require('./uploadSession');
exports.AveragePartitionLoadScalingTrigger = require('./averagePartitionLoadScalingTrigger');
exports.AverageServiceLoadScalingTrigger = require('./averageServiceLoadScalingTrigger');
exports.PartitionInstanceCountScaleMechanism = require('./partitionInstanceCountScaleMechanism');
exports.AddRemoveIncrementalNamedPartitionScalingMechanism = require('./addRemoveIncrementalNamedPartitionScalingMechanism');
exports.ApplicationCreatedEvent = require('./applicationCreatedEvent');
exports.ApplicationDeletedEvent = require('./applicationDeletedEvent');
exports.ApplicationNewHealthReportEvent = require('./applicationNewHealthReportEvent');
exports.ApplicationHealthReportExpiredEvent = require('./applicationHealthReportExpiredEvent');
exports.ApplicationUpgradeCompletedEvent = require('./applicationUpgradeCompletedEvent');
exports.ApplicationUpgradeDomainCompletedEvent = require('./applicationUpgradeDomainCompletedEvent');
exports.ApplicationUpgradeRollbackCompletedEvent = require('./applicationUpgradeRollbackCompletedEvent');
exports.ApplicationUpgradeRollbackStartedEvent = require('./applicationUpgradeRollbackStartedEvent');
exports.ApplicationUpgradeStartedEvent = require('./applicationUpgradeStartedEvent');
exports.DeployedApplicationNewHealthReportEvent = require('./deployedApplicationNewHealthReportEvent');
exports.DeployedApplicationHealthReportExpiredEvent = require('./deployedApplicationHealthReportExpiredEvent');
exports.ApplicationProcessExitedEvent = require('./applicationProcessExitedEvent');
exports.ApplicationContainerInstanceExitedEvent = require('./applicationContainerInstanceExitedEvent');
exports.NodeAbortedEvent = require('./nodeAbortedEvent');
exports.NodeAddedToClusterEvent = require('./nodeAddedToClusterEvent');
exports.NodeClosedEvent = require('./nodeClosedEvent');
exports.NodeDeactivateCompletedEvent = require('./nodeDeactivateCompletedEvent');
exports.NodeDeactivateStartedEvent = require('./nodeDeactivateStartedEvent');
exports.NodeDownEvent = require('./nodeDownEvent');
exports.NodeNewHealthReportEvent = require('./nodeNewHealthReportEvent');
exports.NodeHealthReportExpiredEvent = require('./nodeHealthReportExpiredEvent');
exports.NodeOpenSucceededEvent = require('./nodeOpenSucceededEvent');
exports.NodeOpenFailedEvent = require('./nodeOpenFailedEvent');
exports.NodeRemovedFromClusterEvent = require('./nodeRemovedFromClusterEvent');
exports.NodeUpEvent = require('./nodeUpEvent');
exports.PartitionNewHealthReportEvent = require('./partitionNewHealthReportEvent');
exports.PartitionHealthReportExpiredEvent = require('./partitionHealthReportExpiredEvent');
exports.PartitionReconfiguredEvent = require('./partitionReconfiguredEvent');
exports.PartitionPrimaryMoveAnalysisEvent = require('./partitionPrimaryMoveAnalysisEvent');
exports.ServiceCreatedEvent = require('./serviceCreatedEvent');
exports.ServiceDeletedEvent = require('./serviceDeletedEvent');
exports.ServiceNewHealthReportEvent = require('./serviceNewHealthReportEvent');
exports.ServiceHealthReportExpiredEvent = require('./serviceHealthReportExpiredEvent');
exports.DeployedServicePackageNewHealthReportEvent = require('./deployedServicePackageNewHealthReportEvent');
exports.DeployedServicePackageHealthReportExpiredEvent = require('./deployedServicePackageHealthReportExpiredEvent');
exports.StatefulReplicaNewHealthReportEvent = require('./statefulReplicaNewHealthReportEvent');
exports.StatefulReplicaHealthReportExpiredEvent = require('./statefulReplicaHealthReportExpiredEvent');
exports.StatelessReplicaNewHealthReportEvent = require('./statelessReplicaNewHealthReportEvent');
exports.StatelessReplicaHealthReportExpiredEvent = require('./statelessReplicaHealthReportExpiredEvent');
exports.ClusterNewHealthReportEvent = require('./clusterNewHealthReportEvent');
exports.ClusterHealthReportExpiredEvent = require('./clusterHealthReportExpiredEvent');
exports.ClusterUpgradeCompletedEvent = require('./clusterUpgradeCompletedEvent');
exports.ClusterUpgradeDomainCompletedEvent = require('./clusterUpgradeDomainCompletedEvent');
exports.ClusterUpgradeRollbackCompletedEvent = require('./clusterUpgradeRollbackCompletedEvent');
exports.ClusterUpgradeRollbackStartedEvent = require('./clusterUpgradeRollbackStartedEvent');
exports.ClusterUpgradeStartedEvent = require('./clusterUpgradeStartedEvent');
exports.ChaosStoppedEvent = require('./chaosStoppedEvent');
exports.ChaosStartedEvent = require('./chaosStartedEvent');
exports.ChaosCodePackageRestartScheduledEvent = require('./chaosCodePackageRestartScheduledEvent');
exports.ChaosReplicaRemovalScheduledEvent = require('./chaosReplicaRemovalScheduledEvent');
exports.ChaosPartitionSecondaryMoveScheduledEvent = require('./chaosPartitionSecondaryMoveScheduledEvent');
exports.ChaosPartitionPrimaryMoveScheduledEvent = require('./chaosPartitionPrimaryMoveScheduledEvent');
exports.ChaosReplicaRestartScheduledEvent = require('./chaosReplicaRestartScheduledEvent');
exports.ChaosNodeRestartScheduledEvent = require('./chaosNodeRestartScheduledEvent');
exports.SecretResourcePropertiesBase = require('./secretResourcePropertiesBase');
exports.SecretResourceProperties = require('./secretResourceProperties');
exports.InlinedValueSecretResourceProperties = require('./inlinedValueSecretResourceProperties');
exports.SecretResourceDescription = require('./secretResourceDescription');
exports.PagedSecretResourceDescriptionList = require('./pagedSecretResourceDescriptionList');
exports.SecretValue = require('./secretValue');
exports.SecretValueProperties = require('./secretValueProperties');
exports.SecretValueResourceDescription = require('./secretValueResourceDescription');
exports.PagedSecretValueResourceDescriptionList = require('./pagedSecretValueResourceDescriptionList');
exports.VolumeProviderParametersAzureFile = require('./volumeProviderParametersAzureFile');
exports.VolumeReference = require('./volumeReference');
exports.ApplicationScopedVolumeCreationParameters = require('./applicationScopedVolumeCreationParameters');
exports.ApplicationScopedVolume = require('./applicationScopedVolume');
exports.ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk = require('./applicationScopedVolumeCreationParametersServiceFabricVolumeDisk');
exports.VolumeResourceDescription = require('./volumeResourceDescription');
exports.PagedVolumeResourceDescriptionList = require('./pagedVolumeResourceDescriptionList');
exports.NetworkResourcePropertiesBase = require('./networkResourcePropertiesBase');
exports.NetworkResourceProperties = require('./networkResourceProperties');
exports.LocalNetworkResourceProperties = require('./localNetworkResourceProperties');
exports.EndpointRef = require('./endpointRef');
exports.NetworkRef = require('./networkRef');
exports.NetworkResourceDescription = require('./networkResourceDescription');
exports.PagedNetworkResourceDescriptionList = require('./pagedNetworkResourceDescriptionList');
exports.GatewayDestination = require('./gatewayDestination');
exports.TcpConfig = require('./tcpConfig');
exports.HttpRouteMatchPath = require('./httpRouteMatchPath');
exports.HttpRouteMatchHeader = require('./httpRouteMatchHeader');
exports.HttpRouteMatchRule = require('./httpRouteMatchRule');
exports.HttpRouteConfig = require('./httpRouteConfig');
exports.HttpHostConfig = require('./httpHostConfig');
exports.HttpConfig = require('./httpConfig');
exports.GatewayResourceDescription = require('./gatewayResourceDescription');
exports.PagedGatewayResourceDescriptionList = require('./pagedGatewayResourceDescriptionList');
exports.ImageRegistryCredential = require('./imageRegistryCredential');
exports.EnvironmentVariable = require('./environmentVariable');
exports.Setting = require('./setting');
exports.ContainerLabel = require('./containerLabel');
exports.EndpointProperties = require('./endpointProperties');
exports.ResourceRequests = require('./resourceRequests');
exports.ResourceLimits = require('./resourceLimits');
exports.ResourceRequirements = require('./resourceRequirements');
exports.DiagnosticsRef = require('./diagnosticsRef');
exports.ReliableCollectionsRef = require('./reliableCollectionsRef');
exports.ContainerState = require('./containerState');
exports.ContainerEvent = require('./containerEvent');
exports.ContainerInstanceView = require('./containerInstanceView');
exports.ContainerCodePackageProperties = require('./containerCodePackageProperties');
exports.AutoScalingTrigger = require('./autoScalingTrigger');
exports.AutoScalingMechanism = require('./autoScalingMechanism');
exports.AutoScalingPolicy = require('./autoScalingPolicy');
exports.ServiceResourceDescription = require('./serviceResourceDescription');
exports.DiagnosticsSinkProperties = require('./diagnosticsSinkProperties');
exports.DiagnosticsDescription = require('./diagnosticsDescription');
exports.AzureInternalMonitoringPipelineSinkDescription = require('./azureInternalMonitoringPipelineSinkDescription');
exports.AddRemoveReplicaScalingMechanism = require('./addRemoveReplicaScalingMechanism');
exports.AutoScalingMetric = require('./autoScalingMetric');
exports.AutoScalingResourceMetric = require('./autoScalingResourceMetric');
exports.ServiceProperties = require('./serviceProperties');
exports.ServiceReplicaProperties = require('./serviceReplicaProperties');
exports.ServiceReplicaDescription = require('./serviceReplicaDescription');
exports.AverageLoadScalingTrigger = require('./averageLoadScalingTrigger');
exports.PagedServiceResourceDescriptionList = require('./pagedServiceResourceDescriptionList');
exports.PagedServiceReplicaDescriptionList = require('./pagedServiceReplicaDescriptionList');
exports.ApplicationResourceDescription = require('./applicationResourceDescription');
exports.PagedApplicationResourceDescriptionList = require('./pagedApplicationResourceDescriptionList');
exports.discriminators = {
  'FabricEvent.ApplicationEvent' : exports.ApplicationEvent,
  'HealthEvaluation' : exports.HealthEvaluation,
  'HealthEvaluation.Application' : exports.ApplicationHealthEvaluation,
  'HealthEvaluation.Applications' : exports.ApplicationsHealthEvaluation,
  'HealthEvaluation.ApplicationTypeApplications' : exports.ApplicationTypeApplicationsHealthEvaluation,
  'SafetyCheck' : exports.SafetyCheck,
  'FabricEvent.ClusterEvent' : exports.ClusterEvent,
  'FabricEvent.ContainerInstanceEvent' : exports.ContainerInstanceEvent,
  'HealthEvaluation.DeltaNodesCheck' : exports.DeltaNodesCheckHealthEvaluation,
  'HealthEvaluation.DeployedApplication' : exports.DeployedApplicationHealthEvaluation,
  'HealthEvaluation.DeployedApplications' : exports.DeployedApplicationsHealthEvaluation,
  'HealthEvaluation.DeployedServicePackage' : exports.DeployedServicePackageHealthEvaluation,
  'HealthEvaluation.DeployedServicePackages' : exports.DeployedServicePackagesHealthEvaluation,
  'DeployedServiceReplicaInfo' : exports.DeployedServiceReplicaInfo,
  'DeployedServiceReplicaInfo.Stateful' : exports.DeployedStatefulServiceReplicaInfo,
  'DeployedServiceReplicaInfo.Stateless' : exports.DeployedStatelessServiceInstanceInfo,
  'HealthEvaluation.Event' : exports.EventHealthEvaluation,
  'FabricEvent' : exports.FabricEvent,
  'PartitionInformation.Int64Range' : exports.Int64RangePartitionInformation,
  'PartitionInformation.Named' : exports.NamedPartitionInformation,
  'FabricEvent.NodeEvent' : exports.NodeEvent,
  'HealthEvaluation.Node' : exports.NodeHealthEvaluation,
  'HealthEvaluation.Nodes' : exports.NodesHealthEvaluation,
  'PartitionInformation' : exports.PartitionInformation,
  'ServicePartitionInfo' : exports.ServicePartitionInfo,
  'ReplicaInfo' : exports.ReplicaInfo,
  'ServiceInfo' : exports.ServiceInfo,
  'FabricEvent.PartitionAnalysisEvent' : exports.PartitionAnalysisEvent,
  'FabricEvent.PartitionEvent' : exports.PartitionEvent,
  'EntityHealthState.ReplicaHealthState' : exports.ReplicaHealthState,
  'HealthEvaluation.Partition' : exports.PartitionHealthEvaluation,
  'ProvisionApplicationTypeDescriptionBase' : exports.ProvisionApplicationTypeDescriptionBase,
  'ProvisionApplicationTypeDescriptionBase.ImageStorePath' : exports.ProvisionApplicationTypeDescription,
  'ProvisionApplicationTypeDescriptionBase.ExternalStore' : exports.ExternalStoreProvisionApplicationTypeDescription,
  'SafetyCheck.PartitionSafetyCheck' : exports.PartitionSafetyCheck,
  'SafetyCheck.EnsureAvailability' : exports.EnsureAvailabilitySafetyCheck,
  'SafetyCheck.EnsurePartitionQuorum' : exports.EnsurePartitionQurumSafetyCheck,
  'SafetyCheck.EnsureSeedNodeQuorum' : exports.SeedNodeSafetyCheck,
  'HealthEvaluation.Partitions' : exports.PartitionsHealthEvaluation,
  'FabricEvent.ReplicaEvent' : exports.ReplicaEvent,
  'EntityHealth.ReplicaHealth' : exports.ReplicaHealth,
  'HealthEvaluation.Replica' : exports.ReplicaHealthEvaluation,
  'HealthEvaluation.Replicas' : exports.ReplicasHealthEvaluation,
  'FabricEvent.ServiceEvent' : exports.ServiceEvent,
  'HealthEvaluation.Service' : exports.ServiceHealthEvaluation,
  'ServicePlacementPolicyDescription.InvalidDomain' : exports.ServicePlacementInvalidDomainPolicyDescription,
  'ServicePlacementPolicyDescription.NonPartiallyPlaceService' : exports.ServicePlacementNonPartiallyPlaceServicePolicyDescription,
  'ServicePlacementPolicyDescription' : exports.ServicePlacementPolicyDescription,
  'ServicePlacementPolicyDescription.PreferredPrimaryDomain' : exports.ServicePlacementPreferPrimaryDomainPolicyDescription,
  'ServicePlacementPolicyDescription.RequiredDomain' : exports.ServicePlacementRequiredDomainPolicyDescription,
  'ServicePlacementPolicyDescription.RequiredDomainDistribution' : exports.ServicePlacementRequireDomainDistributionPolicyDescription,
  'HealthEvaluation.Services' : exports.ServicesHealthEvaluation,
  'ServiceTypeDescription' : exports.ServiceTypeDescription,
  'PartitionInformation.Singleton' : exports.SingletonPartitionInformation,
  'ServiceInfo.Stateful' : exports.StatefulServiceInfo,
  'ServicePartitionInfo.Stateful' : exports.StatefulServicePartitionInfo,
  'EntityHealth.Stateful' : exports.StatefulServiceReplicaHealth,
  'EntityHealthState.Stateful' : exports.StatefulServiceReplicaHealthState,
  'ServiceTypeDescription.Stateful' : exports.StatefulServiceTypeDescription,
  'ServiceInfo.Stateless' : exports.StatelessServiceInfo,
  'EntityHealth.Stateless' : exports.StatelessServiceInstanceHealth,
  'EntityHealthState.Stateless' : exports.StatelessServiceInstanceHealthState,
  'ServicePartitionInfo.Stateless' : exports.StatelessServicePartitionInfo,
  'ServiceTypeDescription.Stateless' : exports.StatelessServiceTypeDescription,
  'HealthEvaluation.SystemApplication' : exports.SystemApplicationHealthEvaluation,
  'HealthEvaluation.UpgradeDomainDeltaNodesCheck' : exports.UpgradeDomainDeltaNodesCheckHealthEvaluation,
  'HealthEvaluation.UpgradeDomainNodes' : exports.UpgradeDomainNodesHealthEvaluation,
  'SafetyCheck.WaitForInbuildReplica' : exports.WaitForInbuildReplicaSafetyCheck,
  'SafetyCheck.WaitForPrimaryPlacement' : exports.WaitForPrimaryPlacementSafetyCheck,
  'SafetyCheck.WaitForPrimarySwap' : exports.WaitForPrimarySwapSafetyCheck,
  'SafetyCheck.WaitForReconfiguration' : exports.WaitForReconfigurationSafetyCheck,
  'ReplicaInfo.Stateful' : exports.StatefulServiceReplicaInfo,
  'ReplicaInfo.Stateless' : exports.StatelessServiceInstanceInfo,
  'ChaosEvent' : exports.ChaosEvent,
  'ChaosEvent.ExecutingFaults' : exports.ExecutingFaultsChaosEvent,
  'ChaosEvent.Started' : exports.StartedChaosEvent,
  'ChaosEvent.Stopped' : exports.StoppedChaosEvent,
  'ChaosEvent.TestError' : exports.TestErrorChaosEvent,
  'ChaosEvent.ValidationFailed' : exports.ValidationFailedChaosEvent,
  'ChaosEvent.Waiting' : exports.WaitingChaosEvent,
  'PartitionSchemeDescription' : exports.PartitionSchemeDescription,
  'PartitionSchemeDescription.Named' : exports.NamedPartitionSchemeDescription,
  'PartitionSchemeDescription.Singleton' : exports.SingletonPartitionSchemeDescription,
  'PartitionSchemeDescription.UniformInt64Range' : exports.UniformInt64RangePartitionSchemeDescription,
  'ScalingTriggerDescription' : exports.ScalingTriggerDescription,
  'ScalingMechanismDescription' : exports.ScalingMechanismDescription,
  'ServiceDescription' : exports.ServiceDescription,
  'ServiceDescription.Stateful' : exports.StatefulServiceDescription,
  'ServiceDescription.Stateless' : exports.StatelessServiceDescription,
  'ReplicatorStatus' : exports.ReplicatorStatus,
  'ReplicatorStatus.Primary' : exports.PrimaryReplicatorStatus,
  'ReplicatorStatus.SecondaryReplicatorStatus' : exports.SecondaryReplicatorStatus,
  'ReplicatorStatus.ActiveSecondary' : exports.SecondaryActiveReplicatorStatus,
  'ReplicatorStatus.IdleSecondary' : exports.SecondaryIdleReplicatorStatus,
  'DeployedServiceReplicaDetailInfo' : exports.DeployedServiceReplicaDetailInfo,
  'ReplicaStatusBase.KeyValueStore' : exports.KeyValueStoreReplicaStatus,
  'DeployedServiceReplicaDetailInfo.Stateful' : exports.DeployedStatefulServiceReplicaDetailInfo,
  'DeployedServiceReplicaDetailInfo.Stateless' : exports.DeployedStatelessServiceInstanceDetailInfo,
  'ReplicaStatusBase' : exports.ReplicaStatusBase,
  'ServiceUpdateDescription' : exports.ServiceUpdateDescription,
  'ServiceUpdateDescription.Stateful' : exports.StatefulServiceUpdateDescription,
  'ServiceUpdateDescription.Stateless' : exports.StatelessServiceUpdateDescription,
  'PropertyValue' : exports.PropertyValue,
  'PropertyValue.Binary' : exports.BinaryPropertyValue,
  'PropertyValue.Int64' : exports.Int64PropertyValue,
  'PropertyValue.Double' : exports.DoublePropertyValue,
  'PropertyValue.String' : exports.StringPropertyValue,
  'PropertyValue.Guid' : exports.GuidPropertyValue,
  'PropertyBatchOperation' : exports.PropertyBatchOperation,
  'PropertyBatchOperation.CheckExists' : exports.CheckExistsPropertyBatchOperation,
  'PropertyBatchOperation.CheckSequence' : exports.CheckSequencePropertyBatchOperation,
  'PropertyBatchOperation.CheckValue' : exports.CheckValuePropertyBatchOperation,
  'PropertyBatchOperation.Delete' : exports.DeletePropertyBatchOperation,
  'PropertyBatchOperation.Get' : exports.GetPropertyBatchOperation,
  'PropertyBatchOperation.Put' : exports.PutPropertyBatchOperation,
  'PropertyBatchInfo' : exports.PropertyBatchInfo,
  'PropertyBatchInfo.Successful' : exports.SuccessfulPropertyBatchInfo,
  'PropertyBatchInfo.Failed' : exports.FailedPropertyBatchInfo,
  'BackupScheduleDescription' : exports.BackupScheduleDescription,
  'BackupStorageDescription' : exports.BackupStorageDescription,
  'RetentionPolicyDescription' : exports.RetentionPolicyDescription,
  'RetentionPolicyDescription.Basic' : exports.BasicRetentionPolicyDescription,
  'BackupConfigurationInfo.Application' : exports.ApplicationBackupConfigurationInfo,
  'BackupConfigurationInfo.Service' : exports.ServiceBackupConfigurationInfo,
  'BackupConfigurationInfo' : exports.BackupConfigurationInfo,
  'BackupStorageDescription.AzureBlobStore' : exports.AzureBlobBackupStorageDescription,
  'BackupStorageDescription.FileShare' : exports.FileShareBackupStorageDescription,
  'BackupScheduleDescription.FrequencyBased' : exports.FrequencyBasedBackupScheduleDescription,
  'BackupScheduleDescription.TimeBased' : exports.TimeBasedBackupScheduleDescription,
  'BackupConfigurationInfo.Partition' : exports.PartitionBackupConfigurationInfo,
  'BackupEntity' : exports.BackupEntity,
  'BackupEntity.Application' : exports.ApplicationBackupEntity,
  'BackupEntity.Service' : exports.ServiceBackupEntity,
  'BackupEntity.Partition' : exports.PartitionBackupEntity,
  'RepairImpactDescriptionBase.Node' : exports.NodeRepairImpactDescription,
  'RepairTargetDescriptionBase.Node' : exports.NodeRepairTargetDescription,
  'RepairImpactDescriptionBase' : exports.RepairImpactDescriptionBase,
  'RepairTargetDescriptionBase' : exports.RepairTargetDescriptionBase,
  'ScalingTriggerDescription.AveragePartitionLoad' : exports.AveragePartitionLoadScalingTrigger,
  'ScalingTriggerDescription.AverageServiceLoad' : exports.AverageServiceLoadScalingTrigger,
  'ScalingMechanismDescription.PartitionInstanceCount' : exports.PartitionInstanceCountScaleMechanism,
  'ScalingMechanismDescription.AddRemoveIncrementalNamedPartition' : exports.AddRemoveIncrementalNamedPartitionScalingMechanism,
  'FabricEvent.ApplicationCreated' : exports.ApplicationCreatedEvent,
  'FabricEvent.ApplicationDeleted' : exports.ApplicationDeletedEvent,
  'FabricEvent.ApplicationNewHealthReport' : exports.ApplicationNewHealthReportEvent,
  'FabricEvent.ApplicationHealthReportExpired' : exports.ApplicationHealthReportExpiredEvent,
  'FabricEvent.ApplicationUpgradeCompleted' : exports.ApplicationUpgradeCompletedEvent,
  'FabricEvent.ApplicationUpgradeDomainCompleted' : exports.ApplicationUpgradeDomainCompletedEvent,
  'FabricEvent.ApplicationUpgradeRollbackCompleted' : exports.ApplicationUpgradeRollbackCompletedEvent,
  'FabricEvent.ApplicationUpgradeRollbackStarted' : exports.ApplicationUpgradeRollbackStartedEvent,
  'FabricEvent.ApplicationUpgradeStarted' : exports.ApplicationUpgradeStartedEvent,
  'FabricEvent.DeployedApplicationNewHealthReport' : exports.DeployedApplicationNewHealthReportEvent,
  'FabricEvent.DeployedApplicationHealthReportExpired' : exports.DeployedApplicationHealthReportExpiredEvent,
  'FabricEvent.ApplicationProcessExited' : exports.ApplicationProcessExitedEvent,
  'FabricEvent.ApplicationContainerInstanceExited' : exports.ApplicationContainerInstanceExitedEvent,
  'FabricEvent.NodeAborted' : exports.NodeAbortedEvent,
  'FabricEvent.NodeAddedToCluster' : exports.NodeAddedToClusterEvent,
  'FabricEvent.NodeClosed' : exports.NodeClosedEvent,
  'FabricEvent.NodeDeactivateCompleted' : exports.NodeDeactivateCompletedEvent,
  'FabricEvent.NodeDeactivateStarted' : exports.NodeDeactivateStartedEvent,
  'FabricEvent.NodeDown' : exports.NodeDownEvent,
  'FabricEvent.NodeNewHealthReport' : exports.NodeNewHealthReportEvent,
  'FabricEvent.NodeHealthReportExpired' : exports.NodeHealthReportExpiredEvent,
  'FabricEvent.NodeOpenSucceeded' : exports.NodeOpenSucceededEvent,
  'FabricEvent.NodeOpenFailed' : exports.NodeOpenFailedEvent,
  'FabricEvent.NodeRemovedFromCluster' : exports.NodeRemovedFromClusterEvent,
  'FabricEvent.NodeUp' : exports.NodeUpEvent,
  'FabricEvent.PartitionNewHealthReport' : exports.PartitionNewHealthReportEvent,
  'FabricEvent.PartitionHealthReportExpired' : exports.PartitionHealthReportExpiredEvent,
  'FabricEvent.PartitionReconfigured' : exports.PartitionReconfiguredEvent,
  'FabricEvent.PartitionPrimaryMoveAnalysis' : exports.PartitionPrimaryMoveAnalysisEvent,
  'FabricEvent.ServiceCreated' : exports.ServiceCreatedEvent,
  'FabricEvent.ServiceDeleted' : exports.ServiceDeletedEvent,
  'FabricEvent.ServiceNewHealthReport' : exports.ServiceNewHealthReportEvent,
  'FabricEvent.ServiceHealthReportExpired' : exports.ServiceHealthReportExpiredEvent,
  'FabricEvent.DeployedServicePackageNewHealthReport' : exports.DeployedServicePackageNewHealthReportEvent,
  'FabricEvent.DeployedServicePackageHealthReportExpired' : exports.DeployedServicePackageHealthReportExpiredEvent,
  'FabricEvent.StatefulReplicaNewHealthReport' : exports.StatefulReplicaNewHealthReportEvent,
  'FabricEvent.StatefulReplicaHealthReportExpired' : exports.StatefulReplicaHealthReportExpiredEvent,
  'FabricEvent.StatelessReplicaNewHealthReport' : exports.StatelessReplicaNewHealthReportEvent,
  'FabricEvent.StatelessReplicaHealthReportExpired' : exports.StatelessReplicaHealthReportExpiredEvent,
  'FabricEvent.ClusterNewHealthReport' : exports.ClusterNewHealthReportEvent,
  'FabricEvent.ClusterHealthReportExpired' : exports.ClusterHealthReportExpiredEvent,
  'FabricEvent.ClusterUpgradeCompleted' : exports.ClusterUpgradeCompletedEvent,
  'FabricEvent.ClusterUpgradeDomainCompleted' : exports.ClusterUpgradeDomainCompletedEvent,
  'FabricEvent.ClusterUpgradeRollbackCompleted' : exports.ClusterUpgradeRollbackCompletedEvent,
  'FabricEvent.ClusterUpgradeRollbackStarted' : exports.ClusterUpgradeRollbackStartedEvent,
  'FabricEvent.ClusterUpgradeStarted' : exports.ClusterUpgradeStartedEvent,
  'FabricEvent.ChaosStopped' : exports.ChaosStoppedEvent,
  'FabricEvent.ChaosStarted' : exports.ChaosStartedEvent,
  'FabricEvent.ChaosCodePackageRestartScheduled' : exports.ChaosCodePackageRestartScheduledEvent,
  'FabricEvent.ChaosReplicaRemovalScheduled' : exports.ChaosReplicaRemovalScheduledEvent,
  'FabricEvent.ChaosPartitionSecondaryMoveScheduled' : exports.ChaosPartitionSecondaryMoveScheduledEvent,
  'FabricEvent.ChaosPartitionPrimaryMoveScheduled' : exports.ChaosPartitionPrimaryMoveScheduledEvent,
  'FabricEvent.ChaosReplicaRestartScheduled' : exports.ChaosReplicaRestartScheduledEvent,
  'FabricEvent.ChaosNodeRestartScheduled' : exports.ChaosNodeRestartScheduledEvent,
  'SecretResourcePropertiesBase.SecretResourceProperties' : exports.SecretResourceProperties,
  'SecretResourcePropertiesBase.inlinedValue' : exports.InlinedValueSecretResourceProperties,
  'SecretResourcePropertiesBase' : exports.SecretResourcePropertiesBase,
  'ApplicationScopedVolumeCreationParameters' : exports.ApplicationScopedVolumeCreationParameters,
  'ApplicationScopedVolumeCreationParameters.ServiceFabricVolumeDisk' : exports.ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk,
  'NetworkResourcePropertiesBase.NetworkResourceProperties' : exports.NetworkResourceProperties,
  'NetworkResourcePropertiesBase.Local' : exports.LocalNetworkResourceProperties,
  'NetworkResourcePropertiesBase' : exports.NetworkResourcePropertiesBase,
  'AutoScalingTrigger' : exports.AutoScalingTrigger,
  'AutoScalingMechanism' : exports.AutoScalingMechanism,
  'DiagnosticsSinkProperties' : exports.DiagnosticsSinkProperties,
  'DiagnosticsSinkProperties.AzureInternalMonitoringPipeline' : exports.AzureInternalMonitoringPipelineSinkDescription,
  'AutoScalingMechanism.AddRemoveReplica' : exports.AddRemoveReplicaScalingMechanism,
  'AutoScalingMetric' : exports.AutoScalingMetric,
  'AutoScalingMetric.Resource' : exports.AutoScalingResourceMetric,
  'AutoScalingTrigger.AverageLoad' : exports.AverageLoadScalingTrigger
};
