/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Node Deactivate Started event.
 *
 * @extends models['NodeEvent']
 */
class NodeDeactivateStartedEvent extends models['NodeEvent'] {
  /**
   * Create a NodeDeactivateStartedEvent.
   * @property {number} nodeInstance Id of Node instance.
   * @property {string} batchId Batch Id.
   * @property {string} deactivateIntent Describes deactivate intent.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of NodeDeactivateStartedEvent
   *
   * @returns {object} metadata of NodeDeactivateStartedEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeDeactivateStarted',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'NodeDeactivateStartedEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'Category',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          nodeName: {
            required: true,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          nodeInstance: {
            required: true,
            serializedName: 'NodeInstance',
            type: {
              name: 'Number'
            }
          },
          batchId: {
            required: true,
            serializedName: 'BatchId',
            type: {
              name: 'String'
            }
          },
          deactivateIntent: {
            required: true,
            serializedName: 'DeactivateIntent',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NodeDeactivateStartedEvent;
