/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The list of compose deployments in the cluster. The list is paged when all
 * of the results cannot fit in a single message. The next set of results can
 * be obtained by executing the same query with the continuation token provided
 * in this list.
 *
 */
class PagedComposeDeploymentStatusInfoList {
  /**
   * Create a PagedComposeDeploymentStatusInfoList.
   * @property {string} [continuationToken] The continuation token parameter is
   * used to obtain next set of results. The continuation token is included in
   * the response of the API when the results from the system do not fit in a
   * single response. When this value is passed to the next API call, the API
   * returns next set of results. If there are no further results, then the
   * continuation token is not included in the response.
   * @property {array} [items] List of compose deployment status information.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PagedComposeDeploymentStatusInfoList
   *
   * @returns {object} metadata of PagedComposeDeploymentStatusInfoList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PagedComposeDeploymentStatusInfoList',
      type: {
        name: 'Composite',
        className: 'PagedComposeDeploymentStatusInfoList',
        modelProperties: {
          continuationToken: {
            required: false,
            serializedName: 'ContinuationToken',
            type: {
              name: 'String'
            }
          },
          items: {
            required: false,
            serializedName: 'Items',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ComposeDeploymentStatusInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'ComposeDeploymentStatusInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PagedComposeDeploymentStatusInfoList;
