/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the base for all Partition Analysis Events.
 *
 * @extends models['PartitionEvent']
 */
class PartitionAnalysisEvent extends models['PartitionEvent'] {
  /**
   * Create a PartitionAnalysisEvent.
   * @property {object} metadata Metadata about an Analysis Event.
   * @property {moment.duration} [metadata.delay] The analysis delay.
   * @property {moment.duration} [metadata.duration] The duration of analysis.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PartitionAnalysisEvent
   *
   * @returns {object} metadata of PartitionAnalysisEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionAnalysisEvent',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'PartitionAnalysisEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'Category',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: true,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: true,
            serializedName: 'Metadata',
            type: {
              name: 'Composite',
              className: 'AnalysisEventMetadata'
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionAnalysisEvent;
