/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Partition Primary Move Analysis event.
 *
 * @extends models['PartitionAnalysisEvent']
 */
class PartitionPrimaryMoveAnalysisEvent extends models['PartitionAnalysisEvent'] {
  /**
   * Create a PartitionPrimaryMoveAnalysisEvent.
   * @property {date} whenMoveCompleted Time when the move was completed.
   * @property {string} previousNode The name of a Service Fabric node.
   * @property {string} currentNode The name of a Service Fabric node.
   * @property {string} moveReason Move reason.
   * @property {string} relevantTraces Relevant traces.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PartitionPrimaryMoveAnalysisEvent
   *
   * @returns {object} metadata of PartitionPrimaryMoveAnalysisEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PartitionPrimaryMoveAnalysis',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'PartitionPrimaryMoveAnalysisEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'Category',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          partitionId: {
            required: true,
            serializedName: 'PartitionId',
            type: {
              name: 'String'
            }
          },
          metadata: {
            required: true,
            serializedName: 'Metadata',
            type: {
              name: 'Composite',
              className: 'AnalysisEventMetadata'
            }
          },
          whenMoveCompleted: {
            required: true,
            serializedName: 'WhenMoveCompleted',
            type: {
              name: 'DateTime'
            }
          },
          previousNode: {
            required: true,
            serializedName: 'PreviousNode',
            type: {
              name: 'String'
            }
          },
          currentNode: {
            required: true,
            serializedName: 'CurrentNode',
            type: {
              name: 'String'
            }
          },
          moveReason: {
            required: true,
            serializedName: 'MoveReason',
            type: {
              name: 'String'
            }
          },
          relevantTraces: {
            required: true,
            serializedName: 'RelevantTraces',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PartitionPrimaryMoveAnalysisEvent;
