/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents the base for all Service Events.
 *
 * @extends models['FabricEvent']
 */
class ServiceEvent extends models['FabricEvent'] {
  /**
   * Create a ServiceEvent.
   * @property {string} serviceId The identity of the service. This ID is an
   * encoded representation of the service name. This is used in the REST APIs
   * to identify the service resource.
   * Starting in version 6.0, hierarchical names are delimited with the "\~"
   * character. For example, if the service name is "fabric:/myapp/app1/svc1",
   * the service identity would be "myapp~app1\~svc1" in 6.0+ and
   * "myapp/app1/svc1" in previous versions.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceEvent
   *
   * @returns {object} metadata of ServiceEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceEvent',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ServiceEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'Category',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          serviceId: {
            required: true,
            serializedName: 'ServiceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceEvent;
