/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the operation to unregister or unprovision an application type and
 * its version that was registered with the Service Fabric.
 *
 */
class UnprovisionApplicationTypeDescriptionInfo {
  /**
   * Create a UnprovisionApplicationTypeDescriptionInfo.
   * @property {string} applicationTypeVersion The version of the application
   * type as defined in the application manifest.
   * @property {boolean} [async] The flag indicating whether or not unprovision
   * should occur asynchronously. When set to true, the unprovision operation
   * returns when the request is accepted by the system, and the unprovision
   * operation continues without any timeout limit. The default value is false.
   * However, we recommend setting it to true for large application packages
   * that were provisioned.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UnprovisionApplicationTypeDescriptionInfo
   *
   * @returns {object} metadata of UnprovisionApplicationTypeDescriptionInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UnprovisionApplicationTypeDescriptionInfo',
      type: {
        name: 'Composite',
        className: 'UnprovisionApplicationTypeDescriptionInfo',
        modelProperties: {
          applicationTypeVersion: {
            required: true,
            serializedName: 'ApplicationTypeVersion',
            type: {
              name: 'String'
            }
          },
          async: {
            required: false,
            serializedName: 'Async',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = UnprovisionApplicationTypeDescriptionInfo;
