/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a image store upload session
 *
 */
class UploadSession {
  /**
   * Create a UploadSession.
   * @property {array} [uploadSessions] When querying upload session by upload
   * session ID, the result contains only one upload session. When querying
   * upload session by image store relative path, the result might contain
   * multiple upload sessions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UploadSession
   *
   * @returns {object} metadata of UploadSession
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UploadSession',
      type: {
        name: 'Composite',
        className: 'UploadSession',
        modelProperties: {
          uploadSessions: {
            required: false,
            serializedName: 'UploadSessions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UploadSessionInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'UploadSessionInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = UploadSession;
