/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a reference to a volume resource.
 *
 */
class VolumeReference {
  /**
   * Create a VolumeReference.
   * @property {string} name Name of the volume being referenced.
   * @property {boolean} [readOnly] The flag indicating whether the volume is
   * read only. Default is 'false'.
   * @property {string} destinationPath The path within the container at which
   * the volume should be mounted. Only valid path characters are allowed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VolumeReference
   *
   * @returns {object} metadata of VolumeReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VolumeReference',
      type: {
        name: 'Composite',
        className: 'VolumeReference',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          readOnly: {
            required: false,
            serializedName: 'readOnly',
            type: {
              name: 'Boolean'
            }
          },
          destinationPath: {
            required: true,
            serializedName: 'destinationPath',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VolumeReference;
