/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an Azure Virtual Machine Scale Set
 *
 */
class AzureVmScaleSetConfiguration {
  /**
   * Create a AzureVmScaleSetConfiguration.
   * @member {string} [name] Virtual Machine Scale Set name
   * @member {string} [instanceId] Virtual Machine Scale Set instance
   * identifier
   * @member {string} [deployment] Virtual Machine Scale Set deployment
   * identifier
   * @member {string} [resourceId] Unique identifier of the resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureVmScaleSetConfiguration
   *
   * @returns {object} metadata of AzureVmScaleSetConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureVmScaleSetConfiguration',
      type: {
        name: 'Composite',
        className: 'AzureVmScaleSetConfiguration',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          instanceId: {
            required: false,
            serializedName: 'instanceId',
            type: {
              name: 'String'
            }
          },
          deployment: {
            required: false,
            serializedName: 'deployment',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureVmScaleSetConfiguration;
