/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * REST API operation supported by SignalR resource provider.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] Name of the operation with format:
   * {provider}/{resource}/{operation}
   * @member {object} [display] The object that describes the operation.
   * @member {string} [display.provider] Friendly name of the resource provider
   * @member {string} [display.resource] Resource type on which the operation
   * is performed.
   * @member {string} [display.operation] The localized friendly name for the
   * operation.
   * @member {string} [display.description] The localized friendly description
   * for the operation
   * @member {string} [origin] Optional. The intended executor of the
   * operation; governs the display of the operation in the RBAC UX and the
   * audit logs UX.
   * @member {object} [properties] Extra properties for the operation.
   * @member {object} [properties.serviceSpecification] The service
   * specifications.
   * @member {array} [properties.serviceSpecification.metricSpecifications]
   * Specifications of the Metrics for Azure Monitoring.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          },
          origin: {
            required: false,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'OperationProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
