/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A class represents the access keys of SignalR service.
 *
 */
class SignalRKeys {
  /**
   * Create a SignalRKeys.
   * @member {string} [primaryKey] The primary access key.
   * @member {string} [secondaryKey] The secondary access key.
   * @member {string} [primaryConnectionString] SignalR connection string
   * constructed via the primaryKey
   * @member {string} [secondaryConnectionString] SignalR connection string
   * constructed via the secondaryKey
   */
  constructor() {
  }

  /**
   * Defines the metadata of SignalRKeys
   *
   * @returns {object} metadata of SignalRKeys
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SignalRKeys',
      type: {
        name: 'Composite',
        className: 'SignalRKeys',
        modelProperties: {
          primaryKey: {
            required: false,
            serializedName: 'primaryKey',
            type: {
              name: 'String'
            }
          },
          secondaryKey: {
            required: false,
            serializedName: 'secondaryKey',
            type: {
              name: 'String'
            }
          },
          primaryConnectionString: {
            required: false,
            serializedName: 'primaryConnectionString',
            type: {
              name: 'String'
            }
          },
          secondaryConnectionString: {
            required: false,
            serializedName: 'secondaryConnectionString',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SignalRKeys;
