/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object that describes a specific usage of SignalR resources.
 *
 */
class SignalRUsage {
  /**
   * Create a SignalRUsage.
   * @member {string} [id] Fully qualified ARM resource id
   * @member {number} [currentValue] Current value for the usage quota.
   * @member {number} [limit] The maximum permitted value for the usage quota.
   * If there is no limit, this value will be -1.
   * @member {object} [name] Localizable String object containing the name and
   * a localized value.
   * @member {string} [name.value] The indentifier of the usage.
   * @member {string} [name.localizedValue] Localized name of the usage.
   * @member {string} [unit] Representing the units of the usage quota.
   * Possible values are: Count, Bytes, Seconds, Percent, CountPerSecond,
   * BytesPerSecond.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SignalRUsage
   *
   * @returns {object} metadata of SignalRUsage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SignalRUsage',
      type: {
        name: 'Composite',
        className: 'SignalRUsage',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          currentValue: {
            required: false,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          limit: {
            required: false,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'SignalRUsageName'
            }
          },
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SignalRUsage;
