/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The log size capability.
 *
 */
class LogSizeCapability {
  /**
   * Create a LogSizeCapability.
   * @property {number} [limit] The log size limit (see 'unit' for the units).
   * @property {string} [unit] The units that the limit is expressed in.
   * Possible values include: 'Megabytes', 'Gigabytes', 'Terabytes',
   * 'Petabytes', 'Percent'
   */
  constructor() {
  }

  /**
   * Defines the metadata of LogSizeCapability
   *
   * @returns {object} metadata of LogSizeCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogSizeCapability',
      type: {
        name: 'Composite',
        className: 'LogSizeCapability',
        modelProperties: {
          limit: {
            required: false,
            readOnly: true,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          unit: {
            required: false,
            readOnly: true,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LogSizeCapability;
