/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The managed instance virtual cores capability.
 *
 */
class ManagedInstanceVcoresCapability {
  /**
   * Create a ManagedInstanceVcoresCapability.
   * @property {string} [name] The virtual cores identifier.
   * @property {number} [value] The virtual cores value.
   * @property {string} [status] The status of the capability. Possible values
   * include: 'Visible', 'Available', 'Default', 'Disabled'
   * @property {string} [reason] The reason for the capability not being
   * available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedInstanceVcoresCapability
   *
   * @returns {object} metadata of ManagedInstanceVcoresCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedInstanceVcoresCapability',
      type: {
        name: 'Composite',
        className: 'ManagedInstanceVcoresCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            readOnly: true,
            serializedName: 'value',
            type: {
              name: 'Number'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedInstanceVcoresCapability;
