/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The managed instance capability
 *
 */
class ManagedInstanceVersionCapability {
  /**
   * Create a ManagedInstanceVersionCapability.
   * @property {string} [name] The server version name.
   * @property {array} [supportedEditions] The list of supported managed
   * instance editions.
   * @property {string} [status] The status of the capability. Possible values
   * include: 'Visible', 'Available', 'Default', 'Disabled'
   * @property {string} [reason] The reason for the capability not being
   * available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ManagedInstanceVersionCapability
   *
   * @returns {object} metadata of ManagedInstanceVersionCapability
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedInstanceVersionCapability',
      type: {
        name: 'Composite',
        className: 'ManagedInstanceVersionCapability',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          supportedEditions: {
            required: false,
            readOnly: true,
            serializedName: 'supportedEditions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ManagedInstanceEditionCapabilityElementType',
                  type: {
                    name: 'Composite',
                    className: 'ManagedInstanceEditionCapability'
                  }
              }
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Visible', 'Available', 'Default', 'Disabled' ]
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedInstanceVersionCapability;
