/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A short term retention policy resource.
 *
 * @extends models['ProxyResource']
 */
class ShortTermRetentionPolicy extends models['ProxyResource'] {
  /**
   * Create a ShortTermRetentionPolicy.
   * @member {number} [retentionDays] The backup retention period in days. This
   * is how many days Point-in-Time Restore will be supported.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ShortTermRetentionPolicy
   *
   * @returns {object} metadata of ShortTermRetentionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ShortTermRetentionPolicy',
      type: {
        name: 'Composite',
        className: 'ShortTermRetentionPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          retentionDays: {
            required: false,
            serializedName: 'properties.retentionDays',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ShortTermRetentionPolicy;
