/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An update request for an Azure SQL Database virtual cluster.
 *
 */
class VirtualClusterUpdate {
  /**
   * Create a VirtualClusterUpdate.
   * @property {string} [subnetId] Subnet resource ID for the virtual cluster.
   * @property {string} [family] If the service has different generations of
   * hardware, for the same SKU, then that can be captured here.
   * @property {array} [childResources] List of resources in this virtual
   * cluster.
   * @property {object} [tags] Resource tags.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualClusterUpdate
   *
   * @returns {object} metadata of VirtualClusterUpdate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualClusterUpdate',
      type: {
        name: 'Composite',
        className: 'VirtualClusterUpdate',
        modelProperties: {
          subnetId: {
            required: false,
            readOnly: true,
            serializedName: 'properties.subnetId',
            type: {
              name: 'String'
            }
          },
          family: {
            required: false,
            serializedName: 'properties.family',
            type: {
              name: 'String'
            }
          },
          childResources: {
            required: false,
            readOnly: true,
            serializedName: 'properties.childResources',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualClusterUpdate;
