/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Filters that can be specified on the alert
 *
 */
class AlertFilter {
  /**
   * Create a AlertFilter.
   * @member {string} [status] Status of the alert. Possible values include:
   * 'Active', 'Cleared'
   * @member {string} [severity] Severity of the alert. Possible values
   * include: 'Informational', 'Warning', 'Critical'
   * @member {string} [sourceType] Source of the alert. Possible values
   * include: 'Resource', 'Device'
   * @member {string} [sourceName] Source name of the alert
   * @member {date} [appearedOnTime] UTC time on which the alert appeared
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertFilter
   *
   * @returns {object} metadata of AlertFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AlertFilter',
      type: {
        name: 'Composite',
        className: 'AlertFilter',
        modelProperties: {
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Active', 'Cleared' ]
            }
          },
          severity: {
            required: false,
            serializedName: 'severity',
            type: {
              name: 'Enum',
              allowedValues: [ 'Informational', 'Warning', 'Critical' ]
            }
          },
          sourceType: {
            required: false,
            serializedName: 'sourceType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Resource', 'Device' ]
            }
          },
          sourceName: {
            required: false,
            serializedName: 'sourceName',
            type: {
              name: 'String'
            }
          },
          appearedOnTime: {
            required: false,
            serializedName: 'appearedOnTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AlertFilter;
