/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ErrorModel.
 */
class ErrorModel {
  /**
   * Create a ErrorModel.
   * @member {string} errorCode
   * @member {object} message
   * @member {string} [message.language]
   * @member {string} [message.value]
   * @member {array} [values]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorModel
   *
   * @returns {object} metadata of ErrorModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Error',
      type: {
        name: 'Composite',
        className: 'ErrorModel',
        modelProperties: {
          errorCode: {
            required: true,
            serializedName: 'errorCode',
            type: {
              name: 'String'
            }
          },
          message: {
            required: true,
            serializedName: 'message',
            type: {
              name: 'Composite',
              className: 'Message'
            }
          },
          values: {
            required: false,
            serializedName: 'values',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'Item'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorModel;
