/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Failover request object.
 *
 */
class FailoverRequest {
  /**
   * Create a FailoverRequest.
   * @member {array} [accesspointIds]
   * @member {string} [targetDeviceId]
   * @member {boolean} [skipValidation]
   * @member {boolean} [keepSourceDevice]
   */
  constructor() {
  }

  /**
   * Defines the metadata of FailoverRequest
   *
   * @returns {object} metadata of FailoverRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FailoverRequest',
      type: {
        name: 'Composite',
        className: 'FailoverRequest',
        modelProperties: {
          accesspointIds: {
            required: false,
            serializedName: 'accesspointIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          targetDeviceId: {
            required: false,
            serializedName: 'targetDeviceId',
            type: {
              name: 'String'
            }
          },
          skipValidation: {
            required: false,
            serializedName: 'skipValidation',
            type: {
              name: 'Boolean'
            }
          },
          keepSourceDevice: {
            required: false,
            serializedName: 'keepSourceDevice',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = FailoverRequest;
