/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details related to the IP address configuration
 *
 */
class IPConfig {
  /**
   * Create a IPConfig.
   * @member {string} ipAddress The ipaddress of the network adapter, either
   * ipv4 or ipv6.
   * @member {number} [prefixLength] The prefix length of the network adapter.
   * @member {string} gateway The gateway of the network adapter.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IPConfig
   *
   * @returns {object} metadata of IPConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IPConfig',
      type: {
        name: 'Composite',
        className: 'IPConfig',
        modelProperties: {
          ipAddress: {
            required: true,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          prefixLength: {
            required: false,
            serializedName: 'prefixLength',
            type: {
              name: 'Number'
            }
          },
          gateway: {
            required: true,
            serializedName: 'gateway',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IPConfig;
