/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * class representing the filters to be passed while fetching metrics
 *
 */
class MetricFilter {
  /**
   * Create a MetricFilter.
   * @member {object} [name] filter for name property
   * @member {string} [name.value] The value.
   * @member {date} [startTime] starttime for fetching metrics
   * @member {date} [endTime] endtime for fetching metrics
   * @member {string} [timeGrain] timegrain of the metrics
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricFilter
   *
   * @returns {object} metadata of MetricFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricFilter',
      type: {
        name: 'Composite',
        className: 'MetricFilter',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'MetricNameFilter'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          timeGrain: {
            required: false,
            serializedName: 'timeGrain',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricFilter;
