/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Upload Certificate Request to IDM
 *
 */
class UploadCertificateRequest {
  /**
   * Create a UploadCertificateRequest.
   * @member {string} [authType] Specify the Authentication type. Possible
   * values include: 'Invalid', 'AccessControlService', 'AzureActiveDirectory'
   * @member {string} certificate Gets or sets the base64 encoded certificate
   * raw data string
   * @member {string} [contractVersion] Gets ContractVersion. Possible values
   * include: 'InvalidVersion', 'V2011_09', 'V2012_02', 'V2012_05', 'V2012_12',
   * 'V2013_04', 'V2013_10', 'V2013_11', 'V2014_04', 'V2014_06', 'V2014_07',
   * 'V2014_09', 'V2014_10', 'V2014_12', 'V2015_01', 'V2015_02', 'V2015_04',
   * 'V2015_05', 'V2015_06', 'V2015_07', 'V2015_08', 'V2015_10', 'V2015_12',
   * 'V2016_01', 'V2016_02', 'V2016_04', 'V2016_05', 'V2016_07', 'V2016_08'
   */
  constructor() {
  }

  /**
   * Defines the metadata of UploadCertificateRequest
   *
   * @returns {object} metadata of UploadCertificateRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UploadCertificateRequest',
      type: {
        name: 'Composite',
        className: 'UploadCertificateRequest',
        modelProperties: {
          authType: {
            required: false,
            serializedName: 'properties.authType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'AccessControlService', 'AzureActiveDirectory' ]
            }
          },
          certificate: {
            required: true,
            serializedName: 'properties.certificate',
            type: {
              name: 'String'
            }
          },
          contractVersion: {
            required: false,
            readOnly: true,
            serializedName: 'contractVersion',
            type: {
              name: 'Enum',
              allowedValues: [ 'InvalidVersion', 'V2011_09', 'V2012_02', 'V2012_05', 'V2012_12', 'V2013_04', 'V2013_10', 'V2013_11', 'V2014_04', 'V2014_06', 'V2014_07', 'V2014_09', 'V2014_10', 'V2014_12', 'V2015_01', 'V2015_02', 'V2015_04', 'V2015_05', 'V2015_06', 'V2015_07', 'V2015_08', 'V2015_10', 'V2015_12', 'V2016_01', 'V2016_02', 'V2016_04', 'V2016_05', 'V2016_07', 'V2016_08' ]
            }
          }
        }
      }
    };
  }
}

module.exports = UploadCertificateRequest;
