/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters used when creating a cloud endpoint.
 *
 * @extends models['ProxyResource']
 */
class CloudEndpointCreateParameters extends models['ProxyResource'] {
  /**
   * Create a CloudEndpointCreateParameters.
   * @property {string} [storageAccountResourceId] Storage Account Resource Id
   * @property {string} [azureFileShareName] Azure file share name
   * @property {string} [storageAccountTenantId] Storage Account Tenant Id
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CloudEndpointCreateParameters
   *
   * @returns {object} metadata of CloudEndpointCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CloudEndpointCreateParameters',
      type: {
        name: 'Composite',
        className: 'CloudEndpointCreateParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          storageAccountResourceId: {
            required: false,
            serializedName: 'properties.storageAccountResourceId',
            type: {
              name: 'String'
            }
          },
          azureFileShareName: {
            required: false,
            serializedName: 'properties.azureFileShareName',
            type: {
              name: 'String'
            }
          },
          storageAccountTenantId: {
            required: false,
            serializedName: 'properties.storageAccountTenantId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CloudEndpointCreateParameters;
