/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Files not syncing error object
 *
 */
class FilesNotSyncingError {
  /**
   * Create a FilesNotSyncingError.
   * @property {number} [errorCode] Error code (HResult)
   * @property {number} [persistentCount] Count of persistent files not syncing
   * with the specified error code
   * @property {number} [transientCount] Count of transient files not syncing
   * with the specified error code
   */
  constructor() {
  }

  /**
   * Defines the metadata of FilesNotSyncingError
   *
   * @returns {object} metadata of FilesNotSyncingError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FilesNotSyncingError',
      type: {
        name: 'Composite',
        className: 'FilesNotSyncingError',
        modelProperties: {
          errorCode: {
            required: false,
            readOnly: true,
            serializedName: 'errorCode',
            type: {
              name: 'Number'
            }
          },
          persistentCount: {
            required: false,
            readOnly: true,
            serializedName: 'persistentCount',
            type: {
              name: 'Number'
            }
          },
          transientCount: {
            required: false,
            readOnly: true,
            serializedName: 'transientCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = FilesNotSyncingError;
