/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The parameters used when creating a registered server.
 *
 * @extends models['ProxyResource']
 */
class RegisteredServerCreateParameters extends models['ProxyResource'] {
  /**
   * Create a RegisteredServerCreateParameters.
   * @property {string} [serverCertificate] Registered Server Certificate
   * @property {string} [agentVersion] Registered Server Agent Version
   * @property {string} [serverOSVersion] Registered Server OS Version
   * @property {string} [lastHeartBeat] Registered Server last heart beat
   * @property {string} [serverRole] Registered Server serverRole
   * @property {string} [clusterId] Registered Server clusterId
   * @property {string} [clusterName] Registered Server clusterName
   * @property {string} [serverId] Registered Server serverId
   * @property {string} [friendlyName] Friendly Name
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of RegisteredServerCreateParameters
   *
   * @returns {object} metadata of RegisteredServerCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RegisteredServerCreateParameters',
      type: {
        name: 'Composite',
        className: 'RegisteredServerCreateParameters',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          serverCertificate: {
            required: false,
            serializedName: 'properties.serverCertificate',
            type: {
              name: 'String'
            }
          },
          agentVersion: {
            required: false,
            serializedName: 'properties.agentVersion',
            type: {
              name: 'String'
            }
          },
          serverOSVersion: {
            required: false,
            serializedName: 'properties.serverOSVersion',
            type: {
              name: 'String'
            }
          },
          lastHeartBeat: {
            required: false,
            serializedName: 'properties.lastHeartBeat',
            type: {
              name: 'String'
            }
          },
          serverRole: {
            required: false,
            serializedName: 'properties.serverRole',
            type: {
              name: 'String'
            }
          },
          clusterId: {
            required: false,
            serializedName: 'properties.clusterId',
            type: {
              name: 'String'
            }
          },
          clusterName: {
            required: false,
            serializedName: 'properties.clusterName',
            type: {
              name: 'String'
            }
          },
          serverId: {
            required: false,
            serializedName: 'properties.serverId',
            type: {
              name: 'String'
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = RegisteredServerCreateParameters;
