/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error type
 *
 */
class StorageSyncError {
  /**
   * Create a StorageSyncError.
   * @property {object} [error] Error details of the given entry.
   * @property {string} [error.code] Error code of the given entry.
   * @property {string} [error.message] Error message of the given entry.
   * @property {string} [error.target] Target of the given error entry.
   * @property {object} [error.details] Error details of the given entry.
   * @property {string} [error.details.code] Error code of the given entry.
   * @property {string} [error.details.message] Error message of the given
   * entry.
   * @property {string} [error.details.target] Target of the given entry.
   * @property {object} [innererror] Error details of the given entry.
   * @property {string} [innererror.code] Error code of the given entry.
   * @property {string} [innererror.message] Error message of the given entry.
   * @property {string} [innererror.target] Target of the given error entry.
   * @property {object} [innererror.details] Error details of the given entry.
   * @property {string} [innererror.details.code] Error code of the given
   * entry.
   * @property {string} [innererror.details.message] Error message of the given
   * entry.
   * @property {string} [innererror.details.target] Target of the given entry.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageSyncError
   *
   * @returns {object} metadata of StorageSyncError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageSyncError',
      type: {
        name: 'Composite',
        className: 'StorageSyncError',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'StorageSyncApiError'
            }
          },
          innererror: {
            required: false,
            serializedName: 'innererror',
            type: {
              name: 'Composite',
              className: 'StorageSyncApiError'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageSyncError;
