/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Parameters supplied to the Create or Update Event Source operation.
 *
 * @extends models['CreateOrUpdateTrackedResourceProperties']
 */
class EventSourceCreateOrUpdateParameters extends models['CreateOrUpdateTrackedResourceProperties'] {
  /**
   * Create a EventSourceCreateOrUpdateParameters.
   * @member {string} kind Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EventSourceCreateOrUpdateParameters
   *
   * @returns {object} metadata of EventSourceCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EventSourceCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'CreateOrUpdateTrackedResourceProperties',
        className: 'EventSourceCreateOrUpdateParameters',
        modelProperties: {
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventSourceCreateOrUpdateParameters;
