/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object that represents the offset information for the local timestamp
 * format specified. Should not be specified for LocalTimestampFormat -
 * Embedded.
 *
 */
class LocalTimestampTimeZoneOffset {
  /**
   * Create a LocalTimestampTimeZoneOffset.
   * @member {string} [propertyName] The event property that will be contain
   * the offset information to calculate the local timestamp. When the
   * LocalTimestampFormat is Iana, the property name will contain the name of
   * the column which contains IANA Timezone Name (eg: Americas/Los Angeles).
   * When LocalTimestampFormat is Timespan, it contains the name of property
   * which contains values representing the offset (eg: P1D or 1.00:00:00)
   */
  constructor() {
  }

  /**
   * Defines the metadata of LocalTimestampTimeZoneOffset
   *
   * @returns {object} metadata of LocalTimestampTimeZoneOffset
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocalTimestamp_timeZoneOffset',
      type: {
        name: 'Composite',
        className: 'LocalTimestampTimeZoneOffset',
        modelProperties: {
          propertyName: {
            required: false,
            serializedName: 'propertyName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LocalTimestampTimeZoneOffset;
