/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The sku determines the capacity of the environment, the SLA (in
 * queries-per-minute and total capacity), and the billing rate.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} name The name of this SKU. Possible values include: 'S1',
   * 'S2'
   * @member {number} capacity The capacity of the sku. This value can be
   * changed to support scale out of environments after they have been created.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'S1', 'S2' ]
            }
          },
          capacity: {
            required: true,
            serializedName: 'capacity',
            constraints: {
              InclusiveMaximum: 10,
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
